'use strict';
angular.module('bamboo.class').controller('ClassGalleryListCtrl', function($scope, $stateParams, ApiService) {
  var self = this;
  self.classid = $stateParams.classid;
  console.log($stateParams);
  self.imgBaseUrl = ApiService.SHOST + '/advinfo/';

  function getInfo() {
    var info = {
      limit: Number.MAX_SAFE_INTEGER,
      start: 0,
      cid: self.classid,
      type: 'class',
      action: "getalbums"
    };

    console.log(info);
    ApiService.post("/advinfo", info).then(function(result) {
      console.log(result.data.data);
      if (result.data.success) {
        console.log(result.data.data);
        self.items = result.data.data.items;
        self.totalCount = result.data.data.counter;
        $scope.totalCount = result.data.data.counter;
      }
    });
  }
  getInfo();

});