angular.module('bamboo').service('CoursewareService', function($q, loginService, ApiService) {
  var vm = this;
  vm.checkresult = checkresult;

  function checkresult(chapter, questions, _historydetail, views, _last_rid) {
    //  console.log(questions);
    var correct = 0;
    var wrong = 0;
    for (var i = 0; i < questions.length; i += 1) {
      var q = questions[i];
      checkQResult(q);
      if (q.judgement == 'Correct') {
        correct++;
      } else {
        wrong++;
      }
    }
  }

  function checkQResult(q) {
    switch (q.type) {
      case 'single':
        // console.log(q)
        angular.forEach(q._options, function(opt, index) {
          // console.log(opt);
          // console.log(index);
          if (opt.correct && index == q.select) {
            q.judgement = 'Correct';
            q.selection = opt.text;
            console.log('correct');
          }
        })
        if (q.judgement != 'Correct') {
          if (q.select || q.select == 0) {
            q.judgement = 'Wrong';
            q.selection = q._options[q.select].text;
          } else {
            q.judgement = 'Not Attempted';
          }
        }
        break;
      case 'multiple':
        var opts = q._options;
        console.log("--------multiple---------");
        // console.log(opts);
        var _selected = 0;
        var _correct = true;
        for (var j = 0; j < opts.length; j += 1) {
          var opt = opts[j];
          console.log(opt);
          if (opt.selection) {
            _selected++;
          }
          if ((opt.selection && opt.correct) || (!opt.selection && !opt.correct)) {} else {
            _correct = false;
            console.log('wrong selection');
          }
        }
        console.log(_selected);
        console.log(_correct);
        if (_selected) {
          if (_correct) {
            q.judgement = 'Correct';
          } else {
            q.judgement = 'Wrong';
          }
        } else {
          q.judgement = 'Not Attempted';
        }
        break;
      case 'tof':
        console.log("--------tof---------");
        console.log(q);
        q.tof_answer = q._options[0] && q._options[0].correct;
        if (!q.selection&&q.selection!==false) {
          q.judgement = 'Not Attempted';
        } else if (q.selection == true && q.tof_answer) {
          q.judgement = 'Correct';
        } else if (q.selection == false && q.tof_answer ==false) {
          q.judgement = 'Correct';
        } else {
          q.judgement = 'Wrong';
        }
        break;
      case 'fill':
      case 'mfill':
        console.log(q);
        var opts = q._options;
        console.log("---------M Fills--------");
        // console.log(opts);
        q.judgement = 'Correct';
        var _selected = 0;
        var _correct = true;
        for (var j = 0; j < opts.length; j += 1) {
          var opt = opts[j];
          if (opt.selection) {
            _selected++;
            var _result = false;
            for (var n = 0; n < opt.texts.length; n++) {
              if (opt.selection == opt.texts[n].text) {
                _result = true;;
                break;
              }
            }
            if (_result) {} else {
              _correct = false;
              console.log(opt);
            }
          } else {
            _correct = false;
          }
        }
        if (_selected) {
          if (_correct) {
            q.judgement = 'Correct';
          } else {
            q.judgement = 'Wrong';
          }
        } else {
          q.judgement = 'Not Attempted';
        }
        break;
    }
    return q;
  }

});