angular.module('bamboo.company', ['ionic']).config(function($stateProvider, $urlRouterProvider) {
  $stateProvider
  .state('app.company', {
    url: '/company',
    views: {
      'Content': {
        templateUrl: 'app/company/category.html',
        controller: "CompanyCategoryCtrl as ctrl"
      }
    }
  }).state('app.company.list', {
    url: '/list/:key',
    views: {
      'Content@app': {
        templateUrl: 'app/company/list.html',
        controller: "CompanyListInCategoryCtrl as ctrl"
      }
    }
  }).state('app.company.list.detail', {
    url: '/detail/:cid',
    views: {
      'Content@app': {
        templateUrl: 'app/company/detail.html',
        controller: "CompanyItemCtrl as cctrl"
      }
    }
  }).state('app.company.list.detail.map', {
    url: '/map',
    views: {
      'Content@app': {
        templateUrl: 'app/company/map.html',
        controller: "CompanyItemCtrl as cctrl"
      }
    }
  })
});