angular.module('bamboo.config').controller('ConfigCtrl', function($scope, $window, ServerLists, $translate,AppConfig, $state, CommonService, ApiService, loginService, $localstorage,  $timeout,$ionicHistory) {
  var _self = this;
  //  CommonService.showInfo("news controller");
  console.log("---- config -----");
  _self.defaultClaimer = 'THE SERVICE OFFERINGS ARE PROVIDED “AS IS.” WE AND OUR AFFILIATES AND LICENSORS MAKE NO REPRESENTATIONS OR WARRANTIES OF ANY KIND, WHETHER EXPRESS, IMPLIED, STATUTORY OR OTHERWISE REGARDING THE SERVICE OFFERINGS OR THE THIRD PARTY CONTENT, INCLUDING ANY WARRANTY THAT THE SERVICE OFFERINGS OR THIRD PARTY CONTENT WILL BE UNINTERRUPTED, ERROR FREE OR FREE OF HARMFUL COMPONENTS, OR THAT ANY CONTENT, INCLUDING YOUR CONTENT OR THE THIRD PARTY CONTENT, WILL BE SECURE OR NOT OTHERWISE LOST OR DAMAGED. EXCEPT TO THE EXTENT PROHIBITED BY LAW, WE AND OUR AFFILIATES AND LICENSORS DISCLAIM ALL WARRANTIES, INCLUDING ANY IMPLIED WARRANTIES OF MERCHANTABILITY, SATISFACTORY QUALITY, FITNESS FOR A PARTICULAR PURPOSE, NON-INFRINGEMENT, OR QUIET ENJOYMENT, AND ANY WARRANTIES ARISING OUT OF ANY COURSE OF DEALING OR USAGE OF TRADE.';
  this.subdomain = $localstorage.get('subdomain');
  this.imgPath = ApiService.PSURL + "/avatar/";
  this.role=AppConfig.Role;
  $scope.isChecked = false;
  // this.lan = $localstorage.get('language');
  this.lan = 'en';
  if($translate.use()=='Chinese') {
    this.lan = 'cn';
  }
  console.log(this.lan);
  if(ApiService.school){
    this.schoolName=ApiService.school.name;
  }
  if (this.subdomain) {
    ApiService.getSchoolInfo().then(function() {
      if (ApiService.school.agreementdoc) {
        //CommonService.showLoading();
        ApiService.get("/settingdoc/" + ApiService.school.agreementdoc).then(function(result) {
          //CommonService.stopLoading();
          if (result.data.success) {
            var value = result.data.data;
            if (!_self.lan) {
              _self.lan = 'en';
            }
            if (_self.lan == 'en') {
              _self.schoolServiceAgreement = value.detail
            } else if (_self.lan == 'cn') {
              _self.schoolServiceAgreement = value.chinese
            } else {
              _self.schoolServiceAgreement = _self.defaultClaimer;
            }
          }
        })
      }
      if (ApiService.school.mobilephoto) {
        $scope.mobilephoto = ApiService.SHOST + "/site/" + ApiService.school.mobilephoto;
      } else {
        $scope.mobilephoto = 'img/splash_img.png';
      }
    }, function() {
      $state.go('app.config.login');
    });
  }
  this.username = $localstorage.get('username');
  this.password = $localstorage.get('password');


  console.log(this.username);
  console.log(this.password);

  console.log(this.lan);
  this.lanText = this.lan;
  this.userData = false;
  this.updatelan = function() {
    console.log(" -- update lan");
    if (_self.lan) {
      console.log("--- save language");
      $localstorage.set('language', _self.lan);
      console.log(_self.lan);
      $translate.use(_self.lan);
      // $state.go('^');
      $ionicHistory.goBack();
    }
  };

  if (!_self.lan) {
    _self.lan = 'en';
  }

  if (_self.lan == 'en') {
    _self.lanText = 'English'
  } else if (_self.lan == 'cn') {
    _self.lanText = 'Chinese'
  }
  this.logout = function() {
    console.log('logout')
    $localstorage.removeItem('username');
    $localstorage.removeItem('password');
    loginService.logout();
    $timeout(function(){
      $state.go('app.config.login');
    },500)
  };

  this.logoutFromSettings = function() {
    $localstorage.removeItem('username');
    $localstorage.removeItem('password');
    loginService.logout();
  };

  _self.userData = _self.username && _self.password;
  console.log(_self.userData);
  function getProfileDetails(){
    ApiService.get('/profile/').then(function(result) {
      console.log(result);
      if (result.data.success) {
        _self.userDetails = JSON.parse(JSON.stringify(result.data.data));
        console.log(_self.userDetails);
      }
    });
  }
  if($state.current.name!='app.config.language'){
    getProfileDetails();
  }
});
