angular.module('bamboo.config').controller('DomainCtrl', function($scope, $window, ServerLists, $translate, AppConfig, $state, CommonService, DomainLists, ApiService, loginService, $localstorage, $ionicPopup) {
  var self = this;
  // CommonService.showInfo("AdvanceDomainCtrl");
  console.log("DomainCtrl");
  this.subdomain = $localstorage.get('subdomain');
  if (!$localstorage.get('site')) {
    $localstorage.set('site', 'sgedushare');
  }
  this.serverInfo;
  this.siteInfo;
  this.checkServers = function() {
    //console.log("checkServers");
    self.serverInfo = null;
    self.siteInfo = null;
    var pos = self.fulldomain.indexOf('//');
    if (pos > 0) {
      self.fulldomain = self.fulldomain.substring(pos + 2);
    }
    self.fulldomain = self.fulldomain.toLowerCase();
    if (self.fulldomain) {
      if (DomainLists[self.fulldomain]) {
        var domaininfo = DomainLists[self.fulldomain];
        console.log(domaininfo);
        self.serverInfo = {
          HINT: domaininfo.HINT,
          Country: ServerLists[domaininfo.server].Country,
          //info:ServerLists[domaininfo.server],
          subdomain: domaininfo.SUBDOMAIN,
          server: domaininfo.server,
        }
        console.log(self.serverInfo);
      } else {
        //  console.log(self.fulldomain);
        if (self.fulldomain.endsWith('sgedushare.com')) {
          console.log('sgedushare.com');
          // self.sitekey = "sgedushare";
          var subdomain = self.fulldomain.substring(0, self.fulldomain.length - 15);
          if (subdomain.length > 1) {
            self.serverInfo = {
              HINT: "Bamboo Cloud Singapore",
              Country: "Singapore",
              subdomain: subdomain,
              server: 'sgedushare',
            }
          }
          // console.log(self.siteInfo);
          // self.
        } else if (self.fulldomain.endsWith('bamboostudy.com')) {
          console.log('bamboostudy.com');
          var subdomain = self.fulldomain.substring(0, self.fulldomain.length - 16);
          if (subdomain.length > 1) {
            self.serverInfo = {
              HINT: "Bamboo Cloud Singapore",
              Country: "Singapore",
              subdomain: subdomain,
              server: 'bamboobeijing',
            }
          }
        } else if (self.fulldomain.endsWith('wdbamboo.com')) {
          console.log('wdbamboo.com');
          var subdomain = self.fulldomain.substring(0, self.fulldomain.length - 13);
          if (subdomain.length > 1) {
            self.serverInfo = {
              HINT: "Weidong Bamboo Cloud",
              Country: "China",
              subdomain: subdomain,
              server: 'wdbamboo',
            }
          }
        } else if (self.fulldomain.endsWith('witonclass.com')) {
          console.log('witonclass.com');
          var subdomain = self.fulldomain.substring(0, self.fulldomain.length - 15);
          if (subdomain.length > 1) {
            self.serverInfo = {
              HINT: "Weidong Witon Class",
              Country: "China",
              subdomain: subdomain,
              server: 'witon',
            }
          }
        } else if (self.fulldomain.endsWith('bamboolms.com')) {
          console.log('bamboolms.com');
          var subdomain = self.fulldomain.substring(0, self.fulldomain.length - 14);
          if (subdomain.length > 1) {
            self.serverInfo = {
              HINT: "Bamboo Beta Singapore",
              Country: "Singapore",
              subdomain: subdomain,
              server: 'bamboolms',
            }
          }
        }
      }
    }
  }
  if (this.subdomain) {
    var site = $localstorage.get('site');
    var SITEINFO = ServerLists[site]
    //  console.log(SITEINFO);
    if (SITEINFO) {
      if (SITEINFO.FULLDOMAIN) {
        this.fulldomain = SITEINFO.FULLDOMAIN;
        console.log("--1", SITEINFO.FULLDOMAIN);;
        self.checkServers();
      } else {
        this.fulldomain = this.subdomain + "." + SITEINFO.MAINDOMAIN;
        console.log("--2");;
        self.checkServers();
      }
    }
  }
  this.selectSite = function() {
    self.subdomain = self.serverInfo.subdomain;
    self.sitekey = self.serverInfo.server;
    self.updatekey();
  }
  this.role = AppConfig.Role;
  this.updatekey = function() {
    console.log(" -- update key");
    console.log(self.sitekey);
    console.log(self.subdomain);
    if (self.subdomain && self.subdomain.length > 1) {
      // CommonService.showInfo('Loading...');
      // CommonService.showLoading();
      showLoadingDlg();
      self.subdomain = self.subdomain.toLowerCase();
      ApiService.initConstant(self.sitekey);
      loginService.logout(true);
      ApiService.getSchoolInfo(self.subdomain.toLowerCase()).then(function(school) {
        CommonService.stopLoading();
        if (!school.mobileApp) {
          CommonService.showError("Mobile login is not allowed ,please contact administrator!");
        } else {
          $localstorage.set('subdomain', self.subdomain);
          $localstorage.set('groupid', school._id);
          $localstorage.set('site', self.sitekey);
          loginService.getLoginInfo(true);
          ApiService.initConstant(self.sitekey);
          // $state.go('app.config.login');
          //   $localstorage.set('redirect', 'app.config.login');
          $localstorage.set('redirect', 'app.config.login');
          $localstorage.set('role', AppConfig.Role);
          $window.location.reload(true);
          //  console.log(school);
          console.log("--- save subdomain");
        }
      }, function(err) {
        // CommonService.stopLoading();
        console.log(err);
        CommonService.showError("Wrong School address! Please check.");
      });
      // $localstorage.set('subdomain', self.subdomain);
    } else {
      console.log('invalid subdomain');
      CommonService.showError("Wrong School address! Please check.");
    }
  }
  this.redirect = $localstorage.get('redirect');
  console.log(self.redirect);
  if (this.redirect) {
    $localstorage.removeItem('redirect');
    loginService.getLoginInfo(true);
    var role = $localstorage.get('role');
    if (role) {
      AppConfig.Role = role;
      // $localstorage.removeItem('role');
    }
    console.log(self.redirect);
    $state.go(self.redirect);
    return;
  }
  console.log("----");

  function showLoadingDlg() {
    var myPopup = $ionicPopup.show({
      template: '<img src="./img/loading.gif" width="100" /><p translate>Connecting School</p>',
      // title: $translate.instant('Connecting School'),
      cssClass: 'my-custom-popup',
      // subTitle: 'Please use normal things',
      scope: $scope,
      // buttons: [
      //   { text: 'Cancel' },
      //   {
      //     text: '<b>Save</b>',
      //     type: 'button-positive',
      //     onTap: function(e) {
      //       if (!$scope.data.wifi) {
      //         //don't allow the user to close unless he enters wifi password
      //         e.preventDefault();
      //       } else {
      //         return $scope.data.wifi;
      //       }
      //     }
      //   }
      // ]
    });
    myPopup.then(function(res) {
      console.log('Tapped!', res);
    });
  }
});