angular.module('bamboo.config').controller('DownloadCtrl', function(ApiService, $state, $cordovaDevice, CommonService) {
  var self = this;
  var school = this.school = ApiService.school;
  this.alreadyLatest = false;
  var android = false;
  this.os = 'android';
  this.apkUrl = ApiService.SHOST + "/apk/";
  console.log('download')
  if (window.cordova) {
    console.log("device");
    var _platform = $cordovaDevice.platform;
    cordova.getAppVersion.getVersionNumber().then(function(version) {
      console.log("current software version", version);
      self.version = version;
      if (school.eduAppVers) {
        if (_platform && _platform.indexOf('Android') > -1) {
          android = true;
          self.os = 'android'
          if (school.eduAppVers.androidLatestVer) {
            var result = ApiService.compareVersion(school.eduAppVers.androidLatestVer, version);
            console.log(result);
            if (result) {
              getLatestVersion();
            } else {
              self.alreadyLatest = true;
            }
          }
        } else {
          if (school.eduAppVers.iosLatestVer) {
            var result = ApiService.compareVersion(school.eduAppVers.iosLatestVer, version);
            console.log(result);
            if (result) {} else {
              self.alreadyLatest = true;
            }
          }
        }
      }
    });
  } else {
    console.log("host");
    var version = this.version = '1.0.1';
    self.os = 'android';
    if (school.eduAppVers&&school.eduAppVers.iosLatestVer) {
      var result = ApiService.compareVersion(school.eduAppVers.iosLatestVer, version);
      console.log(result);
      if (result) {
        self.alreadyLatest = false;
        getLatestVersion();
      } else {
        self.alreadyLatest = true;
      }


    }
  }

  function getLatestVersion() {
    var info = {
      action: 'getLastestBiary',
      os: self.os,
      product:'edu',
    }
    console.log(info);
    ApiService.post('/logs', info).then(function(result) {
      if (result.data.success) {
        console.log(result.data.data);
        self.record = result.data.data;
      }
    });
  }
  this.openiOS = function() {
    CommonService.showInfo('请通过应用商店下载最新版本', function() {});
  }
  this.openDownloadLink = function() {
    var link = self.apkUrl + self.record.file;
    console.log(link);

    CommonService.showInfo('下载完成后，请点击安装！', function() {
      window.open(encodeURI(link), "_system");
    });

  }
});