angular.module('bamboo.config').controller('ForgetPasswordCtrl', function ($translate,  $stateParams,$interval,  $rootScope,$ionicHistory,$filter,loginService,AppConfig, $scope, $state, CommonService, ApiService, $localstorage) {
    var self = this;
    CommonService.stopLoading();
    this.username = $stateParams.card;
    this.password = $localstorage.get('password');
    this.lan = $localstorage.get('language');
    this.subdomain = $localstorage.get('subdomain');
    this.stage = 'asktoken';
    //this.stage = 'submit';
    this.isverifycode = false;
    $scope.submitted = false;
    this.verify = function () {
        var info = {
            action: 'getLoginSMSToken',
            name: self.username,
        }
        console.log();
        ApiService.post('/messages', info).then(function (result) {
            console.log(result);
            if (result.data.success && result.data.data && result.data.data.mobile) {
                self.mobile = result.data.data.mobile;
                var displayNumber = self.mobile.substring(0, 3) + "xxxx" + self.mobile.substring(self.mobile.length - 4);
                console.log(result.data);
                CommonService.showInfo("验证码已经发送至手机"+ displayNumber + "!", function (res) {
                    self.stage = 'submit';
                    if (self.isverifycode == false) {
                        self.isverifycode = true;
                        self.isCheck = true;
                        var totalSecond = 59; //设置计时总时间（分钟）
                        //倒计时
                        self.timePromise = $interval(function() {
                            $scope.CountDown = true;
                            if (totalSecond >= 0) {
                                var s = totalSecond < 10 ? "0" + totalSecond : totalSecond;
                                totalSecond = totalSecond - 1;
                                $scope.payCountDown = s + "秒";
                                console.log($scope.payCountDown);
                            } else {
                                self.isverifycode = false;
                                $scope.payCountDown = "发送验证码";
                                $interval.cancel(self.timePromise); //终止倒计时
                            }
                        }, 1000);
                    }
                });
            } else {
              if(result.data.error=="error: Mobile not set!"){
                CommonService.showInfo("手机号没有设置！");
              }else if(result.data.error=="error: No record!"){
                CommonService.showInfo("没有记录！");
              }

            }
        });
    }


    this.sendCode = function() {
        var info = {
            action: 'getLoginSMSToken',
            name: self.username,
        }
        ApiService.post('/messages', info).then(function(result) {
            console.log(result);
            if (result.data.success) {
                console.log("OK..");
                if (self.isverifycode == false) {
                    self.isverifycode = true;
                    //var totalSecond = 59; //设置计时总时间（分钟）
                    var totalSecond = 10; //设置计时总时间（分钟）
                    //倒计时
                    self.timePromise = $interval(function() {
                        $scope.CountDown = true;
                        if (totalSecond >= 0) {
                            var s = totalSecond < 10 ? "0" + totalSecond : totalSecond;
                            totalSecond = totalSecond - 1;
                            $scope.payCountDown = s + "秒";
                            console.log($scope.payCountDown);
                        } else {
                            self.isverifycode = false;
                            $scope.payCountDown = "验证";
                            $interval.cancel(self.timePromise); //终止倒计时
                        }
                    }, 1000);
                }
            } else {
                if(result.data.error=="error: No record!"){
                    CommonService.showInfo("没有记录！");
                }else{
                    CommonService.showError(result.data.error)
                }

            }
        });
    }
    this.passwordInfo = {}
    this.resetpassword = function (form) {
        $scope.submitted=true;
        console.log(form);
        if (form.$invalid) {
            return;
        }
        var info = self.passwordInfo;
        if (info.pass.length < 6) {
            CommonService.showError("输入的密码不得少于6个字符！");
            return;
        }
        if (info.re_pass.length < 6) {
            CommonService.showError("输入的确认密码不得少于6个字符！");
            return;
        }
        if (info.pass != info.re_pass) {
            CommonService.showError("两次输入密码不一致，请确认输入的密码!");
            return;
        }

        info.name = self.username;
        console.log(info);
        ApiService.post('/smssetpassword', info).then(function (result) {
            console.log(result)
            $scope.code = result;
            if (result.data.success) {
                 CommonService.showInfo("请用新密码登录！",function(){
                     $state.go('app.config.login', {}, {
                         reload: true,
                         inherit: false
                     });
                 });

            }else {
                CommonService.showInfo("验证码有误请重新输入！！");
                return;
            }
        });


    };
});
