angular.module('bamboo.config').controller('SchoolSelectCtrl', function($scope, DomainLists, $window, ServerLists, $translate, AppConfig, $state, $timeout, CommonService, ApiService, loginService, $localstorage,$ionicHistory, $ionicPopup) {
  var _self = this;
  this.role = AppConfig.Role;
  this.sitelist = [];
  this.serverlist = DomainLists;
  _self.country = 'Singapore';
  angular.forEach(DomainLists, function(val, key) {
    //console.log(key);
    val.key = key;
    if (val.list) {
      _self.sitelist.push(val);
    }
  });
  this.redirect = $localstorage.get('redirect');
  if (this.redirect) {
    $localstorage.removeItem('redirect');
    loginService.getLoginInfo(true);
    var role = $localstorage.get('role');
    if (role) {
      AppConfig.Role = role;
      // $localstorage.removeItem('role');
    }
    $state.go(this.redirect);
  }
  this.selectSite = function(item) {
    console.log(item);
    _self.subdomain = item.SUBDOMAIN;
    _self.sitekey = item.server;
    // showLoadingDlg();
    _self.updatekey();
  }
  this.updatekey = function() {
    console.log(" -- update key");
    if (_self.currentkey) {
      _self.sitekey = _self.currentkey;
    }
    console.log(_self.subdomain);
    if (_self.subdomain && _self.subdomain.length > 1) {
      // CommonService.showInfo('Loading...');
      CommonService.showLoading();
      _self.subdomain = _self.subdomain.toLowerCase();
      ApiService.initConstant(_self.sitekey);
      loginService.logout(true);
      ApiService.getSchoolInfo(_self.subdomain.toLowerCase(), true).then(function(school) {
        CommonService.stopLoading();
        $localstorage.set('subdomain', _self.subdomain);
        $localstorage.set('groupid', school._id);
        $localstorage.set('site', _self.sitekey);
        $localstorage.set('serverlist', 'normal');
        ApiService.initConstant(_self.sitekey);
        loginService.getLoginInfo(true);
        loginService.changeDomain();
        // $state.go('app.config.login');
        //   $localstorage.set('redirect', 'app.config.login');
        // $localstorage.set('redirect', 'app.config.login');
        $localstorage.set('role', AppConfig.Role);
        // $window.location.reload(true);
        // $timeout(function() {
        //   $window.location.reload(true);
        // });
        //  console.log(school);
        // $localstorage.removeItem('redirect');
        loginService.getLoginInfo(true);
        $ionicHistory.clearCache().then(function() {
          $state.go('app.config.login', {}, {
            reload: true,
            inherit: false
          });
        })
        // $timeout(function() {
        //  // stopLoading();
        //   $state.go('app.config.login',{},{reload:true});
        // });
        console.log("--- save subdomain");
      }, function(err) {
        CommonService.stopLoading();
        console.log(err);
        CommonService.showError("Wrong School address! Please check.");
      });
    }
  };
  var myPopup;
  // function showLoadingDlg() {
  //   myPopup = $ionicPopup.show({
  //     template: '<img src="./img/loading.gif" width="100" /><p translate>Connecting School</p>',
  //     // title: $translate.instant('Connecting School'),
  //     cssClass: 'my-custom-popup',
  //     scope: $scope,
  //   });
  //   myPopup.then(function(res) {
  //     console.log('Tapped!', res);
  //   });
  // }
  // function stopLoading(){
  //   if(myPopup){
  //     myPopup.close();
  //   }
  // }
});