angular.module('bamboo.config').controller('ConfigTermCtrl', function($scope, $window, ServerLists, $translate, AppConfig, $state, CommonService, ApiService, loginService, $localstorage, $timeout, $ionicHistory) {
  var _self = this;
  //  CommonService.showInfo("news controller");
  console.log("---- config -----");
  this.subdomain = $localstorage.get('subdomain');
  this.imgPath = ApiService.PSURL + "/avatar/";
  this.role = AppConfig.Role;
  $scope.isChecked = false;
  // this.lan = $localstorage.get('language');
  this.lan = 'en';
  if ($translate.use() == 'Chinese') {
    this.lan = 'cn';
  }
  console.log(this.lan);
  ApiService.getSchoolInfo().then(function() {
    if (ApiService.school.agreementdoc) {
      //CommonService.showLoading();
      ApiService.get("/settingdoc/" + ApiService.school.agreementdoc).then(function(result) {
        //CommonService.stopLoading();
        if (result.data.success) {
          var value = result.data.data;
          if (!_self.lan) {
            _self.lan = 'en';
          }
          if (_self.lan == 'en') {
            _self.schoolServiceAgreement = value.detail
          } else if (_self.lan == 'cn') {
            _self.schoolServiceAgreement = value.chinese
          } else {
            _self.schoolServiceAgreement = _self.defaultClaimer;
          }
        }
      })
    }
    if (ApiService.school.mobilephoto) {
      $scope.mobilephoto = ApiService.SHOST + "/site/" + ApiService.school.mobilephoto;
    } else {
      $scope.mobilephoto = 'img/splash_img.png';
    }
  }, function() {
    $state.go('app.config.login');
  });
});