angular.module('bamboo.config').controller('UpdateProfileCtrl', function($scope,$stateParams, $window, ServerLists, $translate, $state, CommonService, ApiService, loginService, $ionicHistory,$ionicNavBarDelegate, $ionicModal,$timeout, $filter) {
  var _self = this;
  this.isShowModel = false;
  this.isMobile = false;
  this.imageFile = '';
  this.subtab = 0;
  this.backShow=$stateParams.backShow;
  var uploadSetting = {
    image: true,
    promise: true,
    s3: true,
    title: "User Avatar",
    maxSize: 80,
    ctrl: _self,
    id: null, //_self.contentModel.id,
    resPath: null,
    imageUrl: null,
    action: "avatar"
  };
  this.cardTypes = ['中国居民身份证', '中国港澳身份证件', '中国台湾身份证件', '中国港澳居民居住证', '中国台湾居民居住证', '其它'];
  this.gender = ["Male", "Female"];
  this.RaceList = ["汉族", "满族", "蒙古族", "回族", "藏族", "维吾尔族", "苗族", "彝族", "壮族", "布依族", "侗族", "瑶族", "白族", "土家族", "哈尼族", "哈萨克族", "傣族", "黎族", "傈僳族", "佤族", "畲族", "高山族", "拉祜族", "水族", "东乡族", "纳西族", "景颇族", "族柯尔克孜族", "土族", "达斡尔族", "仫佬族", "羌族", "布朗族", "撒拉族", "毛南族", "仡佬族", "锡伯族", "阿昌族", "普米族", "朝鲜族", "塔吉克族", "怒族", "族乌孜别克族", "俄罗斯族", "鄂温克族", "德昂族", "保安族", "裕固族", "京族", "塔塔尔族", "独龙族", "鄂伦春族", "赫哲族", "门巴族", "珞巴族", "基诺族"];
  this.TrainingTypeList = ['道路旅客运输驾驶员', '道路货物运输驾驶员', '道路危险货物运输驾驶员', '城市公共汽电车驾驶员', '车主', '安全员', '出租车驾驶员', '其他'];
  this.TypeList = [];
  this.provinceList = ["安徽省", "北京市", "福建省", "甘肃省", "广东省", "广西壮族自治区", "贵州省", "海南省", "河北省", "河南省", "黑龙江省", "湖北省", "湖南省", "吉林省", "江苏省", "江西省", "辽宁省", "内蒙古自治区", "宁夏回族自治区", "青海省", "山东省", "山西省", "陕西省", "上海市", "四川省", "天津市", "西藏自治区", "新疆维吾尔自治区", "云南省", "浙江省", "重庆市"];

  angular.forEach(_self.TrainingTypeList, function(item, index) {
    var info = {
      name: item,
      id: index + 1
    }
    _self.TypeList.push(info);
  })

  //console.log($ionicHistory.backView().stateName);
  function checkBack(){
    console.log('go back');
    var result = checkInfoComplete();
    if (result) {
      $ionicNavBarDelegate.showBackButton(false);
     // return CommonService.showInfo(result);

    }else{

    }
   // $ionicHistory.goBack();
  }

  this.goBack =  function() {
    $ionicHistory.goBack();
  }

  this.jobTypes = ['企业在岗', '个体经营'];
  this.driveTypes = ['A1', 'A2', 'A3', 'B1', 'B2', 'C1', 'C2', 'C3', 'C4', 'C5', 'D', 'E', 'F', 'M', 'N', 'P'];
  this.cyryTypes = {
    '道路旅客运输': ['经营性道路旅客运输驾驶员'],
    '道路货物运输': ['经营性道路货物运输驾驶员'],
    '道路危险货物运输': ["道路危险货物运输驾驶员", "道路危险货物运输押运人员", "道路危险货物运输装卸管理人员", "剧毒化学品道路运输驾驶员", "剧毒化学品道路运输装卸管理人员", "剧毒化学品道路运输押运人员", "爆炸品道路运输驾驶员", "爆炸品道路运输装卸管理人员", "爆炸品道路运输押运人员"],
    '出租汽车运输': ['出租汽车驾驶员', '网约车驾驶员'],
    '放射品性物品道路运输': ["放射品性物品道路运输驾驶员", "放射性物品道路运输押运人员", "放射性物品道路运输装卸管理人员"]
  }
  this.cyryList=[];
  for(var key in _self.cyryTypes){
    var values=_self.cyryTypes[key];
    angular.forEach(values,function(item){
      var _i={
        type:key,
        ctype:item,
      }
      _self.cyryList.push(_i);
    })
  }
  console.log(this.TypeList);
  this.imgPath = ApiService.PSURL + "/avatar/";
  this.changeCity = function() {
    _self.tmpUser.district = null;
  }
  ApiService.get('/profile/').then(function(result) {
    // console.log(result);
    if (result.data.success) {
      $scope.user = result.data.data;
      if ($scope.user.comId) {
        ApiService.post('/company', {
          action: "getCompany",
          id: $scope.user.comId,
        }).then(function(result) {
          if (result.data.success && result.data.data) {
            $scope.user.companyName = _self.tmpUser.companyName = result.data.data.name;
            console.log($scope.user);
          }
        });
      }
      console.log($scope.user);
      _self.tmpUser = JSON.parse(JSON.stringify(result.data.data));
      if (!_self.tmpUser.province || _self.tmpUser.province == '广东省') {
        _self.tmpUser.province = '广东';
      }

      if (!_self.tmpUser.busitype) {
        _self.tmpUser.busitype = '企业在岗';
      }
      _self.tmpUser.birthday = _self.tmpUser.birthday ? new Date(_self.tmpUser.birthday) : null;
      $scope.phone = _self.tmpUser.mobile;
      if (_self.tmpUser.enrol) {
        _self.tmpUser.enrol = new Date(_self.tmpUser.enrol);
      }
      if(_self.tmpUser.city){
        _self.tmpUser.city=_self.tmpUser.city;
      }
      if (_self.tmpUser.safeCertExpired) {
        _self.tmpUser.safeCertExpired = new Date(_self.tmpUser.safeCertExpired);
      }
      if (_self.tmpUser.birthday) {
        _self.tmpUser.birthday = new Date(_self.tmpUser.birthday);
      }
      if (_self.tmpUser.licensExpire) {
        _self.tmpUser.licensExpire = new Date(_self.tmpUser.licensExpire);
      }
      if (_self.tmpUser.drivingLicenseExpire) {
        _self.tmpUser.drivingLicenseExpire = new Date(_self.tmpUser.drivingLicenseExpire);
      }
      _self.changeDriverType();
      checkBack();
      uploadSetting.id = $scope.user.id;
      uploadSetting.resPath = "public/" + ApiService.RES + "/avatar/" + uploadSetting.id + "/";
      if ($scope.user.avatar) {
        uploadSetting.imageUrl = ApiService.SHOST + "/" + uploadSetting.resPath + $scope.user.avatar;
      }
    }
  });
  var companyPage = 0;

  function getValidCompanys() {
    var info = {
      action: "getSystemCompanys",
      start: companyPage * 6,
      limit: 6,
    }
    if (_self.q) {
      info.search = {
        name: _self.q
      }
    }
    console.log(info);
    CommonService.showLoading();
    ApiService.post("/business", info).then(function(result) {
      if (result.data.success) {
        console.log(result.data.data);
        if (companyPage == 0) {
          _self.companys = result.data.data.items;
        } else {
          _self.companys = _self.companys.concat(result.data.data.items);
        }
        _self.totalCompanys = result.data.data.counter;
        _self.moreData = ((_self.totalCompanys - _self.companys.length) > 0);
        console.log(_self.totalCompanys, _self.companys.length, _self.moreData);
      };
      $timeout(CommonService.stopLoading,100);
     // CommonService.stopLoading();
    });
  }
  this.nextPage = function() {
    companyPage++;
    console.log("--next page --");
    getValidCompanys();
  }
  this.selectCompany = function(company) {
    console.log(company)
    // _self.companys=[];
    _self.tmpUser.comId = company._id;
    _self.tmpUser.companyName = company.name;
   // _self.tmpUser.city = company.city;
   // _self.tmpUser.district = company.district;
    $scope.modal.hide();
  }
  this.searchCompanyName = function() {
    console.log(_self.q)
    // _self.companys=[];
    companyPage = 0;
    getValidCompanys();
  }
  this.changeCompany = function() {
    companyPage = 0;
    $ionicModal.fromTemplateUrl('app/config/changecompany.html', {
      scope: $scope
    }).then(function(modal) {
      $scope.modal = modal;
      $scope.modal.show();
      if (!_self.companys) {
        getValidCompanys();
      }
    });
    $scope.closeModal = function() {
      $scope.modal.hide();
    }
  }
  this.changeDriveTypeFunction = function() {
    $ionicModal.fromTemplateUrl('app/config/changedrivertype.html', {
      scope: $scope
    }).then(function(modal) {
      $scope.modal = modal;
      $scope.modal.show();
      _self.userDriveType = {};
      if (_self.tmpUser.drivingType) {
        var _types = _self.tmpUser.drivingType.split('、');
        angular.forEach(_types, function(item) {
          _self.userDriveType[item] = true;
        })
      }
    });
  }
  this.closeDriveTypeModal = function() {
    $scope.modal.hide();
    var _types = [];
    for (var key in _self.userDriveType) {
      if (_self.userDriveType[key]) {
        _types.push(key);
      }
    }
    _self.tmpUser.drivingType = _types.join('、');
  }
  this.changeLicensType = function() {
    console.log('change type');
    var userTypes=[]
    var userCtypes=[];
    if(_self.tmpUser.licensType){
      userTypes=_self.tmpUser.licensType.split('、');
    }
    if(_self.tmpUser.CertificateType){
      userCTypes=_self.tmpUser.CertificateType.split('、');
    }
    angular.forEach(_self.cyryList,function(item){
      if(userTypes.indexOf(item.type)>-1&&userCTypes.indexOf(item.ctype)>-1){
        item.selected=true;
      }
    });
    //return;
    $ionicModal.fromTemplateUrl('app/config/changelicenstype.html', {
      scope: $scope
    }).then(function(modal) {
      $scope.modal = modal;
      $scope.modal.show();
    });
  }
  this.closeLicensTypeModal = function() {
    $scope.modal.hide();

    var userTypes=[]
    var userCtypes=[];
    angular.forEach(_self.cyryList,function(item){
      if(item.selected){
        if(userTypes.indexOf(item.type)<0){
          userTypes.push(item.type);
        }
        if(userCtypes.indexOf(item.ctype)<0){
          userCtypes.push(item.ctype);
        }
      }
    })
    if(userTypes.length){
       _self.tmpUser.licensType=userTypes.join('、');
     }else{
       _self.tmpUser.licensType=null;
     }
     if(userCtypes.length){
       _self.tmpUser.CertificateType=userCtypes.join('、');
     }else{
       _self.tmpUser.CertificateType=null;
     }
  }
  //this.provinceList = ["安徽", "北京市", "福建", "甘肃", "广东", "广西壮族自治区", "贵州", "海南", "河北", "河南", "黑龙江", "湖北", "湖南", "吉林", "江苏", "江西", "辽宁", "内蒙古自治区", "宁夏回族自治区", "青海", "山东", "山西", "陕西", "上海市", "四川", "天津市", "西藏自治区", "新疆维吾尔自治区", "云南", "浙江", "重庆市"];

  function getProvinceCityList() {
    ApiService.getLocalJsonFile('guangdongList.json').then(function(data) {
      _self.provinceCityList = data || {};
    });
  }
  getProvinceCityList();
  $scope.$on('$destroy', function() {
    if ($scope.modal) {
      $scope.modal.remove();
    }
  });
  // this.saveEmail = function() {
  //   CommonService.showConfirm("你确定要更新用户吗?", function() {
  //     console.log($scope.user);
  //     var info = {
  //       id: $scope.user.id,
  //       email: _self.tmpUser.email,
  //       action: "changeuseremail",
  //     }
  //     console.log(info);
  //     ApiService.post('/user', info).then(function(result) {
  //       if (result.data.success) {
  //         CommonService.showInfo('邮件更新成功', function() {
  //           $state.reload();
  //         });
  //       } else {
  //         $scope.error = "用户更新失败: " + result.data.error;
  //       }
  //     });
  //   })
  // }
  this.todayStr = (new Date()).toISOString().substring(0, 10);
  // $scope.saveUser = function() {
  //   CommonService.showConfirm("你确定要更新用户吗?", function() {
  //     $scope.submitted = true;
  //     var mobile = document.getElementById('mobile').value;
  //     if (!(/^1[3456789]\d{9}$/.test(mobile))) {
  //       CommonService.showInfo('手机号码有误，请重新填写！');
  //       return;
  //     }
  //     if (mobile == _self.tmpUser.mobile) {
  //       CommonService.showInfo('更改后的手机号与原手机号一样，请重新填写！');
  //       return;
  //     }
  //     _self.tmpUser.mobile = mobile;
  //     $scope.user = JSON.parse(JSON.stringify(_self.tmpUser));
  //     ApiService.post('/profile', $scope.user).then(function(result) {
  //       $scope.submitted = false;
  //       if (result.data.success) {
  //         _self.isMobile = false;
  //         CommonService.showInfo('用户信息更新成功')
  //         $state.reload();
  //       } else {
  //         $scope.error = "用户更新失败: " + result.data.error;
  //       }
  //     });
  //   });
  // };

  function checkLicenseError() {
    if (!_self.tmpUser.licensProvience) {
      return '请选择从业资格核发地！';
    }
    if (!_self.tmpUser.licensNo) {
      return '请填写从业资格证号！';
    }
    if (!_self.tmpUser.licensType) {
      return '请选择从业人员类别！';
    }
    if (!_self.tmpUser.CertificateType) {
      return '请填选择业资格类别！';
    }
    if (!_self.tmpUser.licensExpire) {
      return '请选择从业资格有效期！';
    }
    return false;
  }
  var toUpdateKeys = ['userType', 'enrol', 'licensNo', 'comId', 'address', 'district', 'city', 'province', 'mobile', 'birthday', 'race', 'gender', 'fullname', 'licensType', 'licensProvience', 'CertificateType', 'licensExpire', 'drivingLicenseSource', 'drivingLicenseNo', 'drivingType', 'drivingLicenseExpire', 'busitype', 'safeCert', 'safeCertSource', 'safeCertExpired', 'safeCertNo'];
  this.invalidDriverType=false;
  this.changeDriverType=function(){
    if(!_self.tmpUser.drivingType||_self.tmpUser.drivingType.indexOf(',')>0||_self.tmpUser.drivingType.indexOf('、')>0){
      _self.invalidDriverType=true;
    }else{
      _self.invalidDriverType=false;
    }
  }
  function checkInfoComplete() {
    if (!_self.tmpUser.avatar) {
      return '请更新个人照片！';
    }
    if (!_self.tmpUser.gender) {
      return '请选择性别！';
    }
    if (!_self.tmpUser.race) {
      return '请选择民族！';
    }
    if (!_self.tmpUser.birthday) {
      return '请选择出生日期！';
    }
    if (!(/^1[3456789]\d{9}$/.test(_self.tmpUser.mobile))) {
      return '基本信息联系电话有误，请重新填写！';
    }
    if (!_self.tmpUser.province) {
      return '请选择辖区省！';
    }
    if (!_self.tmpUser.city) {
      return '请选择辖区市！';
    }
    if (!_self.tmpUser.address) {
      return '请填写联系地址！';
    }
    if (_self.tmpUser.busitype != '个体经营' && !_self.tmpUser.comId) {
      return '请选择就业公司！';
    }
    if (!_self.tmpUser.userType) {
      return '请选择岗位类型！';
    }
    if (!_self.tmpUser.enrol) {
      return '请填写服务开始时间！';
    }
    return false;
  }

  function ageValidation (birthDate, currentDate) {
    birthDate = new Date(birthDate);
    currentDate = new Date();

    var years = (currentDate.getFullYear() - birthDate.getFullYear());

    if (currentDate.getMonth() < birthDate.getMonth() ||
        currentDate.getMonth() == birthDate.getMonth() && currentDate.getDate() < birthDate.getDate()) {
        years--;
    }

    var isAllowedAge = years >= 18
    return isAllowedAge;
  }

  $scope.updateUser = function() {
    if($scope.user.BeiAnZhuangTai==1){
      CommonService.showInfo('用户信息已经备案，请通过企业平台进行更新！');
      return;
    }
    var result = checkInfoComplete();
    if (result) {
      return CommonService.showInfo(result);
    }

    if(!ageValidation(_self.tmpUser.birthday)) {
      return CommonService.showInfo("您必须年满18周岁及以上。") // You must be 18 years old or above
    }

    CommonService.showConfirm("你确定要更新用户吗?", function() {
      $scope.submitted = true;
      var toUpdate = {
        id: $scope.user.id,
      }
      angular.forEach(toUpdateKeys, function(key) {
        if (_self.tmpUser[key] != $scope.user[key]) {
          $scope.user[key] = toUpdate[key] = _self.tmpUser[key];
        }
      })
      console.log(toUpdate);
      ApiService.post('/profile', toUpdate).then(function(result) {
        $scope.submitted = false;
        if (result.data.success) {
          _self.isMobile = false;
          CommonService.showInfo('用户信息更新成功，点击确定进入首页！', function() {
            $state.go('app.home');
          })
          //$state.reload();
        } else {
          $scope.error = "用户更新失败: " + result.data.error;
        }
      });
    });
  };
  $scope.cancelSaveUser = function() {
    _self.isMobile = false;
    _self.tmpUser = JSON.parse(JSON.stringify($scope.user));
  }
  this.showModel = function() {
    console.log(23792378)
    _self.isShowModel = true;
  }
  this.hideModel = function() {
    _self.isShowModel = false;
  }
  this.addAttachment = function(fileflag) {
    if($scope.user.BeiAnZhuangTai==1){
      CommonService.showInfo('用户信息已经备案，请通过企业平台进行更新！');
      return;
    }
    var url = "public/resg/avatar/" + $scope.user.id + "/";
    console.log(url)
    if (!window.cordova) {
      return console.log('-- not device ---')
    }

    var permissions = cordova.plugins.permissions;
    permissions.checkPermission(permissions.CAMERA, function(status) {
      if (status.hasPermission) {
        CommonService.attachmentUpload(url, fileflag, function(res) {
          console.log(res);
          _self.imageFile = res.result;
          _self.updateAvatar();
        }, true);
      } else {
        var list = [permissions.CAMERA];
        permissions.requestPermissions(list, function(status) {
          if (status) {
            CommonService.attachmentUpload(url, fileflag, function(res) {
              console.log(res);
              _self.imageFile = res.result;
            }, true);
          } else {
            _self.showError("请打开摄像头权限");
          }
        }, function(error) {
          _self.showError("请打开摄像头权限");
          console.log("-- Storage Error ---");
        });
      }
    });
  }
  this.deleteAttach = function(index) {
    _self.imageFile = ''
    this.hideModel();
  }
  this.goHome = function() {
    $ionicHistory.clearCache().then(function() {
      $state.go('app.home');;
    });
  }
  this.updateAvatar = function() {
    if (_self.imageFile) {
      var info = {
        action: 'avatar',
        id: $scope.user.id,
        file: _self.imageFile,
      };
      console.log(info);
      ApiService.post('/user', info).then(function(result) {
        //console.log(result);
        if (result.data.success) {
          _self.tmpUser.avatar = _self.imageFile;
          loginService.user.avatar = _self.imageFile;
          $ionicHistory.clearCache().then(function() {
            _self.hideModel();
            return $state.go('app.config.update');
          });
        }
      });
    } else {
      CommonService.showInfo("您还没有拍摄头像哦，请重新拍摄。");
      return;
    }
  }
});
