angular.module('bamboo.course').controller('LMSCtrl', function($sce, $stateParams, $scope, ScormService, ApiService, CommonService, CourseApi) {
  var self = this;
  this.cid = $stateParams.cid;
  this.id = $stateParams.rid;
  this.chapter = {};
  this.mediapath = ApiService.SHOST + '/lcourse/' + self.cid + '/resources/';
  this.lmsready = false;
  console.log("---- lms ----");

  function getMediaUrl(url) {
    return $sce.trustAsResourceUrl(encodeURI(url));
  };
  var _lasttime = new Date();
  $scope.$on("$ionicView.enter", function(scopes, states) {
    _lasttime = new Date();
  });
  $scope.$on('$ionicView.beforeLeave', function() {
    CourseApi.recordUsage(self.cid,self.id,$stateParams.mvid,_lasttime);
  });
  function getInfo() {
    // CommonService.showLoading();
    var info = {
      action: 'getresource',
      id: self.id,
    };
    CourseApi.mvApi(info, function(result) {
      //  CommonService.stopLoading();
      console.log(result);
      self.chapter = result;
      if (self.chapter.cid != self.cid) {
        self.mediapath = ApiService.SHOST + '/lcourse/' + self.chapter.cid + '/resources/';
      }
      var api = ScormService.scormLocal(self.cid, self.id, null, function() {
        console.log("---- this one ---");
        // $timeout(function(){
        self.lmsready = true;
        // },10);
      });
      var lmsdoc = document.getElementById('lmswindow');
      lmsdoc.API = window.API = ScormService.API;
      var indexHtml = 'index_lms_html5.html';
      if (self.chapter.indexHtml) {
        indexHtml = self.chapter.indexHtml;
      }
    /*  var tempurl = self.mediapath + self.chapter.content + '/' + indexHtml;
      console.log(tempurl);
      self.mediaurl = getMediaUrl(tempurl);*/
      CourseApi.getMediaPath(self.id,self.mediapath,self.chapter.content,indexHtml,function(file){
        
        if(file.indexOf('file')==0){
          self.mediaurl=file;
        }else{
          self.mediaurl=$sce.trustAsResourceUrl(encodeURI(file));
        }
      })
    });
  }
  getInfo();
});