angular.module('bamboo.course').controller('MSOfficeCtrl', function($scope, $sce, $timeout, $stateParams, CourseApi, ApiService) {
  this.cid = $stateParams.cid;
  this.id = $stateParams.rid;
  var self = this;
  this.pptpicurl = this.pptaudiourl = this.ResUrl = ApiService.SHOST + '/lcourse/';
  function getInfo() {
    var info = {
      action: 'getresource',
      id: self.id,
    };
    CourseApi.mvApi(info, function(result) {
      console.log(result);
      $scope.chapter = self.chapter = result;
      var _protocol = window.location.protocol;
      var fullurl = self.ResUrl + ($scope.chapter.rid || $scope.chapter.cid) + "/resources/" + encodeURI($scope.chapter.content);
      console.log(fullurl);
      var refurl = "https://view.officeapps.live.com/op/embed.aspx?src=" + fullurl;
      console.log(refurl);
      $scope.chapter.fullurl = $sce.trustAsResourceUrl(refurl);
      $scope.audio = $scope.chapter.audio;
      $scope.video = $scope.chapter.video;
      setTimeout(showAudio, 100);
    });
  }
  getInfo();
  var _lasttime = new Date();
  $scope.$on("$ionicView.enter", function(scopes, states) {
    _lasttime = new Date();
  });
  $scope.$on('$ionicView.beforeLeave', function() {
    CourseApi.recordUsage(self.cid,self.id,$stateParams.mvid,_lasttime);
  });
  function showAudio() {
    var doc = angular.element($('#pptaudiodiv'));
    doc.empty();
    if ($scope.audio) {
      // console.log('show audio');
      $scope.audiourl = getAudioUrl($scope.audio);
      var audioElement = document.createElement('audio');
      audioElement.src = $scope.audiourl;
      audioElement.autoplay = true;
      audioElement.controls = 'controls';
      doc.append(audioElement);
    }
  }
 
});