angular.module('bamboo.course').controller('Scorm2004Ctrl', function($sce, Scorm2004,$timeout, $http,$cordovaDevice, $stateParams, $ionicNavBarDelegate, $stateParams, CourseApi, ApiService, $scope) {
  //  console.log(loginService.user._id);
  var self = this;
  self.lmsready = false;
  var courseid = $stateParams.cid;
  this.id = $stateParams.rid;
  this.mediapath = ApiService.SHOST + '/lcourse/' + self.cid + '/resources/';
  var resInfos = {};
  this.currentRef;
  var rootPath;
  this.gotoScoItem = function(item) {
    console.log(item);
    if (!item._identifierref) {
      return;
    }
    self.currentRef = item._identifierref;
    var _tempurl = rootPath + resInfos[self.currentRef];
    console.log(_tempurl);
    self.fullurl = $sce.trustAsResourceUrl(encodeURI(_tempurl));
  }

  this.toggleslide = function() {
    console.log("test");
    if ($scope.slideout) {
      $scope.slideout = false;
    } else {
      $scope.slideout = true;
    }
  }
  var _lasttime = new Date();
  $scope.$on("$ionicView.enter", function(scopes, states) {
    _lasttime = new Date();
  });
  $scope.$on('$ionicView.beforeLeave', function() {
    CourseApi.recordUsage(courseid,self.id,$stateParams.mvid,_lasttime);
  });
  $scope.toggleslidedrop = function(index) {
    console.log(index);
    $scope.slidedrop = index;
  }

  function getMenuItems(item, menu) {
    if (item._identifier) {
      console.log(item);
      var menuItem = angular.copy(item);
      //menuItem.url=resInfos[item._identifierref];
      if (menuItem.item) {
        delete menuItem.item;
        menuItem.menu = [];
        getMenuItems(item.item, menuItem.menu)
      }
      menu.push(menuItem);
      return;
    }
    for (var i = 0; i < item.length; i++) {
      var _subItem = item[i];
      getMenuItems(_subItem, menu)
    }
    return;
  }
  var isAndroid = null;
  if (window.cordova) {
    _platform = $cordovaDevice.platform;
    if (_platform && _platform.indexOf('Android') > -1) {
      isAndroid = true;
    }
  }

  function rotateScreen() {
    isAndroid && 　window.screen.orientation.lock('landscape');
    console.log('rotateScreen');
    $timeout(function() {
      window.addEventListener('orientationchange', doOnOrientationChange);
    }, 100);
  }

  function doOnOrientationChange() {
    console.log("--- rotation detected --");
    switch (window.orientation) {
      case -90:
      case 90:
        console.log('landscape');
        self.barFlag = true;
        $ionicNavBarDelegate.showBar(true);
        break;
      default:
        console.log('portrait');
        self.barFlag = true;
        $ionicNavBarDelegate.showBar(true);
        break;
    }
  }

  function getInfo() {
    // CommonService.showLoading();
    var info = {
      action: 'getresource',
      id: self.id,
    };
    CourseApi.mvApi(info, function(result) {
      self.chapter = result;
      console.log(result);
      rotateScreen();
      var api = Scorm2004.scorm2004Local(courseid, self.chapter._id, function() {
       
        console.log("--- ready ---");
        if (self.chapter.cid != self.cid) {
          self.mediapath = ApiService.SHOST + '/lcourse/' + self.chapter.cid + '/resources/';
        }
        var lmsdoc = document.getElementById('lmswindow');
        // lmsdoc.API = window.API = ScormService.API;
        lmsdoc.API = window.API_1484_11 = Scorm2004.API_1484_11;
        if (ApiService.MEDIAPATH) {
          self.mediapath = ApiService.MEDIAPATH + "/lcourse/";
        }
        // rootPath = self.mediapath + self.chapter.content + "/";
        var xmlFile = "imsmanifest.xml";
        CourseApi.getMediaPath(self.id, self.mediapath, self.chapter.content, xmlFile, function(fullpath) {
          console.log(fullpath);
          var pos = fullpath.indexOf(xmlFile);
          rootPath = fullpath.substring(0, pos);
          console.log(rootPath);
          var indexHtml = 'index_lms_html5.html';
          if (self.chapter.indexHtml) {
            indexHtml = self.chapter.indexHtml;
          }
          var _tempurl = rootPath + indexHtml;;
          console.log(_tempurl);
          //$timeout(function() {
            if (_tempurl.indexOf('file') == 0) {
              self.fullurl = _tempurl;
            } else {
              self.fullurl = $sce.trustAsResourceUrl(encodeURI(_tempurl));
            }
            console.log(fullpath);
            console.log(self.fullurl);
          self.lmsready = true;
         // }, 100);
          $http.get(fullpath, {
            transformResponse: function(cnv) {
              var x2js = new X2JS();
              var aftCnv = x2js.xml_str2json(cnv);
              console.log(aftCnv.manifest);
              if (aftCnv.manifest && aftCnv.manifest.organizations && aftCnv.manifest.organizations.organization && aftCnv.manifest.organizations.organization.item) {
                var resources = aftCnv.manifest.resources.resource;
                console.log(resources);
                if (resources._href) {
                  var id = resources._identifier;
                  var strname = "";
                  if (resources['_xml:base']) {
                    strname += resources['_xml:base'];
                  }
                  resInfos[id] = strname + resources._href;
                } else if (resources.length) {
                  for (var i = 0; i < resources.length; i++) {
                    var _r = resources[i];
                    var id = _r._identifier;
                    //  console.log(_r);
                    if (id && _r._href) {
                      var strname = "";
                      if (_r['_xml:base']) {
                        strname += _r['_xml:base'];
                      }
                      resInfos[id] = strname + _r._href;
                    }
                    // break;
                  }
                }
                console.log(resInfos);
                var items = aftCnv.manifest.organizations.organization.item;
                console.log(items);
                var menus = [];
                getMenuItems(items, menus);
                self.menuItems = menus;
                console.log(menus);
              } else {
                return CommonService.showError('Incompleted parameters');
              }
            }
          }).success(function(response) {
            console.log(response);
          });
        });
      })
    })
  }
  getInfo();
});