angular.module('bamboo.course').controller('WordChapterCtrl', function($scope, $sce, $timeout, $stateParams, ApiService, CourseApi) {
  this.cid = $stateParams.cid;
  this.id = $stateParams.rid;
  console.log("--- WordChapterCtrl");
  var self = this;
  this.index = 0;
  this.currentPPT;
  var resUrl = ApiService.SHOST + '/lcourse/' + this.cid + '/resources/';
  CourseApi.rotateScreen();

  function getInfo() {
    var info = {
      action: 'getresource',
      id: self.id,
    };
    CourseApi.mvApi(info, function(result) {
      //CommonService.stopLoading();
      console.log(result);
      self.chapter = result;
      resUrl = ApiService.SHOST + '/lcourse/' + self.chapter.cid + '/resources/';
      self.show(0);
    });
  }
  getInfo();
  this.playWord = function(word) {
    var file = self.chapter.libs[word];
    if (!file) {
      return;
    }
    var filename = resUrl + file;
    try {
      var myAudio = new Audio(filename);
      myAudio.play();
    } catch (e) {}
  }
  this.show = function(index) {
    self.index = index;
    self.currentPPT = self.chapter.ppts[index];
    if (self.currentPPT.photo) {
      self.currentPPT.photoUrl = resUrl + self.currentPPT.photo;
    }
    self.currentPPT.code = self.currentPPT.word.charCodeAt(0).toString(16);
    self.playWord(self.currentPPT.word);
  }
  var _lasttime = new Date();
  $scope.$on("$ionicView.enter", function(scopes, states) {
    _lasttime = new Date();
  });
  $scope.$on('$ionicView.beforeLeave', function() {
    CourseApi.recordUsage(self.cid,self.id,$stateParams.mvid,_lasttime);
  });
});