// Ionic Starter App
// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('bamboo.coursebundle', ['ionic', "ionic.native", "ionic.utils"]).config(function($stateProvider, $urlRouterProvider) {
  $stateProvider.state('app.coursebundle', {
    url: '/coursebundle',
    views: {
      'Content@app': {
        templateUrl: 'app/coursebundle/list.html',
        controller: 'CourseBundleListCtrl as ctrl',
      }
    }
  }).state('app.coursebundle.info', {
    url: '/info/:bid',
    views: {
      'Content@app': {
        templateUrl: 'app/coursebundle/bundleinfo.html',
        controller: 'CourseBundleInfoCtrl as ctrl'
      }
    }
  }).state('app.bundlerecords', {
    url: '/bundlerecords',
    views: {
      'Content@app': {
        templateUrl: 'app/coursebundle/records.html',
        controller: 'BundleRecordsCtrl as ctrl'
      }
    }
  }).state('app.bundlerecords.detail', {
    url: '/detail/:id',
    views: {
      'Content@app': {
        templateUrl: 'app/coursebundle/detail.html',
        controller: 'BundleRecordDetailCtrl as ctrl'
      }
    }
  });
});