'use strict';
angular.module('bamboo').directive('bbPwdValidate', ['pwdService','$translate',function(pwdService, $translate) {
  return {
    restrict: 'A',
    require: 'ngModel',
    link: function(scope, element, attrs, ctrl) {
      // add a parser that will process each time the value is
      // parsed into the model when the user updates it.
      // var rule;
      // pwdService.getValidateRule();
      // if (!element.attr('placeholder')) {
      //   element.attr('placeholder', $translate.instant(rule));
      // };
      var regex; 
      pwdService.getValidateRegex(function(data){
        console.log(data);
        regex =  data;
      });
      ctrl.$parsers.unshift(function(value) {
        if (value) {
          //console.info(value);
          var valid = value.match(regex);
          console.info(valid);
        }
        // if it's valid, return the value to the model,
        // otherwise return undefined.
        return valid ? value : undefined;
      });
    }
  }
}]);