angular.module('bamboo.blog').controller('AnnouncementListCtrl', function($scope, ApiService, loginService, $state, $stateParams, CommonService,utilService) {
  var _self = this;
  this.page = parseInt($stateParams.page) || 0;

  this.moreData = false;
  this.items = [];
  this.nextPage = function() {
    _self.page++;
    getInfo(_self.page);
    console.log("--- next page --");
  };

  _self.defaultAnnoucePhoto = ApiService.SHOST + "/public/images/details.png";
  if (loginService.school.announcephoto) {
    _self.defaultAnnoucePhoto = ApiService.SHOST + "/site/" + loginService.school.announcephoto;
  }

  _self.contentModelPicUrl = ApiService.SHOST + "/public/" + ApiService.RES + "/announcement/";

  $scope.setting=this.setting = {
    ctrl: _self,
    pageSize: 4
  };

  _self.newAnnounce = [];
  _self.oldAnnounce = [];

  function getInfo() {

    CommonService.showLoading();
    ApiService.get("/announcements/" + _self.page + "/" + _self.setting.pageSize).then(function(result) {
      CommonService.stopLoading();
      if (result.data.success) {
        
        if (!_self.items) {
          _self.items = [];
        }
        _self.announceList = result.data.data;
        _self.items = _self.items.concat(result.data.data);
        _self.totalCount = result.data.counters;
        _self.moreData = ((_self.totalCount - _self.items.length) > 0);
        console.log(_self.items);
        console.log(_self.totalCount, _self.items.length, _self.moreData);
        $scope.$broadcast('scroll.infiniteScrollComplete');

        var weekago = new Date();
        weekago.setDate(weekago.getDate() - 7);
        for (var i = 0; i < _self.announceList.length; i++) {
          var then = new Date(_self.announceList[i].created);
          if (weekago <= then) {
            _self.newAnnounce.push(_self.announceList[i]);
            _self.newAnnounceCount = _self.newAnnounce.length;
          } else {
            _self.oldAnnounce.push(_self.announceList[i]);
            _self.oldAnnounceCount = _self.oldAnnounce.length;
          }
        }
      }else{

      }
    });
  }
  getInfo(0);
  utilService.watchScroll($scope);
});
