// Ionic Starter App
// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('bamboo.discover', ['ionic', "ionic.native"]).config(function($stateProvider, $urlRouterProvider) {
  $stateProvider.state('app.discover', {
    url: '/discover',
    views: {
      'Content': {
        templateUrl: 'app/home/discover.html',
        controller: 'DiscoverCtrl as ctrl'
      }
    }
  }).state('app.discover.announcement', {
    url: '/discover/announcement/:page',
    views: {
      'Content@app': {
        templateUrl: 'app/discover/announcement_list.html',
        controller: 'AnnouncementListCtrl as ctrl'
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.discover.announcement.detail', {
    url: '/detail/:id',
    views: {
      'Content@app': {
        templateUrl: 'app/discover/announcement_detail.html',
        controller: 'AnnouncementDetailCtrl as ctrl'
      }
    }
  })
});