angular.module('bamboo.exam', ['ionic',"ionic.native","ionic.utils"])
.config(function($stateProvider, $urlRouterProvider) {
  $stateProvider.state('app.exam', {
    url: '/exam/:cat',
    views: {
      'Content@app': {
        templateUrl: 'app/exam/list.html',
        controller:"ExamListController as ctrl",
      }
    }
  }).state('app.exam.category', {
    url: '/category',
    views: {
      'Content@app': {
        templateUrl: 'app/exam/category.html',
        controller:"ExamCategoryCtrl as ctrl",
      }
    }
  }).state('app.exam.start', {
    url: '/start/:type/:id',
    views: {
      'Content@app': {
        templateUrl: 'app/exam/waitpage.html',
        controller: 'ExamPaperCtrl as ctrl'
      }
    }
  }).state('app.exam.test', {
    url: '/detail/:type/:id',
    views: {
      'Content@app': {
        templateUrl: 'app/exam/exampaper.html',
        controller: 'ExamPaperCtrl as ctrl'
      }
    }
  }).state('app.test', {
    url: '/test',
    views: {
      'Content@app': {
        templateUrl: 'app/exam/testlist.html',
        controller: 'TestListCtrl as ctrl'
      }
    }
  }).state('app.test.test', {
    url: '/test/:type/:id',
    views: {
      'Content@app': {
        templateUrl: 'app/exam/exampaper.html',
        controller: 'ExamPaperCtrl as ctrl'
      }
    }
  })
});
