angular.module('bamboo.exam').controller('ExamPaperCtrl', function ($state, $ionicHistory, $sce, $scope, $timeout, ApiService, CommonService, $stateParams, ExamService, $interval, $window, stringHelper, $ionicPlatform) {
    var _self = this;
    this.hideQuestion = false;
    this.id;

    var _type=this._type = $stateParams.type;
    this.type = $stateParams.type;
    var _eid = $stateParams.id; //for exam
    $scope.queShow = false;
    var deregisterFunction;
    // var _index = $stateParams.index;
    this.submitted = false;
    this.showQue = false;
    this.review = true;
    this.currentQ = 0;
    this.courseID;
    $scope.backLeave = false;//判断是header返回 停止物理返回
    //console.log($state.current)
    $scope.currentState = $state.current.name;
    this.question = null;
    this.score_percentage = 0;
    this.exam = null;
    this.examHistoryCounter = 0;
    this.use_time = 0;
    this.time_limit = 0;
    this.sTimer = null;
    this.stopTest = true;
    this.wait = false;
    this.paperType = $stateParams.type;
    this.eid = $stateParams.id;
    this.audioPath = ApiService.SHOST + "/exam/audio/";
    this.videoPath = ApiService.SHOST + "/exam/video/";
    this.examIconUrl = ApiService.SHOST + '/examphoto/' + ApiService.gid + '/';

    _self.submitConfirmationMessageBox = null;
    //this.stateParams = $stateParams;
    this.cid = undefined;
    // this.backtolist = function() {
    //   $window.location.href = $window.location.href = '/#/courselist//course/' + _self.cid;
    // }
    this.backtolist = function () {
        console.log(_self.cid);
        if (_self.cid) {
            $state.go('app.course.home', {cid: _self.cid});
        } else {
            $ionicHistory.goBack(-2);
        }
    };
    this.typename = {
        'single': 'Select one answer',
        'fill': 'Fill in the blank',
        'mfill': 'Fill in all the blanks',
        'tof': 'True or False',
        'short': 'Essay Question',
        'multiple': 'Select ALL the correct answers',
        'mquestion': 'Multiple Questions'
    }
    this.qtypename = {
        'single': 'Multiple Choice',
        'fill': 'Fill In Blanks',
        'mfill': 'Fill In Blanks',
        'tof': 'True or False',
        'short': 'Essay Question',
        'multiple': 'Multiple Answers',
        'multiselect': 'Multiple Answers',
        'mquestion': 'Question Group'
    }
    $scope.title = "Exam";
    console.log($state.current.name);
    if ($state.current.name == "index.tests.test") {
        $scope.title = "Test";
    }

    this.getSelectionText = function () {
        var text = "";
        if (window.getSelection) {
            text = window.getSelection().toString();
        } else if (document.selection && document.selection.type != "Control") {
            text = document.selection.createRange().text;
        }
    };

    this.showpopup = function () {
      if (!_self.question.rootContent) {
        return;
      }
      CommonService.showdetail($scope, 'app/exam/contentpopup.html');
    }

    function examApi(info, callback) {
        ApiService.post('/exam', info).then(function (result) {
            if (result.data.success) {
                if (!callback) {
                    CommonService.showInfo('Update Successful!');
                } else {
                    callback(result.data.data);
                }
            }
        });
    };

    function mvApi(info, callback) {
        ApiService.post('/mvsubjects', info).then(function (result) {
            if (result.data.success) {
                if (!callback) {
                    CommonService.showInfo('Update Successful!');
                } else {
                    callback(result.data.data);
                }
            }
        });
    };
    var _qsts = {};
    _self.selectQuestion = [];
    var newseq = [];
    var _singleQ = [];
    var _multipleQ = [];
    var _tofQ = [];
    var _fillQ = [];
    var _mfillQ = [];
    var _shortQ = [];
    var _mquestionQ = [];

    function addQinQue(fullquestion, sortFlag) {
        if (sortFlag) {
            switch (fullquestion.type) {
                case "tof":
                    _tofQ.push(fullquestion);
                    break;
                case "single":
                    _singleQ.push(fullquestion);
                    break;
                case "fill":
                case "mfill":
                    _mfillQ.push(fullquestion);
                    break;
                case "multiple":
                    _multipleQ.push(fullquestion);
                    break;
                case "short":
                    _shortQ.push(fullquestion);
                    break;
                default:
                    console.log("---- !!! Unknow type: " + fullquestion.type);
                    break;
            }
        } else {
            newseq.push(fullquestion);
        }
    }

    function addMQinQue(fullquestion, sortFlag) {
        if (sortFlag) {
            _mquestionQ.push(fullquestion);
        } else {
            newseq.push(fullquestion);
        }
    }

    var _mqlength;

    function getFullQue(sortFlag) {
        if (sortFlag) {
            newseq = newseq.concat(_tofQ);
            newseq = newseq.concat(_singleQ);
            newseq = newseq.concat(_mfillQ);
            newseq = newseq.concat(_multipleQ);
            newseq = newseq.concat(_shortQ);
            newseq = newseq.concat(_mquestionQ);
            return newseq;
        } else {
            return newseq;
        }
    }

    function prepareQuestions(data, sortFlag) {
        var _qsts = {};
        console.log(data);
        var exam = angular.copy(data.paper);
        angular.forEach(data.qstList, function (fullquestion, idx) {
            var id = fullquestion._id;
            _qsts[id] = fullquestion;
            if (fullquestion.audio) {
                fullquestion.audiourl = $sce.trustAsResourceUrl(_self.audioPath + encodeURI(fullquestion.audio));
            }
            if (fullquestion.video) {
                fullquestion.videourl = $sce.trustAsResourceUrl(_self.videoPath + encodeURI(fullquestion.video));
                console.log(_self.videoPath + encodeURI(fullquestion.video));
            }
            fullquestion = ExamService.convertBankQ(fullquestion);
            /*if (fullquestion.type == 'single' || fullquestion.type == "multiple" || fullquestion.type == "mfill") {
             angular.forEach(fullquestion.answer, function(val, idx) {
             fullquestion.options.push({
             "text": val,
             "correct": true,
             index: 'a' + idx
             });
             });
             angular.forEach(fullquestion.references, function(val, idx) {
             fullquestion.options.push({
             "text": val,
             index: 'r' + idx
             });
             });
             }*/
            if (fullquestion.type == "single" || fullquestion.type == "multiple") {
                fullquestion._options.sort(function (a, b) {
                    return Math.random() > .5 ? -1 : 1;
                });
                fullquestion._options.sort(function (a, b) {
                    return Math.random() > .5 ? -1 : 1;
                });
            }
        });
        var scorsInfo = {};
        angular.forEach(exam.questions, function (val, index) {
            if (val.id) {
                scorsInfo[val.id] = val;
            }
        })
        exam.totalScore = 0;
        var idx = 0;
        newseq = [];
        _singleQ = [];
        _multipleQ = [];
        _tofQ = [];
        _fillQ = [];
        _mfillQ = [];
        _shortQ = [];
        _mquestionQ = [];

        angular.forEach(exam.questions, function (question, index) {
            if (question.id && _qsts[question.id]) {
                var fullquestion = _qsts[question.id];
                if (!fullquestion.root && question.type != 'mquestion') {
                    fullquestion.score = parseInt(question.score || 0);
                    exam.totalScore += fullquestion.score || 0;
                    idx++;
                    fullquestion.newIdx = fullquestion.q_index = idx;
                    addQinQue(fullquestion, sortFlag);
                    //_questions.push(fullquestion);
                } else if (question.type == 'mquestion') {
                    if (fullquestion.questions && fullquestion.questions.length) {
                        angular.forEach(fullquestion.questions, function (id) {
                            if (_qsts[id]) {
                                var subq = _qsts[id];
                                if (!scorsInfo[id]) {
                                    scorsInfo[id] = {};
                                }
                                subq.score = parseInt(scorsInfo[id].score || 0);

                                subq.rootContent = fullquestion.content;
                                if (fullquestion.audiourl) {
                                    subq.rootAudioURL = fullquestion.audiourl;
                                }
                                if (fullquestion.videourl) {
                                    subq.rootVideoURL = fullquestion.videourl;

                                }
                                exam.totalScore += subq.score;
                                idx++;
                                subq.newIdx = subq.q_index = idx;
                                // _questions.push(subq);
                                addMQinQue(subq, sortFlag);
                            }
                        })
                    }
                }
            } else if (question.title) {
                addQinQue(question, sortFlag);
            }
        });
        getFullQue(sortFlag);
        delete exam['questions'];
        exam.questions = newseq;
        return exam;
    }

    function loadPaper() {
        var info = {
            id: _self.id,
            action: "getfullpaper",
        };
        console.log(_self.type);
        if (_self.type == "Dynamic" || _type == "test") {
            info.action = "getfulldpaper";
            info.cid = _self.courseID;
        } else if (_self.type == 'Smart') {
            info.action = "getfullspaper";
            info.cid = _self.courseID;
        }
        console.log(info);
        examApi(info, function (data) {
            console.log(data);
            if (!data) {
                return;
            }
            var exam = angular.copy(data.paper);
            var sortFlag;
            if (_self.type == "Dynamic" || _type == "test" || _self.type == "Smart") {
                sortFlag = true;
            }
            var _exam = prepareQuestions(data, sortFlag);
            console.log(_exam);
            exam.questions = _exam.questions;
            _self.showQue = true;
            _self.selectQuestion = [];
            for (var n = 0; n < exam.questions.length;) {
                _self.selectQuestion.push(++n);
                console.log(_self.selectQuestion)
            }

            _self.submitted = false;
            //console.log(exam);
            _self.exam = exam;
            _self.use_time = 0;
            _self.currentQ = 0;
            _self.question = exam.questions[0];
            console.log(_self.question);
            _self.time_limit = 60 * exam.time; // convert to seconds
            //initPaperVideo();
        });
    }

    // function initPaperVideo() {
    //   angular.forEach(_self.exam.questions, function(q, idx) {
    //     initVideoForQues(q);
    //     //console.log(q);
    //     q.content = q.content.replace(/[\x00-\x1F\x7F-\x9F]/g, "");
    //     q.comment = stringHelper.stripTags(q.comment).trim();
    //     if (idx === 0) {
    //       initFirstQuesVideo(q);
    //     }
    //   });
    // }

    function initQuesVideo(q) {
        if (!q || !q.video) return;
        q.videourl = null;
        $timeout(function () {
            q.videourl = $sce.trustAsResourceUrl(_self.videoPath + encodeURI(q.video))
        }, 200)

    }

    function timerHandler() {
        if (!_self.submitted) {
            _self.use_time++;
            if (_self.time_limit > 0) {
                var timeLeft = _self.time_limit - _self.use_time;
                //if (timeLeft <= 0) {
                //    // time up
                //    if (!_self.submitted) {
                //        _self.submit();
                //    }
                //}
                if (timeLeft <= 0) {
                    // time up
                    _self.sTimer = 0;
                    if (!_self.submitted) {
                        //_self.submit();
                        $interval.cancel(inTimer);
                        _self.timeSubmit();
                    }
                }
                if (Math.floor(timeLeft / 60) < 10) {
                    _self.sTimer = "0" + Math.floor(timeLeft / 60) + " : " + (timeLeft % 60);
                } else {
                    _self.sTimer = Math.floor(timeLeft / 60) + " : " + (timeLeft % 60);
                }
                // console.log("--- timer",_self.time_limit,_self.sTimer);
            }


        } else {
            $interval.cancel(inTimer);
        }
    };

    $scope.$on('$ionicView.beforeLeave', function () {
      if(_self.submitted) {
        $state.go('app.study');
        return
      }

      if ($scope.currentState == "app.exam.test" && _type == 'exam') {
          if (!$scope.backLeave) {
              if (_self.exam && _self.exam.questions.length > 0) {
                  if (!_self.submitted) {
                      if (_self.sTimer != "00 : 0") {
                          _self.submit();
                      }
                      //$state.go('app.study');
                  } else {
                      $state.go('app.study');
                  }

              } else {
                  $ionicHistory.goBack();
              }
          } else {
              $ionicHistory.goBack();
          }
      } else if ($scope.currentState == "app.exam.start") {
        deregisterFunction()
      }
    })
    $scope.$on("$ionicView.enter", function() {
      if ($scope.currentState == "app.exam.test" && _type == 'exam') {
        deregisterFunction = $ionicPlatform.registerBackButtonAction(function(event) {
          event.preventDefault();
            if ($scope.currentState == "app.exam.test" && _type == 'exam') {
              if (!$scope.backLeave) {
                if (_self.exam && _self.exam.questions.length > 0) {
                    if (!_self.submitted) {
                        if (_self.sTimer != "00 : 0") {
                            _self.submit();
                        }
                    } else {
                        $state.go('app.study');
                    }
                } else {
                    $ionicHistory.goBack();
                }
            } else {
                $ionicHistory.goBack();
            }
          }
        }, 501);
      }
    });
    $scope.goBackList = function () {
        //if (_self.sTimer != "00 : 0") {
        //    $state.go('app.study');
        //    $scope.currentState = '0';
        //    $interval.cancel(inTimer);
        //}
        $scope.backLeave = true;
        if ($scope.currentState == "app.exam.test" && _type == 'exam') {
            if (_self.exam && _self.exam.questions.length > 0) {
                if (!_self.submitted) {
                    if (_self.sTimer != "00 : 0") {
                        _self.submit();
                    }
                    //$state.go('app.study');
                } else {
                    $state.go('app.study');
                    $interval.cancel(inTimer);
                }
                $interval.cancel(inTimer);

            } else {
                $ionicHistory.goBack();
                $interval.cancel(inTimer);
            }
        } else {
            $state.go('app.study');
            $interval.cancel(inTimer);
        }
        //$interval.cancel(inTimer);
    }
    var inTimer;
    if ($scope.currentState == "app.exam.test") {
        inTimer = $interval(timerHandler, 1000);
    }
    this.loadExercise = function () {
    };
    this.currentQ = 0;

    $scope.dissQue = function () {
        $scope.queShow = false;
    }
    $scope.clickQue = function () {
        $scope.queShow = true;
    }

    this.gotoQuestion = function (index) {
        console.log(_self.selectQuestion);
        console.log(_self.question, _self.exam.questions.length, idx);
        console.log(_self.question);
        var idx = index;
        if (_self.question.type == 'mfill' || _self.question.type == 'multiple') {
            for (var i = 0; i < _self.question._options.length; i++) {
                if (_self.question._options[i].selection) {
                    _self.question.result = _self.question._options[i].selection;
                    break;
                }
            }
        }
        if (idx >= 0 && idx < _self.exam.questions.length) {
            _self.currentQ = idx;
            _self.question = _self.exam.questions[idx];
            //console.log(_self.question);
        }
        _self.questionNumber = index;
        initQuesVideo(_self.question)
    };
    this.gotoSpecificQuestion = function (idx) {
        console.log(_self.question, _self.exam.questions.length, idx);
        console.log(idx)
        if (_self.question.type == 'mfill' || _self.question.type == 'multiple') {
            console.log(_self.question._options.length)
            for (var i = 0; i < _self.question._options.length; i++) {
                if (_self.question._options[i].answer) {
                    _self.question.result = _self.question._options[i].answer;
                    break;
                }
            }
        }
        if (idx > 0 && idx <= _self.exam.questions.length) {
            _self.question = _self.exam.questions[idx - 1];
            _self.currentQ = idx - 1;
        }
        _self.questionNumber = idx;
        initQuesVideo(_self.question)
        $scope.queShow = false;
    };


    this.loadExamHistory = function () {
        //var info = {
        //    id: _eid,
        //    action: "getuserexamcountbyreason",
        //};
        //examApi(info, function (data) {
        //    console.log(data);
        //    console.log("-- history --" + data + ":" + _self.accessOnce);
        //    console.log($scope.retries);
        //    _self.examHistoryCounter = data.total;
        //    _self.examPassCounter = data.pass || 0;
        //    if (_self.accessOnce == "1" && _self.examHistoryCounter > 0 && _type != "test") {
        //        console.log("Have record, can not start test!");
        //        //_self.stopInfo = $filter('trans')({
        //        //    eng: "You have done the Test!",
        //        //    chn: '已完成考试'
        //        //});
        //        $timeout(function () {
        //            _self.stopTest = false;
        //        }, 200);
        //    }
        //    if ($scope.retries && _self.examHistoryCounter >= $scope.retries && $scope.retries != 0) {
        //
        //        if (_self.examHistoryCounter >= $scope.retries && $scope.retries != 0) {
        //            CommonService.showInfo("很抱歉，您不能进行答题，因答题次数已到达限制!");
        //        }else{
        //            $state.go('app.exam.test', {
        //                id: _self.eid,
        //                type: _self.paperType
        //            });
        //        }
        //    }
        //});
        if ($scope.retries == 0 || $scope.retries == undefined || $scope.retries == 'undefined') {
            $state.go('app.exam.test', {
                id: _self.eid,
                type: _self.paperType
            });
            return;
        }
        //if ($scope.retries && _self.examHistoryCounter >= $scope.retries && $scope.retries != 0) {

        if (_self.examHistoryCounter >= $scope.retries && $scope.retries != 0) {
            CommonService.showInfo("很抱歉，您不能进行答题，因答题次数已到达限制!");
        } else {
            $state.go('app.exam.test', {
                id: _self.eid,
                type: _self.paperType
            });
        }
        //}
    };


    this.selectSingle = function (index, opt) {
        console.log(opt);
        _self.question.result = opt.text;
        //_self.question.selected = opt.index;
    }
    this.submit = function () {
      _self.submitConfirmationMessageBox = CommonService.showConfirm("您确定要提交吗？", function () {
            deregisterFunction()
            var exam = _self.exam;
            _self.hideQuestion = !_self.review;
            var _result = ExamService.calResult(exam);
            _result.type = _self.type;
            _result.eid = exam._id;
            _result.reasonid = _eid;
            _result.reasontype = _type;
            _result.time = _self.use_time;
            $scope.timespent = _self.use_time;
            _result.action = "saveexamrecord";
            if (_self.courseID || exam.cid) {
                _result.cid = _self.courseID || exam.cid; // course id higher than paper cid
            }
            if (_type == 'test') {
                _result.action = "savetestrecord";
            } else if (_type == 'error' || _type == 'personal') {
                _result.action = "saveerrorrecord";
            }
            _self.submitted = true;
            // to avoid the resumit for long time.
            examApi(_result, function (data) {
                _self.submitted = true;
                _self.score_percentage = exam.get_score / exam.totalScore;
                console.log("submit success");
                console.log(_self.submitted);
            });
        });
    };
    this.timeSubmit = function () {
      deregisterFunction()

      //this will close the opened message box when exam time runs out
      if(_self.submitConfirmationMessageBox) {
        _self.submitConfirmationMessageBox.close();
      }

      $interval.cancel(inTimer);

      var exam = _self.exam;
      _self.hideQuestion = !_self.review;
      var _result = ExamService.calResult(exam);
      _result.type = _self.type;
      _result.eid = exam._id;
      _result.reasonid = _eid;
      _result.reasontype = _type;
      //scores:get_score,
      _result.time = _self.use_time;
      $scope.timespent = _self.use_time;
      _result.action = "saveexamrecord";
      if (_self.courseID || exam.cid) {
          _result.cid = _self.courseID || exam.cid; // course id higher than paper cid
      }
      if (_type == 'test') {
          _result.action = "savetestrecord";
      } else if (_type == 'error' || _type == 'personal') {
          _result.action = "saveerrorrecord";
      }
      // console.log(_result);
      _self.submitted = true;
      // to avoid the resumit for long time.
      examApi(_result, function (data) {
          _self.submitted = true;
          _self.score_percentage = exam.get_score / exam.totalScore;
          //_self.submitted = true;
          console.log("submit success");
          if (_self.sTimer == "00 : 0") {
              CommonService.showInfo("考试时间已到，试卷已被自动提交！");
          } else {
              $interval.cancel(inTimer);
          }
            console.log(_self.submitted);
        });
    };

    function init() {
        console.log(_type + ":" + _eid);

        function prepareTest(data) {
            console.log(data);
            _self.id = data.eid;
            console.log(_self.id);
            _self.type = data.type;
            _self.accessOnce = data.oneaccess;
            _self.review = data.review;
            _self.scoresFlag = data.scoresFlag;
            _self.type = data.type;
            _self.title = data.name;
            _self.description = data.description;
            _self.imgUrl = data.photo;
            _self.wait = data.waittostart;
            _self.courseID = data.cid;
            loadPaper();
            // loadExamHistory();
        }

        if (_type == 'exam') {
            //var info = {
            //    action: "getexamitem",
            //    id: _eid,
            //};
            //
            //examApi(info, function (data) {
            var info = {
                action: "getExamitemWithStatus",
                id: _eid,
            };
            //    console.log(data);
            //    console.log(info);
            examApi(info, function (data) {
                if (data) {
                    console.info(data);
                    $scope.retries = data.retries;
                    var info = {
                        id: _eid,
                        action: "getuserexamcountbyreason",
                    };
                    examApi(info, function (data) {
                        console.log(data);
                        console.log("-- history --" + data + ":" + _self.accessOnce);
                        console.log($scope.retries);
                        _self.examHistoryCounter = data.total;
                        _self.examPassCounter = data.pass || 0;
                    });
                    prepareTest(data);
                } else {
                    console.log("error: data is null");
                }
            });


            //prepareTest(data);
            //});

        } else if (_type == 'test') {
            var info = {
                action: "gettestitem",
                id: _eid,
            };
            examApi(info, function (data) {
                prepareTest(data);
            });
        } else if (_type == 'course') {
            var info = {
                action: 'getresource',
                id: _eid,
            };
            console.log(info);
            mvApi(info, function (data) {
                _self.courseID = _self.cid = data.cid;
                _self.id = data.content;
                console.log(_self.id);
                _self.type = 'Paper';
                _self.review = data.review;
                _self.title = data.name;
                _self.description = data.description;
                _self.imgUrl = data.photo;
                loadPaper();
                // loadExamHistory();
            })
        } else if (_type == 'error') {
            _self.submitted = false;
            _self.title="我的错题";
            var info = {
                action: 'geterrorpaper',
                cid: _eid,
            }
            _self.courseID = _eid;
            examApi(info, function (data) {
                console.log(data);
                if (!data) {
                    _self.showQue=true;
                    return;
                }
                //var qsts = data.qstList;
                var _questions = [];
                angular.forEach(data.qstList, function (val, index) {
                    var q = {
                        type: val.type,
                        id: val._id,
                        score: val.score,
                    }
                    _questions.push(q);
                })
                data.paper = {
                    questions: _questions,
                };
                console.log(data);
                // var exam = angular.copy(data.paper);
                // var _exam = prepareQuestions(data,true);
                // exam.questions = _exam.questions;
                _self.exam = prepareQuestions(data, true);
                console.log(_self.exam);
                _self.question = _self.exam.questions[0];
                _self.gotoQuestion(0);
                _self.totalscores = _self.exam.totalscores;
                _self.use_time = 0;
                _self.currentQ = 0;
                _self.exam.time = 60;
                //  console.log(_self.question);
                _self.time_limit = 60 * 60; // convert to seconds
                _self.selectQuestion = [];
                for (var n = 0; n < _self.exam.questions.length;) {
                    _self.selectQuestion.push(++n);
                    console.log(_self.selectQuestion)
                }

            });
        }
    }

    init();
    this.retest = function () {
        if (_self.examHistoryCounter + 1 >= $scope.retries && $scope.retries != 0) {
            CommonService.showInfo("很抱歉，您不能进行重做，因答题次数已到达上限!");
            return;
        }
        _self.currentQ = 0;
        //_self.submitted = false;
        //if($scope.retries = 0)
        init();
        //timerHandler()
        _self.sTimer = '00:0';
        if ($scope.currentState == "app.exam.test") {
            inTimer = $interval(timerHandler, 1000);
        }
    }
    $scope.numToLetters = function (num) {
        return String.fromCharCode(65 + num);
    };
    this.share = function () {
        console.log(_self.exam);
        var link = ApiService.HOST + '/app/#/examdetails/' + _self.paperType + '/' + _self.eid;
        console.log(link);
        CommonService.showShareDialog($scope, _self.exam.title, null, link, _self.exam.des);
    };

    this.clickQ = function () {
        //  console.log(_self.question)
        _self.question._answered = true;
    }
})
;
