'use strict';
angular.module('bamboo.formal').controller('MyFormalRecordsCtrl', function($scope, examService, CommonService) {
  var _self = this;
  this.TrainingTypeList = ['道路旅客运输驾驶员', '道路货物运输驾驶员', '道路危险货物运输驾驶员', '城市公共汽电车驾驶员', '车主', '安全员', '其他'];
  function getAccessRecords() {
    var info = {
      start: 0,
      limit: 50,
      action: "getUserFormalRecords"
    };
    console.log(info)
    examService.api(info,function(result) {
      //console.log(result);
      console.log(result)
      _self.displayedItems = result.items;
      
      angular.forEach(_self.displayedItems, function(item) {
        
        item.endTime = moment(item.update).add(item.time, 'seconds').format();
        item.startTime = item.update
        item.duration = secondsToTime(item.time);
      })
      _self.total = result.counter;
      console.log(_self.displayedItems, "displayedItems");
    });
  }
  getAccessRecords();

  function secondsToTime(secs) {
    var sec_num = parseInt(secs, 10); // don't forget the second param
    var hours = Math.floor(sec_num / (60 * 60));
    var minutes = Math.floor((sec_num - (hours * 3600)) / 60);
    var seconds = sec_num - (hours * 3600) - (minutes * 60);
    if (hours < 10) {
      hours = "0" + hours;
    }
    if (minutes < 10) {
      minutes = "0" + minutes;
    }
    if (seconds < 10) {
      seconds = "0" + seconds;
    }
    var time = hours + ':' + minutes + ':' + seconds;
    return time;
  };
});