'use strict';
angular.module('bamboo.formal').controller('FormalTestController', function($state, $ionicHistory, $localstorage, $rootScope, $sce, CommonService, ExamService, $scope, ApiService, $stateParams, loginService, $interval, $timeout, $filter, $window, $document, $translate, $ionicPlatform) {
  var self = this;
  this.hideQuestion = false;
  this.id;
  this.userID = loginService.user && loginService.user.name;
  // console.log(loginService);
  var _type = this._type = $stateParams.type;
  var paperId = $stateParams.paperid;
  $scope.queShow = false;
  var _task = $stateParams.task;
  this.commentIndex = 0;
  if ($localstorage.get('paperExamPass')) {
    this.paperInfo = $localstorage.get('paperExamPass');
  }
  var deregisterFunction;
  var _eid = $stateParams.id; //for exam
  //console.log($stateParams);
  this.courseID;
  this.fullsize = false;
  self.CurrQIdx = 0;
  $scope.singleDropTarget = {};
  $scope.multiTargetList = initTargetList();
  this.submitted = false;
  this.review = true;
  self.showQue = false;
  this.currentQ = 0;
  this.question = null;
  this.score_percentage = 0;
  this.exam = null;
  this.examHistoryCounter = 0;
  this.use_time = 0;
  this.time_limit = 0;
  this.sTimer = null;
  this.stopTest = true;
  this.knowledgeresult = {};
  this.wait = false;
  this.totalscores = 0;
  this.eid = $stateParams.id;
  this.examIconUrl = ApiService.SHOST + '/examphoto/';
  this.audioPath = ApiService.SHOST + "/exam/audio/";
  this.videoPath = ApiService.SHOST + "/exam/video/";
  //this.typename = ExamService.typename;

  self.submitConfirmationMessageBox = null;
  this.typename = {
    'single': 'Select one answer',
    'fill': 'Fill in the blank',
    'mfill': 'Fill in all the blanks',
    'tof': 'True or False',
    'short': 'Essay Question',
    'multiple': 'Select ALL the correct answers',
    'multiselect': 'Select ALL the correct answers',
    'mquestion': 'Multiple Questions'
  }
  this.qtypename = {
    'single': 'Multiple Choice',
    'fill': 'Fill In Blanks',
    'mfill': 'Fill In Blanks',
    'tof': 'True or False',
    'short': 'Essay Question',
    'multiple': 'Multiple Answers',
    'multiselect': 'Multiple Answers',
    'mquestion': 'Question Group'
  }
  this.REASON = "Sorry,you can not take the test again because you can only take a limited number of times!";
  $scope.title = "Exam";
  console.log($state.current.name);
  // console.log(ApiService);
  $scope.HostURL = "http://localhost:3100/#";
  this.attachFilesSetting = {
    image: false,
    accept: ".jpg,.jpeg,.gif,.png,.pdf,.txt,.xlsx,.mp3,.mp4,.docx,.docm,.dotm,.dotx,.xlsx,.xlsb,.xlsm,.pptx,.ppsx,.ppt,.pps,.pptm,.potm,.ppam,.potx,.ppsm",
    promise: true,
    title: "Documents",
    maxSize: 102400,
    randomFlag: true,
    multiple: true,
    resPath: "public/" + ApiService.RES + "/examattachment/" + this.eid + "/",
  };
  /*  if ($state.current.name == "index.tests.test") {
   $scope.title = "Test";
   }*/
  this.toggleSize = function() {
    self.fullsize = !self.fullsize;
  }
  this.toggleSize2 = function() {
    self.fullsize2 = !self.fullsize2;
  }
  this.toggleSize3 = function() {
    self.fullsize3 = !self.fullsize3;
  }

  function loadPaper() {
    var info = {
      id: self.id,
      action: "getfullpaper",
    };
    if (self.type == 'Knowledge') {
      info.action = "getFullKPaper";
    }
    examApi(info, function(data) {
      if (!data) {
        return;
      }
      self.showQue = true;
      self.paperID = data.paper._id;
      var sortFlag;
      if (self.type == "Knowledge") {
        sortFlag = true;
      }
      self.submitted = false;
      self.exam = ExamService.prepareQuestions(data, sortFlag);
      self.selectQuestion = [];
      for (var n = 0; n < self.exam.questions.length;) {
        self.selectQuestion.push(++n);
        // console.log(self.selectQuestion)
      }
      console.log(self.exam);
      paperPostProcess();
    });
  }

  function relaceExmQsWithlocalQs(exam, localExm) {
    var localQs = localExm.questions || [];
    var localDict = {};
    var Qs = exam.questions || [];
    var newQs = [];
    angular.forEach(localQs, function(q, idx) {
      if (q && q._id) {
        localDict[q._id] = q;
      }
    });
    angular.forEach(Qs, function(q, idx) {
      var newQ = localDict[q._id];
      newQ && newQ.rawRootVideoURL && (newQ.rootVideoURL = $sce.trustAsResourceUrl(newQ.rawRootVideoURL));
      newQs.push(newQ);
    });
    exam.questions = newQs;
  }
  self.matchQMap = {};

  function paperPostProcess() {
    self.use_time = 0;
    self.currentQ = 0;
    console.log(self.exam);
    if (self.exam.questions && self.exam.questions.length != 0) {
      angular.forEach(self.exam.questions, function(q, idx) {
        initVideoForQues(q);
        q.content = q.content.replace(/[\x00-\x1F\x7F-\x9F]/g, "");
        q.commentChk = (q.comment) ? q.comment.replace(/<[^\/>][^>]*><\/[^>]+>/, "") : ''; //stringHelper.stripTags(q.comment).trim();
        if (idx === 0) {
          initFirstQuesVideo(q);
        }
      });
      console.log(self.exam.questions);
      self.gotoQuestion(0);
      //self.question = self.exam.questions[0];
      shuffleMultiQOptions(self.question);
      //var mdd_blank_count = stringHelper.getQCountByQContent(self.question.content);
      //self.question.mdd_blank_count = mdd_blank_count;
      //self.question.mdd_blank_count = 5;
      self.questionCopy = angular.copy(self.question);
      //console.log(mdd_blank_count);
      self.totalscores = self.exam.totalscores;
      // console.log(self.exam);
      self.time_limit = 60 * self.exam.time; // convert to seconds
      // initResultInfo();
    }
  }

  function initVideoForQues(q) {
    if (!q || !q.video) return;
    q.quesVideoSrc = $sce.trustAsResourceUrl(self.videoPath + encodeURI(q.video));
  }

  function initFirstQuesVideo(q) {
    if (!q || !q.quesVideoSrc) return;
    $timeout(function() {
      $scope.selectedQVdoPath = q.quesVideoSrc;
      $scope.$apply();
    }, 0);
  }

  function timerHandler() {
    if (!self.submitted) {
      self.use_time++;
      if (self.time_limit > 0) {
        var timeLeft = self.time_limit - self.use_time;
        if (timeLeft <= 0) {
          // time up
          self.sTimer = 0;
          if (!self.submitted && self.sTimer == 0) {
            $interval.cancel(self.inTimer);
            self.timeSubmit();
          }
        }
        if (Math.floor(timeLeft / 60) < 10) {
          self.sTimer = "0" + Math.floor(timeLeft / 60) + " : " + (timeLeft % 60);
        } else {
          self.sTimer = Math.floor(timeLeft / 60) + " : " + (timeLeft % 60);
        }
      }
    } else {
      cancelTimer();
      // $interval.cancel(self.inTimer);
    }
  }
  this.inTimer = $interval(timerHandler, 1000);

  function lauchInTimer() {
    self.inTimer = $interval(timerHandler, 1000);
  }

  function cancelTimer() {
    if (self.inTimer) {
      $interval.cancel(self.inTimer);
      self.inTimer = null;
    }
  }
  $scope.$on('$ionicView.beforeLeave', function() {
    if (self.exam && self.exam.questions.length > 0) {
      if (!self.submitted) {
        if (self.sTimer != "00 : 0") {
          self.submit();
        }
      } else {
        if (_type == 'exam') {
          $state.go('app.formal');
          // $interval.cancel(inTimer);
        } else if (_type == 'fast') {
          $state.go('app.formal.practise');
        } else if (_type == 'simulate') {
          $state.go('app.formal.simulations');
          // $interval.cancel(inTimer);
        } else {
          $state.go('app.formal');
        }
      }
    } else {
      $ionicHistory.goBack();
      //$interval.cancel(inTimer);
    }
  })
  $scope.$on("$ionicView.enter", function() {
    deregisterFunction = $ionicPlatform.registerBackButtonAction(function(event) {
      event.preventDefault();
      if (self.exam && self.exam.questions.length > 0) {
        if (!self.submitted) {
          if (self.sTimer != "00 : 0") {
            self.submit();
          }
        } else {
          if (_type == 'exam') {
            $state.go('app.formal');
            // $interval.cancel(self.inTimer);
          } else if (_type == 'fast') {
            $state.go('app.formal.practise');
            // $interval.cancel(self.inTimer);
          } else if (_type == 'simulate') {
            $state.go('app.formal.simulations');
            //$interval.cancel(self.inTimer);
          }
          $state.go('app.formal');
        }
      } else {
        $ionicHistory.goBack();
        // $interval.cancel(inTimer);
      }
    }, 501);
  });
  $scope.goBackList = function() {
    if (self.exam && self.exam.questions.length > 0) {
      if (!self.submitted) {
        if (self.sTimer != "00 : 0") {
          self.submit();
        }
      } else {
        if (_type == 'exam') {
          $state.go('app.formal');
          // $interval.cancel(inTimer);
        } else if (_type == 'fast') {
          $state.go('app.formal.practise');
        } else if (_type == 'simulate') {
          $state.go('app.formal.simulations');
          // $interval.cancel(inTimer);
        }else{
          $state.go('app.formal');
        }

      }
    } else {
      $ionicHistory.goBack();
      // $interval.cancel(inTimer);
    }
    // cancelTimer();
  }
  // function loadExamHistory() {
  //   var info = {
  //     id: _eid,
  //     action: "getuserexamcountbyreason",
  //   };
  //   examApi(info, function(data) {
  //     console.log(data);
  //     console.log("-- history --" + data + ":" + self.accessOnce);
  //     console.log($scope.retries);
  //     self.examHistoryCounter = data.total;
  //     self.examPassCounter = data.pass || 0;
  //     if (self.accessOnce == "1" && self.examHistoryCounter > 0 && _type != "test") {
  //       console.log("Have record, can not start test!");
  //       self.stopInfo = $filter('trans')({
  //         eng: "You have done the Test!",
  //         chn: '已完成考试'
  //       });
  //       $timeout(function() {
  //         self.stopTest = false;
  //       }, 200);
  //     }
  //     if ($scope.retries && self.examHistoryCounter >= $scope.retries && $scope.retries != 0) {
  //       $state.go('app.formal.startpage', {
  //         id: $stateParams.id,
  //         type: _type
  //       });
  //     }
  //     //isAllowedRetest();
  //   });
  // };
  function clearStyle(q) {
    if (q.answer) {
      angular.forEach(q.answer, function(val, idx) {
        console.log(val);
        //angular.isString(val) && (q.answer[idx] = stringHelper.removeInvalidSymbol(val));
        //angular.isString(q.answer[idx]) && (q.answer[idx] = stringHelper.clearHtmlStrStyle(q.answer[idx]));
      });
    }
    if (q._options) {
      angular.forEach(q._options, function(val, idx) {
        console.log(val);
        //angular.isString(val.text) && (q._options[idx].text = stringHelper.removeInvalidSymbol(val.text));
        //angular.isString(q.options[idx].text) && (q.options[idx].text =  stringHelper.clearHtmlStrStyle(q.options[idx].text));
      });
    }
    if (q.content) {
      //angular.isString(q.content) && (q.content = stringHelper.removeInvalidSymbol(q.content));
      //angular.isString(q.content) && (q.content = stringHelper.clearPositionStyle(q.content));
      //angular.isString(q.content) && (q.content =  stringHelper.clearHtmlStrStyle(q.content));
    }
    console.log(q);
  }
  var dropTargetMap = {};
  var multiMatchTargetMap = {};

  function initTargetList() {
    var multiTargetList = [];
    for (var i = 0; i < 100; i++) {
      multiTargetList.push({});
    }
    return multiTargetList;
  }
  this.shuffleArray = function(array) {
    var m = array.length,
      t, i;
    // While there remain elements to shuffle
    while (m) {
      // Pick a remaining element…
      i = Math.floor(Math.random() * m--);
      // And swap it with the current element.
      t = array[m];
      array[m] = array[i];
      array[i] = t;
    }
    return array;
  }
  $scope.dissQue = function() {
    $scope.queShow = false;
  }
  $scope.clickQue = function() {
    $scope.queShow = true;
  }
  this.gotoQuestion = function(idx) {
    //console.log(self.exam);
    console.log(self.exam.questions)
    self.CurrQIdx = idx;
    self.fullsize = false;
    self.commentIndex = 0;
    if (idx >= 0 && idx <= self.exam.questions.length) {
      self.currentQ = idx;
      self.question = self.exam.questions[idx];
      // console.log(self.question);
      if (self.question.content) {
        self.question.content = self.question.content.replace('src="//', 'src="http://');
        self.question.content = self.question.content.replace('src="//', 'src="http://');
      }
      if (self.question.tips && self.question.tips.length) {
        self.question.tip = self.question.tips[0].text;
      }
      console.log("----q change---");
      // console.log(self.question);
      if (self.question.tips) {
        angular.forEach(self.question.tips, function(val, index) {
          if (val.text == '') {
            self.question.tips.splice(index, 1);
          }
        });
      }
      //init drag & drop question
      if (!self.question.shuffle) {
        shuffleMultiQOptions(self.question); //shuffle options
      }
      //var mdd_blank_count = 5;
      ////var mdd_blank_count = stringHelper.getQCountByQContent(self.question.content);
      //self.question.mdd_blank_count = mdd_blank_count;
      self.questionCopy = angular.copy(self.exam.questions[idx]);
      //  console.log(self.questionCopy);
      var dragFlag = self.questionCopy.dragFlag;
      var type = self.questionCopy.type;
      //init drop target for D&D question
      if (dragFlag) {
        if (type === 'single' || type === 'sDD') {
          $scope.singleDropTarget = dropTargetMap[idx] || {};
        } else if (type === 'mfill' || type === 'mDD') {
          $scope.multiTargetList = multiMatchTargetMap[idx] || initTargetList();
          //$scope.multiTargetList =  initTargetList();
          console.log($scope.multiTargetList);
        }
      }
      if (type == 'order') {
        self.question.answered = true;
        self.question.answerd = true;
        self.copyOption = angular.copy(self.question._options);
        if (self.question._options.length != 0) {
          self.shuffleArray(self.copyOption);
        }
        self.question.selection = self.copyOption;
        console.log(self.question.selection);
      }
      //init video path
      $scope.selectedQVdoPath = null;
      //console.log(self.question);
      if (self.question.quesVideoSrc) {
        $timeout(function() {
          $scope.selectedQVdoPath = self.question.quesVideoSrc;
          $scope.$apply();
        }, 0);
      }
    }
    console.log(self.question);
    if (self.question && self.question.type == 'typing') {
      var qCopy = self.question;
      self.question = null;
      $timeout(function() {
        self.question = qCopy;
      }, 0);
    }
    $scope.queShow = false;
    //self.flage = true;
    //if ($localstorage.getFormalRecords(self.courseID, self.paperID)){
    //    $scope.selectQuestionTrue = $localstorage.getFormalRecords(self.courseID, self.paperID);
    //}
    //$localstorage.setFormalRecords(self.courseID, self.paperID, self.currentQ, self.exam.questions[0]._id, self.flage);
  };
  this.gotoSpecificQuestion = function(idx) {
    //console.log(self.exam);
    self.CurrQIdx = idx;
    self.fullsize = false;
    self.commentIndex = 0;
    if (idx >= 0 && idx <= self.exam.questions.length) {
      self.currentQ = idx - 1;
      self.question = self.exam.questions[idx - 1];
      // console.log(self.question);
      if (self.question.tips && self.question.tips.length) {
        self.question.tip = self.question.tips[0].text;
      }
      console.log("----q change---");
      // console.log(self.question);
      if (self.question.tips) {
        angular.forEach(self.question.tips, function(val, index) {
          if (val.text == '') {
            self.question.tips.splice(index, 1);
          }
        });
      }
      //init drag & drop question
      if (!self.question.shuffle) {
        shuffleMultiQOptions(self.question); //shuffle options
      }
      //var mdd_blank_count = 5;
      ////var mdd_blank_count = stringHelper.getQCountByQContent(self.question.content);
      //self.question.mdd_blank_count = mdd_blank_count;
      self.questionCopy = angular.copy(self.exam.questions[self.currentQ]);
      //  console.log(self.questionCopy);
      var dragFlag = self.questionCopy.dragFlag;
      var type = self.questionCopy.type;
      //init drop target for D&D question
      if (dragFlag) {
        if (type === 'single' || type === 'sDD') {
          $scope.singleDropTarget = dropTargetMap[idx] || {};
        } else if (type === 'mfill' || type === 'mDD') {
          $scope.multiTargetList = multiMatchTargetMap[idx] || initTargetList();
          //$scope.multiTargetList =  initTargetList();
          console.log($scope.multiTargetList);
        }
      }
      if (type == 'order') {
        self.question.answered = true;
        self.question.answerd = true;
        self.copyOption = angular.copy(self.question._options);
        if (self.question._options.length != 0) {
          self.shuffleArray(self.copyOption);
        }
        self.question.selection = self.copyOption;
        console.log(self.question.selection);
      }
      //init video path
      $scope.selectedQVdoPath = null;
      //console.log(self.question);
      if (self.question.quesVideoSrc) {
        $timeout(function() {
          $scope.selectedQVdoPath = self.question.quesVideoSrc;
          $scope.$apply();
        }, 0);
      }
      $scope.queShow = false;
    }
    console.log(self.question);
    if (self.question && self.question.type == 'typing') {
      var qCopy = self.question;
      self.question = null;
      $timeout(function() {
        self.question = qCopy;
      }, 0);
    }
    //$scope.queShow = false;
    //if ($localstorage.getFormalRecords(self.courseID, self.paperID)){
    //    $scope.selectQuestionTrue = $localstorage.getFormalRecords(self.courseID, self.paperID);
    //}
    //$localstorage.setFormalRecords(self.courseID, self.paperID, self.currentQ, self.exam.questions[0]._id, self.flage);
  };
  this.selectSingle = function(index) {
    self.question.select = index;
  }
  this.answerQ = function(q) {
    q.answered = true;
    q.answerd = true;
  }
  // for drag and drop
  $scope.selectSingle = function(opt) {
    console.log(opt);
    self.question.result = opt.text;
    //self.question.selected = opt.index;
    self.question.answerd = true;
    self.question.answered = true;
    $scope.singleDropTarget = opt;
    dropTargetMap[self.CurrQIdx] = opt;
    console.log(self.question);
    console.log(self.exam);
    ///dropTargetMap[self.CurrQIdx] = $scope.singleDropTarget;
  }
  $scope.selectMultiMatch = function(opt, idx) {
    console.log(opt, idx);
    //self.question.options[idx]  = opt;
    //self.question.options[idx].answer = opt.text;
    console.log($scope.multiTargetList);
    $scope.multiTargetList[idx] = opt;
    //back up user answer
    multiMatchTargetMap[self.CurrQIdx] = $scope.multiTargetList;
    angular.forEach($scope.multiTargetList, function(val, index) {
      //console.log(index);
      if (self.question._options[index]) {
        self.question._options[index].answer = val.text;
      }
    });
    self.question.answerd = true;
    console.log(self.question);
    //console.log(multiMatchTargetMap);
  }

  function shuffleMultiQOptions(q) {
    // console.log('shuffleMultiQOptions');
    if (q && (q.type === 'sDD' || q.type === 'mDD')) {
      //if (q.content) {
      //  q.content = q.content.replace('src="//', 'src="http://');
      //  q.content = q.content.replace('src="//', 'src="http://');
      //}
      q._options.forEach(function(val, idx) {
        // console.log(val);
        if (val.originIdx || val.originIdx == 0) {} else {
          val.originIdx = idx;
        }
      });
      q._options = _.shuffle(q._options);
      // console.log(q);
      q.shuffle = true;
    }
  }
  //add result to typing question
  this.updateTypingResult = function(q) {
    console.log(q);
    self.question.getScore = q.getScore;
    self.question.result = q.result;
    self.question.correctRate = q.correctRate;
    self.question.taken = true;
  }

  function swapArrEle(array, idx1, idx2) {
    var temp = array[idx1];
    array[idx1] = array[idx2];
    array[idx2] = temp;
  }
  this.submit = function() {
    //if (timeoutFlag) {
    //  delete $localStorage[self.userID + self.paperID];
    //  $localStorage[self.userID + self.paperID] = undefined;
    //  self.clearStorageFlag = true;
    //  self.systemSubmit();
    //  return;
    //}
    //var options = {
    //  title: $translate.instant("Confirm"),
    //  message: $translate.instant("Are you sure you want to submit ? Please make sure you do not leave any questions unanswered ."),
    //  button: $translate.instant("YES"),
    //  button_dismiss: $translate.instant("NO"),
    //  icon: "fa fa-exclamation-triangle fa-3x  text-danger"
    //};
    //CommonService.showConfirmDlg(options, function(data) {
    //  delete $localStorage[self.userID + self.paperID];
    //  $localStorage[self.userID + self.paperID] = undefined;
    //  self.clearStorageFlag = true;
    //  self.systemSubmit();
    //}, function(data) {
    //  console.log(data);
    //});
    self.submitConfirmationMessageBox = CommonService.showConfirm("您确定要提交吗？", function() {
      var exam = self.exam;
      self.hideQuestion = !self.review;
      var _result = ExamService.calResult(exam);
      _result.type = self.type;
      _result.eid = exam._id;
      _result.reasonid = _eid;
      _result.reasontype = _type;
      //scores:get_score,
      _result.time = self.use_time;
      $scope.timespent = self.use_time;
      _result.action = "saveexamrecord";
      self.systemSubmit();
      deregisterFunction();
      // if (self.courseID || exam.cid) {
      //   _result.cid = self.courseID || exam.cid; // course id higher than paper cid
      // }
      // if (_type == 'test') {
      //   _result.action = "savetestrecord";
      // } else if (_type == 'error' || _type == 'personal') {
      //   _result.action = "saveerrorrecord";
      // }
      // // console.log(_result);
      // self.submitted = true;
      // _result.photo= $localstorage.get('imageFileExam');
      // console.log(_result);
      // // to avoid the resumit for long time.
      // examApi(_result, function (data) {
      //   self.submitted = true;
      //   self.score_percentage = exam.get_score / exam.totalScore;
      //   //self.submitted = true;
      //   console.log("submit success");
      //   console.log(self.submitted);
      // });
      //$localstorage.setFormalRecords(self.courseID, self.paperID, self.currentQ, self.exam.questions[0]._id, self.flage);
    });
  }
  this.timeSubmit = function() {
    deregisterFunction();

    if(self.submitConfirmationMessageBox) {
      self.submitConfirmationMessageBox.close();
    }

    var exam = self.exam;
    self.hideQuestion = !self.review;
    var _result = ExamService.calResult(exam);
    _result.type = self.type;
    _result.eid = exam._id;
    _result.reasonid = _eid;
    _result.reasontype = _type;
    //scores:get_score,
    _result.time = self.use_time;
    $scope.timespent = self.use_time;
    _result.action = "saveexamrecord";
    self.systemSubmit();
    CommonService.showInfo("考试时间已到，试卷已被自动提交！");
    //});
  }
  this.systemSubmit = function() {
    // if (_type == 'exam' || _type == 'test') {
      saveExamRecords();
      // var info = {
      //   action: (_type == 'exam') ? "getFormalWithStatus" : "gettestitem",
      //   id: _eid
      // };
      // console.log(info);
      // examApi(info, function(data) {
      //   console.log(data);
      //   if (data && data.pass) {
      //     self.goodScore = data.good;
      //     self.passScore = data.pass;
      //     saveExamRecords();
      //   } else {
      //     saveExamRecords();
      //   }
      // });
    // }
  }
  this.clickQ = function() {
    //  console.log(self.question)
    self.question._answered = true;
  }

  function saveExamRecords() {
    self.hideQuestion = !self.review;
    var exam = self.exam;
    // console.log(exam);
    $scope.passExamFlag = false;
    var _result = ExamService.calResult(exam);
    console.log(_result);
    console.log(exam);
    _result.type = self.type;
    _result.eid = exam._id;
    _result.reasonid = _eid;
    _result.reasontype = _type;
    _result.photo = $localstorage.get('imageFileExam');
    //scores:get_score,
    _result.time = self.use_time;
    $scope.timespent = self.use_time;
    _result.action = "saveFormalRecord";
    if (_type == 'test') {
      _result.action = "savetestrecord";
    }
    console.log('--- before submit ---');
    console.log(_result);
    //add pass and good flag
    console.log(self.passScore);
    console.log(_result.totalscores);
    if ((self.passScore || self.passScore == 0) && _result.totalscores && _result.score && (_result.score >= self.passScore)) {
      _result.pass = true;
      $scope.passExamFlag = true
    }

    if (_type == 'fast') {
      self.submitted = true;
      $localstorage.addCurrentDayExamCounter(_eid);
      return
    }

    if (_type == 'simulate') {
      self.submitted = true;
      return
    }

    // if ((self.goodScore || self.goodScore == 0) && _result.totalscores && (_result.score || _result.score == 0) && (_result.score >= self.goodScore)) {
    //   _result.pass = _result.good = true;
    // }
    //_result.photo=$localStorage.lastUserPhoto;
    console.log(_result);
    filterDotOfKnowledges(_result.knowledgeresult);
    examApi(_result, function(data) {
      console.log(data);
      self.score_percentage = exam.get_score / exam.totalScore;
      //self.submitted = true;
      self.submitted = true;
      //$localStorage.lastUserPhoto=null;
      $scope.passExamFlag = data.pass || false;
      console.log("submit success");
      // if (self.sTimer == "00 : 0") {
      //   CommonService.showInfo("考试时间已到，试卷已被自动提交！");
      // }
      //$interval.cancel(inTimer);
      console.log(self.score_percentage);
      $scope.singleDropTarget = {};
      $scope.multiTargetList = [];
      multiMatchTargetMap = {};
      dropTargetMap = {};
      console.log(self.exam);
    });
  }

  function filterDotOfKnowledges(knowledgeresult) {
    console.log(knowledgeresult);
    for (var property in knowledgeresult) {
      if (property.indexOf('.') >= 0) {
        var oldname = property;
        var newname = property.replace('.', '');
        rename(knowledgeresult, oldname, newname);
      }
    }
    console.log(knowledgeresult);
  }

  function rename(obj, oldName, newName) {
    if (!obj.hasOwnProperty(oldName)) {
      return false;
    }
    obj[newName] = obj[oldName];
    delete obj[oldName];
    return true;
  }
  this.viewResult = function() {
    self.showResult = true;
  }
  this.backtolist = function() {
    //$state.go('app.formal');
    if (_type == 'fast'||_type == 'simulate') {
      $ionicHistory.goBack();
    } else if (_type == 'exam') {
      $ionicHistory.goBack(-2);
    }
  };

  function init() {
    console.log(_type + ":" + _eid);
    console.log("-----------------init-----------------");

    function prepareTest(data) {
      console.log(data);
      self.id = data.eid;
      self.createrName = data.createrName;
      self.type = data.type;
      self.accessOnce = data.oneaccess;
      self.review = data.review;
      self.title = data.name;
      self.description = data.description;
      self.imgUrl = data.photo;
      self.courseID = data.cid;
      self.passOnce = data.passOnce;
      self.scoresFlag = data.scoresFlag;
      self.goodScore = data.good;
      self.passScore = data.pass;
      self.ranking = data.ranking;
      self.closebookFlag = true;
      self.lostFoucsFlag = true;
      loadPaper();
      // loadExamHistory();
      //if ($localstorage.getFormalRecords(self.courseID, self.paperID)){
      //    $scope.selectQuestionTrue = $localstorage.getFormalRecords(self.courseID, self.paperID);
      //}
    }
    switch (_type) {
      case 'exam':
        var info = {
          action: "getFormalWithStatus",
          id: _eid,
        };
        console.log(info);
        examApi(info, function(data) {
          console.log(data)
          if (data) {
            $scope.courseID = data.cid;
            console.info("---data------");
            console.info(data);
            $scope.retries = data.retries;
            prepareTest(data);
            //if ($localstorage.getFormalRecords(self.courseID, self.paperID)){
            //    $scope.selectQuestionTrue = $localstorage.getFormalRecords(self.courseID, self.paperID);
            //}
          } else {
            console.log("error: data is null");
          }
        });
        break;
      case 'fast':
      case 'simulate':
        var info = {
          action: "getFormalExam",
          id: _eid,
        };
        console.log(info);
        examApi(info, function(data) {
          console.log(data)
          if (data) {
            // $scope.courseID = data.cid;
            console.info("---data------");
            console.info(data);
            // $scope.retries = data.retries;
            prepareTest(data);
          } else {
            console.log("error: data is null");
          }
        });
        break;
      case 'test':
        var info = {
          action: "gettestitem",
          id: _eid,
        };
        console.log(info);
        examApi(info, function(data) {
          prepareTest(data);
        });
        break;
    }
  }
  //if (loginService.isLogged&&$localStorage.lastUserPhoto) {
  init();
  //} else {
  //  $state.go('index.formal.startpage',{type:_type,id:_eid});
  //  console.log(_eid);
  //}
  function examApi(info, callback) {
    ApiService.post('/exam', info).then(function(result) {
      console.log(result);
      if (result.data.success) {
        if (!callback) {
          CommonService.showInfo('Update Successful!');
        } else {
          callback(result.data.data);
        }
      }
    });
  }

  function isAllowedRetest() {
    console.log(self.examHistoryCounter, $scope.retries);
    if (self.examHistoryCounter >= $scope.retries && $scope.retries != 0 && ($state.current.name.indexOf("startpage") < 0)) {
      //self.return();
      //CommonService.showInfo(self.REASON);
      self.description = $filter('trans')({
        eng: 'Sorry,you can not take the test again because you can only take a limited number of times!',
        chn: '很抱歉，您不能进行答题，因答题次数已到达限制!'
      });
      CommonService.showInfo(self.description);
      //$timeout(function() {
      //  $window.location.href = '/#/courselist//course/';
      //}, 1000);
    }
  }
  this.retest = function() {
    console.log(self.examHistoryCounter);
    console.log($scope.retries);
    if (self.examHistoryCounter >= ($scope.retries - 1) && $scope.retries != 0) {
      //CommonService.showInfo(self.REASON);
      self.description = $filter('trans')({
        eng: 'Sorry,you can not take the test again because you can only take a limited number of times!',
        chn: '很抱歉，您不能进行答题，因答题次数已到达限制!'
      });
      CommonService.showInfo(self.description);
      return;
    }
    self.use_time = 0;
    //$state.go();
    // $state.go('index.exams.test', {
    //   id: $stateParams.id,
    //   type: _type
    // });
    //$scope.popup = false;
    init();
    lauchInTimer();
  }
  $scope.numToLetters = function(num) {
    return String.fromCharCode(65 + num);
  };

  function getCheckSum(_cs) {
    if (!_cs) {
      return 'a1b1c2';
    }
    var len = _cs.length;
    var start = 0;
    if (len > 8) {
      start = len - 8;
    }
    var chk = 0;
    for (var i = start; i < len; i++) {
      chk += (_cs.charCodeAt(i) * (i + 1));
    }
    return (chk & 0xffffffff).toString(16);
    // return md5.createHash(_cs);
  }
  this.return = function() {
    //if ($localStorage.referralURL) {
    //  var Url = $localStorage.referralURL;
    //  $localStorage.referralURL = null;
    //  $window.location.href = Url;
    //} else if (self.courseID) {
    //  console.log('return to url : /#/courselist//course/' + self.courseID);
    //  $window.location.href = '/#/courselist//course/' + self.courseID + "/" + getCheckSum(self.courseID);
    //} else {
    //  $state.go('^');
    //}
  };
  this.exit = function() {
    var conf = {
      title: $translate.instant("Warning"),
      message: $translate.instant("Are you sure you want to exit the exam ?")
    }
    self.exitFlag = true;
    CommonService.showConfirmDlg(conf, function() {
      self.return();
    });
  }
  var options = {
    title: $translate.instant("Warning"),
    message: $translate.instant("The exam page lost focus ! Click Cancel to go back exam otherwise the system is going to submit the exam after 3s automatically ."),
    button: $translate.instant("Ok"),
    button_dismiss: $translate.instant("Cancel")
    //icon:options.icon;
  };
  /* var options = {
   title: "Warning",
   message: "The exam page lost focus ! Click Cancel to go back exam otherwise the system is going to submit the exam after 3s automatically .",
   button: "Ok",
   button_dismiss: "Cancel"
   //icon:options.icon;
   };*/
  var ExitWarningOptions = {
    content: $translate.instant("Do you really want to exit the exam ? The data maybe lost ."),
    title: 'Confirm',
    icon: "text-warning fa fa-question-circle fa-3x",
    btn_confirm: $translate.instant("Ok")
  };
  var onFocus = function() {
    console.log("onfocus");
  }
  var onBlur = function() {
    console.log("onBlur");
    console.log(self.closebookFlag);
    //if (self.closebookFlag && !self.submitted) {
    //  $scope.popup = true;
    //  //CommonService.countDownDlg(options, function(data) {
    //  //  console.log(data);
    //  //  $scope.popup = true;
    //  //  self.systemSubmit();
    //  //  //self.submitted = true;
    //  //}, function(data) {
    //  //  console.log(data);
    //  //  $scope.popup = false;
    //  //});
    //} else {
    //  if ( !self.closebookFlag && !$scope.ExitPopUp && !self.submitted && self.lostFoucsFlag) {
    //    $scope.ExitPopUp = true;
    //    //DlgHelper.openSimpleDlg(ExitWarningOptions, function(data) {
    //    //  $scope.ExitPopUp = false;
    //    //}, function() {
    //    //  $scope.ExitPopUp = false;
    //    //});
    //  }
    //}
  }
  $window.onfocus = onFocus;
  $window.onblur = onBlur;
  // function initRetakeFlag() {
  //   $scope.retakeFlag = true;
  //   switch (loginService.subDomain) {
  //     case "caregiverasia":
  //       $scope.retakeFlag = false;
  //       break;
  //     default:
  //       $scope.retakeFlag = true;
  //       break;
  //   }
  // }
  // initRetakeFlag();
  this.start = function() {
    console.log(self.examHistoryCounter);
    console.log($scope.retries);
    console.log(self.passOnce);
    console.log(self.examPassCounter);
    if (self.passOnce && self.examPassCounter > 0) {
      CommonService.showInfo("You have passed this exam already and are not allowed to take the exam again !");
      return;
    }
    if (self.examHistoryCounter >= $scope.retries && $scope.retries != 0) {
      //CommonService.showInfo(self.REASON);
      self.description = $filter('trans')({
        eng: 'Sorry,you can not take the test again because you can only take a limited number of times!',
        chn: '很抱歉，您不能进行答题，因答题次数已到达限制!'
      });
      CommonService.showInfo(self.description);
      return;
    }
    var params = {
      type: _type,
      id: self.eid,
      task: _task
    }
    console.log(params);
    $state.go('^.test', params);
  };
  // function initResultInfo() {
  //   $scope.resultSuccessInfo = "<span class='result_hed' translate>Congratulations!</span> <span class='result_success'>" + $translate.instant("You have passed the") + " <b> " + self.exam.title + "</b> " + $translate.instant("Exam") + "!</span>";
  //   $scope.resultFailInfo = "<span class='result_fail'>" + $translate.instant("You have failed the") + " <b> " + self.exam.title + " </b> " + $translate.instant("Exam") + ".</span>";
  // }
  //}
  var lastTransition = null;
  $scope.$on('$stateChangeStart', function(event, toState, toParams, fromState, fromParams) {
    console.log(toState.name);
    console.log(fromState.name);
    console.log(lastTransition);
    console.log(self.exitFlag);
    if (self.exitFlag) {
      return
    };
    //stop show confirm loop
    if (lastTransition === toState.name) {
      return;
    }
    //if (!stateHelper.stateInclude('startpage') && toState.name != fromState.name && !$scope.ExitPopUp && !self.submitted && self.lostFoucsFlag) {
    //  event.preventDefault();
    //  $scope.ExitPopUp = true;
    //  //DlgHelper.openSimpleDlg(ExitWarningOptions, function(data) {
    //  //  //$state.go('index.home');
    //  //  $scope.ExitPopUp = false;
    //  //}, function() {
    //  //  $scope.ExitPopUp = false;
    //  //});
    //}
  })
  $scope.getTrustAsHtml = function(str) {
    return s.unescapeHTML(str);
  }
  //-------------------------------------------
  $scope.startCallback = function(event, ui, title) {
    console.log('You started draggin: ' + title.title);
    //$scope.draggedTitle = title.title;
  };
  $scope.stopCallback = function(event, ui) {
    console.log('Why did you stop draggin me?');
    console.log($scope.singleDragTarget);
    console.log($scope.singleDropTarget);
  };
  $scope.dragCallback = function(event, ui) {
    console.log('hey, look I`m flying');
  };
  $scope.dropCallback = function(event, ui) {
    console.log('hey, you dumped me :-(');
  };
  $scope.overCallback = function(event, ui) {
    console.log('Look, I`m over you');
  };
  $scope.outCallback = function(event, ui) {
    console.log('I`m not, hehe');
  };
  this.showTips = function(tips) {
    console.log(tips);
  }
});
