angular.module('bamboo.formal').controller('MyExamsCtrl', function ($scope, ApiService,utilService, CommonService,$state, MystudyService, loginService,AppConfig, CourseService, $filter) {
  var _self = this;
  var distanceRule = loginService.school.sessionAccessRules;
  _self.tmpUser=loginService.user;
  var examHours=distanceRule.examHours||3;
  $scope.$on('$ionicView.Enter', function () {
    $scope.getInfo();
  })
  _self.pass=[];
  _self.nopass=[];
  var allowed=new Date((new Date()).getTime()-(examHours*3600*1000));
  console.log(allowed,examHours);
  $scope.getInfo=function() {
    var examinfo = {
      action: 'getMyFormalExams',
    }
    console.log(examinfo);
    ApiService.post('/exam', examinfo).then(function(result) {
      console.log("-------!!--------");
      console.log(result.data.data);
      $scope.examitems=result.data.data || 0;

      var completed=0;
      angular.forEach($scope.examitems,function(item){
        item.allowToExam=true;
        if(item.status){
          if(item.status.pass){
           _self.pass.push(item);
            completed++;
          }else{
            if(item.status.last && (new Date(item.status.last)>allowed)){
              item.allowToExam=false;
            }
            _self.nopass.push(item);
          }
        }else{
          _self.nopass.push(item);
        }
      })
      _self.completed=completed;
      _self.outstanding = $scope.examitems.length - completed;

    });
  }
  $scope.getInfo();

  this.goToExam=function(exam){
    if(!exam.allowToExam){
      CommonService.showError('距离上一次考试时间过近，请等待！');
      return;
    }
    if(!exam.zhuangtai){
      CommonService.showError('您的信息尚未被企业确认，请联系企业确认后方能参加考试！');
      return;
    }
    $state.go('app.formal.startpage',{type: "exam", id: exam._id});
  }

  utilService.watchScroll($scope);
});
