// Ionic Starter App
// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('bamboo.forum', ['ionic'])
  .config(function($stateProvider, $urlRouterProvider) {
    $stateProvider.state('app.forums', {
      url: '/forums/:cat',
      views: {
        'Content@app': {
          templateUrl: 'app/forum/course_list.html',
          controller: 'CourseListCtrl as ctrl'
        }
      },
      data_rightbutton: {
        url: "app.forums.category",
        icon: "ion-ios-more",
      }
    }).state('app.forums.list', {
      url: '/List/:cid',
      views: {
        'Content@app': {
          templateUrl: 'app/forum/course_forum_list.html',
          controller: 'CourseForumsCtrl as ctrl'
        }
      },
      data_rightbutton: {
        url: "app.forums.list.addnew",
        icon: "ion-android-add",
      }

    }).state('app.forums.category', {
      url: '/new',
      views: {
        'Content@app': {
          templateUrl: 'app/forum/category.html',
          controller: 'ForumCategoryCtrl as ctrl'
        }
      }

    }).state('app.forums.list.addnew', {
      url: '/new',
      views: {
        'Content@app': {
          templateUrl: 'app/forum/add_new.html',
          controller: 'TopicNewCtrl as ctrl'
        }
      }
    }).state('app.forums.list.detail', {
      url: '/detail/:id',
      views: {
        'Content@app': {
          templateUrl: 'app/forum/forum_detail.html',
          controller: 'TopicItemCtrl as ctrl'
        }
      }
    }).state('app.mycourseforum', {
      url: '/mycourseforums',
      views: {
        'Content@app': {
          templateUrl: 'app/forum/mycourseforum_course_list.html',
          controller: 'MyCoursesCtrl as ctrl'
        }
      }
    })
  });