angular.module('bamboo.grade').controller('gradeCtrl', function($scope, CommonService, ApiService) {
  // body...
  _self = this;
  function examApi(info, callback) {
    ApiService.post('/exam', info).then(function(result) {
      if (result.data.success) {
        if (!callback) {
          CommonService.showNoBlockSuccess('Update Successful!');
        } else {
          callback(result.data.data);
        }
      }
    });
  }

  function getRecord() {
    var info = {
      start: 0,
      limit: Number.MAX_SAFE_INTEGER,
      action: "getuserexamrecords",
    };
    console.log(info);
    examApi(info, function(data) {
      console.log(data);
      $scope.examrecords = data.items;
      $scope.totalrecords = data.counter;
    });
  }
  getRecord();


});