angular.module('bamboo.course').controller('SearchCtrl', function ($scope, $ionicScrollDelegate, $stateParams, loginService, ApiService, CommonService, $timeout, CourseApi, $state, $rootScope, utilService, $localstorage) {
  var self = this;
  console.log('SearchCtrl');
  this.isResult = true;
  function compareMyCourses(item) {
    console.log('--- compare my courses --');
    if (!loginService.user) {
      // angular.forEach(item, function(item, index) {
      item.state = "app.course.info";
      // })
      return;
    }
    // console.log("Mycourses", mycourses);
    if (loginService.user.courses && loginService.user.courses.length > 0) {
      if (loginService.user.courses.index(item._id) > -1) {
        item.state = "app.course.home";
        return;
      }
    }
    item.state = "app.course.info";

  }

  var defaultUseCasePhoto = 'img/usecase.jpg';
  var useCaseUrl = ApiService.SHOST + '/advinfo/';
  var defaultCoursePhoto = ApiService.SHOST + '/public/images/videos.png';
  var courseUrl = ApiService.SHOST + '/lcourse/';
  var defaultNewsPhoto = 'images/news.jpg';
  var defaultBuildPhoto = "images/classroom.jpg";
  var newsPhotoUrl = ApiService.SHOST + "/public/" + ApiService.RES + "/schoolnews/";
  var buildingurl = ApiService.SHOST + "/schoolbuilding/null/";
  ApiService.getSchoolInfo().then(function () {
    if (ApiService.school.coursephoto) {
      defaultCoursePhoto = ApiService.SHOST + "/site/" + ApiService.school.coursephoto;
    }
  });
  function search(q) {
    var info = {
      action: 'topSearch',
      name: q,
    }
    console.log(info);

    ApiService.post('/site', info).then(function (result) {
      console.log(result);
      if (result.data.data) {
        var toDisplays = [];
        angular.forEach(result.data.data, function (value, key) {
          self.isResult = false;
          console.log(value, key);
          switch (key) {
            case 'usecases':
              if (value && value.length) {
                angular.forEach(value, function (item) {
                  item.photourl = item.photo ? useCaseUrl + item.photo : defaultUseCasePhoto;
                  item.state = 'app.usecase.detail';
                  item.type = 'usecase';
                  toDisplays.push(item);
                })
              }
              break;
            case 'courses':
              if (value && value.length) {
                angular.forEach(value, function (item) {
                  compareMyCourses(item);
                  item.photourl = item.photo ? courseUrl + item._id + '/' + item.photo : defaultCoursePhoto;
                  item.type = 'course';
                  toDisplays.push(item);
                })
              }
              break;
            case 'newses':
              if (value && value.length) {
                angular.forEach(value, function (item) {
                  item.photourl = item.photo ? newsPhotoUrl + item._id + '/' + item.photo : defaultNewsPhoto;
                  item.type = 'news';
                  item.state = "app.news.detail";
                  toDisplays.push(item);
                })
              }
              break;
            case 'building':
              if (value && value.length) {
                angular.forEach(value, function (item) {
                  item.photourl = item.photo ? buildingurl + item.photo : defaultBuildPhoto;
                  item.type = 'building';
                  item.state = "app.validbuildings.records";
                  toDisplays.push(item);
                })
              }
              break;
            default:
              console.log("unknow type", key);
              break;
          }

        });
      } else {
        self.isResult = true;
      }
      self.toDisplays = toDisplays;
      console.log(toDisplays);
    });
  }

  this.searchByName = function (q) {
    if (ApiService.gid) {
      search(q)
    } else {
      ApiService.getSchoolInfo().then(function () {
        search(q)
      });
    }
  };
  $scope.$on('$ionicView.afterLeave', function () {

  })
  //$ionicView.afterLeave
});
