angular.module('bamboo.job', ['ionic', "ionic.native", "ionic.utils"]).config(function($stateProvider, $urlRouterProvider) {
  $stateProvider.state('app.job', {
    url: '/job/:cat',
    views: {
      'Content@app': {
        templateUrl: 'app/job/joblist.html',
        controller: 'JobListCtrl as ctrl',
      }
    },
  }).state('app.job.category', {
    url: '/category',
    views: {
      'Content@app': {
        templateUrl: 'app/job/jobcategory.html',
        controller: 'JobCategoryCtrl as ctrl',
      }
    }
  }).state('app.job.detail', {
    url: '/detail/:jid',
    views: {
      'Content@app': {
        templateUrl: 'app/job/jobdetail.html',
        controller: 'JobDetailCtrl as ctrl',
      }
    },
  }).state('app.job.detail.application', {
    url: '/application',
    views: {
      'Content@app': {
        templateUrl: 'app/job/application.html',
        controller: 'JobApplicationCtrl as ctrl',
      }
    },
  });
});