/**
 * Created by root on 8/19/2019.
 */
'use strict';
// coffeescript's for in loop
var __indexOf = [].indexOf || function(item) {
  for (var i = 0, l = this.length; i < l; i++) {
    if (i in this && this[i] === item) return i;
  }
  return -1;
};
angular.module('bamboo').controller('CreateUserCtrl', function($scope, $rootScope, $interval, ApiService, AppConfig, CommonService, loginService, $state, $stateParams, $timeout, formService, $localstorage, $translate) {
  this.userCredentials = {};
  this.company = {};
  var self = this;
  $scope.datePicker = {};
  $scope.regex = /^(?=.*\d)(?=.*[a-z])(?=.*[A-Z])[0-9a-zA-Z]{8,}$/;
  $scope.readTerm = false;
  /**
   * get local footer register data
   */
  // if (localStorageHelper.get('FOOTER_SIGNUP_DATA')) {
  //   self.userCredentials = localStorageHelper.get('FOOTER_SIGNUP_DATA');
  // }
  /**
   * get local normal register data
   */
  // if (localStorageHelper.get('REGISTER_INFO')) {
  //   self.userCredentials = localStorageHelper.get('REGISTER_INFO');
  // }
  if ($localstorage.getObject("userCredentials")) {
    console.log($localstorage.getObject("userCredentials"));
    this.userCredentials = $localstorage.getObject("userCredentials");
    delete $localstorage.getObject("$localstorage");
  } else {
    $state.go('app.config.register');
  }
  self.regWizardstep = 0;
  this.isverifycode = false;
  this.smsVerify = true;
  // if (ApiService.school.smsVerification) {
  //   self.regWizardstep = 0;
  //   self.smsVerify = true;
  // }
  $scope.submitted = false;
  // this.role = $stateParams.role;
  // console.log(this.role);
  //$scope.userTypes = g_userTypes;
  //$scope.edus = g_edus;
  // $scope.jobTitles = g_jobTitles;
  //$scope.provinces = g_provinces;
  this.wizardstep = 0;
  this.maxstep = 0;
  this.backtostep = function(step) {
    self.wizardstep = step;
    if (self.wizardstep > self.maxstep) {
      self.maxstep = self.wizardstep;
    }
  }
  this.nextfrombasic = function(form) {
    $scope.submitted = true;
    console.log(form);
    if (form.$invalid) {
      $scope.shaking = true;
      $timeout(function() {
        $scope.shaking = false;
      }, 500);
      console.log(form.$invalid);
      return;
    }
    $scope.submitted = false;
    self.wizardstep = 1;
    if (self.wizardstep > self.maxstep) {
      self.maxstep = self.wizardstep;
    }
  }
  //var nurseProfile = isNurseProfile($rootScope.currentSchool);
  //if (nurseProfile) {
  //    this.userCredentials.user_profiles = getInitNurseProfile();
  //    $scope.userProfiles = this.userCredentials.user_profiles;
  //}
  //if (loginService.school.userProfiledoc) {
  //    var userProfiledoc = loginService.school.userProfiledoc;
  //    console.log(userProfiledoc);
  //}
  //$rootScope.$watch('currentLanguage', function (newValue, oldValue) {
  //    if (nurseProfile) {
  //        notifyLocaleChanged($scope.userProfiles);
  //    }
  //});
  this.nextform2 = function(form) {
    $scope.submitted = true;
    console.log(form);
    if (form.$invalid) {
      $scope.shaking = true;
      $timeout(function() {
        $scope.shaking = false;
      }, 500);
      console.log(form.$invalid);
      return;
    }
    $scope.submitted = false;
    self.wizardstep = 2;
    if (self.wizardstep > self.maxstep) {
      self.maxstep = self.wizardstep;
    }
    console.log(self.userCredentials);
    console.log(self.company);
  }
  this.argee = function() {
    $scope.readTerm = !$scope.readTerm;
  }
  this.register = function(flag) {
    $scope.submitted = true;
   // this.userCredentials.user_profiles = formService.getFormData();
    if (!flag) {
      if (form.$invalid) {
        $scope.shaking = true;
        $timeout(function() {
          $scope.shaking = false;
        }, 500);
        return;
      }
    }
    if (self.userCredentials.pass==undefined) {
      CommonService.showError("输入的密码不得少于6个字符！");
      return;
    } if (self.userCredentials.re_pass==undefined) {
      CommonService.showError("输入的确认密码不得少于6个字符！");
      return;
    }

    var info = JSON.parse(JSON.stringify(self.userCredentials));
    console.info(info);
    if (info.pass != info.re_pass) {
      CommonService.showError("两次密码不匹配！");
      return;
    }
    info.url = ApiService.HOST + "#/active_account";
    //info.ownername = loginService.school.name;
    console.log(info);
    var serverPath = '/smssignup';
    // if (ApiService.school.smsVerification) {
    //   serverPath = '/smssignup';
    // }
    console.log(self.userCredentials);
    CommonService.showLoading();
    ApiService.post(serverPath, info).then(function(result) {
      //console.log(result);
      if (result.data.success) {
        loginService.login(info).then(function(user) {
          $interval.cancel(self.timePromise); //终止倒计时
          CommonService.stopLoading();
          CommonService.showInfo($translate.instant('账号创建成功!请完善用户信息！'), function() {
            $state.go('app.config.update',{
              backShow:true
            });
          })
        });
        return;
      } else {
        CommonService.stopLoading();
        if (result.data.errorCode && AppConfig.ErrorSignUp[result.data.errorCode]) {
          //  console.log(window.sessionStorage.language);
          var _err = AppConfig.ErrorSignUp[result.data.errorCode];
          //if ($rootScope.currentLanguage == 'Chinese') {
          CommonService.showError(_err.cn);
          //} else {
          //    CommonService.showError(_err.en);
          //}
        } else {
          CommonService.showError(result.data.error);
        }
        return;
      }
    });
  };
  $scope.showDatePicker = function(event, key) {
    event.preventDefault();
    event.stopPropagation();
    $scope.datePicker[key] = true;
  };
  //$scope.readTerms = function (form) {
  //    console.log(self.userCredentials);
  //    localStorageHelper.put('REGISTER_INFO', self.userCredentials);
  //    $state.go('index.agreement');
  //}
  var smsSended=false;
  this.requestToken = function() {
    if (!self.userCredentials.mobile || ( self.userCredentials.mobile.length != 11&&self.userCredentials.mobile.length != 8)) {
        CommonService.showError('手机号长度不正确，请重新输入！');
        return;
    }
    if (!(/^1[34578]\d{9}$/.test(self.userCredentials.mobile))) {
        CommonService.showError("手机号码格式有误，请重新输入！");
        return;
    }
    if (self.isverifycode == false) {
      self.isverifycode = true;
      self.isCheck = true;
      var totalSecond = 59; //设置计时总时间（分钟）
      //  self.codeVerify();
      //倒计时
      self.timePromise = $interval(function() {
        $scope.CountDown = true;
        if (totalSecond >= 0) {
          var s = totalSecond < 10 ? "0" + totalSecond : totalSecond;
          totalSecond = totalSecond - 1;
          $scope.payCountDown = s + "秒";
          console.log($scope.payCountDown);
        } else {
          self.isverifycode = false;
          $scope.payCountDown = "发送验证码";
          $interval.cancel(self.timePromise); //终止倒计时
        }
      }, 1000);
    }
    var info = {
      action: 'verifyMobileForCreate',
      mobile: self.userCredentials.mobile,
    }
    ApiService.post('/messages', info).then(function(result) {
      console.log(result);
      if (result.data.success) {
        //self.showTab = 'tab2';
        smsSended=true;
        self.disableReq = true;
      } else {
        if(result.data.error=='error: Mobile Used!'){
          self.isverifycode = false;
          $scope.payCountDown = "发送验证码";
          $interval.cancel(self.timePromise); //终止倒计时
          CommonService.showError('手机号已被其它用户使用，请更换手机号注册！');
        }else{
          CommonService.showError(result.data.error);
        }
      }
    });
  }
  this.verifyToken = function() {
    if(!smsSended){
      return CommonService.showError('请先发送验证码！');
    }
    if (!self.userCredentials.verifycode || self.userCredentials.verifycode.length < 6) {
      CommonService.showError('验证码输入错误，请重新输入！');
      return;
    }
    var isnum = /^\d+$/.test(self.userCredentials.verifycode);
    if (!isnum) {
      CommonService.showError('验证码输入错误，请重新输入！');
      return;
    }
    var info = {
      action: 'checkverification',
      mobile: self.userCredentials.mobile,
      code: self.userCredentials.verifycode
    }
    ApiService.post('/messages', info).then(function(result) {
      console.log(result);
      if (result.data.success) {
        self.regWizardstep = 1;
        $interval.cancel(self.timePromise); //
      } else {
        CommonService.showError($translate.instant('验证码错误！请重新输入！'));
      }
    });
  }
}).service('formService', function() {
  var formData = {};
  return {
    initFormDate: function() {
      formData = {};
      return;
    },
    saveFormData: function(newformdata) {
      angular.forEach(newformdata, function(value, key) {
        formData[key] = value;
      })
      return;
    },
    getFormData: function() {
      return formData;
    }
  }
}).directive('formDirective', function() {
  return {
    controller: function($scope) {
      $scope.submit = function() {
        alert('Form submitted..');
        $scope.form.submitted = true;
      }
      $scope.cancel = function() {
        alert('Form canceled..');
      }
    },
    templateUrl: 'assets/directive-templates/form/form.html',
    restrict: 'E',
    scope: {
      form: '='
    }
  };
}).directive('fieldDirective', function($http, $compile, formService) {
  var getTemplateUrl = function(field) {
    var type = field.field_type;
    var templateUrl = 'assets/directive-templates/field/';
    var supported_fields = ['textfield', 'email', 'textarea', 'checkbox', 'date', 'dropdown', 'hidden', 'password', 'radio', 'numberinput']
    if (__indexOf.call(supported_fields, type) >= 0) {
      return templateUrl += type + '.html';
    }
  }
  var linker = function(scope, element) {
    // GET template content from path
    var templateUrl = getTemplateUrl(scope.field);
    $http.get(templateUrl).then(function(data) {
      element.html(data);
      $compile(element.contents())(scope);
      if (scope.field.field_type == 'numberinput') {
        scope.$watch('field.field_number', function(newVal, oldVal) {
          if (newVal != oldVal) {
            var key = scope.field.field_title;
            var value = scope.field.field_number;
            var obj = {};
            obj[key] = value;
            formService.saveFormData(obj);
          }
        })
      } else {
        scope.$watch('field.field_value', function(newVal, oldVal) {
          if (newVal != oldVal) {
            var key = scope.field.field_title;
            var value = scope.field.field_value;
            var obj = {};
            obj[key] = value;
            formService.saveFormData(obj);
          }
        })
      }
    });
  }
  return {
    controller: function($scope) {
      // logic function for datepicker
      $scope.opened = false;
      $scope.open = function(e) {
        e.preventDefault();
        e.stopPropagation();
        $scope.opened = true;
      }
    },
    template: '<div ng-bind="field"></div>',
    restrict: 'E',
    scope: {
      field: '='
    },
    link: linker
  };
});