angular.module('bamboo').controller('RegisterCtrl',
    function($scope, $location, $interval, $rootScope, ApiService, CommonService, $state, loginService,
             $timeout, $translate, AppConfig, $localstorage,$ionicHistory) {
  this.userCredentials = {};
  var self = this;
  $scope.submitted = false;
  self.isChecked = true;
  self.isNew = true;
  var school = ApiService.school;
  this.stage = "check";
  this.isverifycode = false;
  this.isWrite=false;
  // var serverPath = "/smssignup"
  this.mobileStage = 'existnumber';
  this.argee = function() {
    self.isChecked = !self.isChecked;

  }
  this.write=function(){
    if(!self.userCredentials.name||!self.userCredentials.fullname){
      self.isWrite=false;
    }else{
      self.isWrite=true;
    }
  }
  this.changeMobile = function() {
    self.mobileStage = "newnumber";
    self.isNew = false;
    //if (self.isNew == false)return;
  }
  this.check = function() {
    if (!self.userCredentials.name || self.userCredentials.name.length != 18) {
      console.log();
      CommonService.showError("非法身份证号，请重新输入！");
      return;
    }
    if (!self.userCredentials.fullname || self.userCredentials.fullname.length < 2) {
      CommonService.showError("全名长度不足！");
      return;
    }
    var info = self.userCredentials;
    $scope.userInfo = self.userCredentials;
    CommonService.showLoading();
    info.action = "getUserActiveInfoByName";
    ApiService.post('/user', info).then(function(result) {
      console.log(result);
      CommonService.stopLoading();
      if (result.data.success) {
        console.log("---1", result.data.data);
        var _result = result.data.data;
        if (_result.active) {
          CommonService.showError("用户已激活, 请直接登录, 若密码丢失请重置密码！");
          return;
        }
        $scope.mobile = self.userCredentials.mobile = result.data.data.mobile;
        self.stage = "verify";
        self.userCredentials.mobilephone = self.userCredentials.mobile.substring(0, 3) + "****" + self.userCredentials.mobile.substring(self.userCredentials.mobile.length - 4);
      } else if (result.data.error){

        if(result.data.error == 'error. No record!') {
          $state.go('app.config.create');
          $localstorage.setObject('userCredentials',self.userCredentials);
        }else if(result.data.error == 'error. Wrong fullname!'){
          CommonService.showError("不匹配的身份证号与全名，请验证后再注册！");
          return;
        }else{
          CommonService.showError(result.data.error);
        }
        //CommonService.showErrorWithTitle("您的信息不在本系统中", "如果您是驾考学员，请前往驾校报名！如果您是从业人员，请核实您的从业报备情况！");
      }
    });
  }
  this.backChangePhone = function() {
    self.userCredentials.newphone = '';
    var info = $scope.userInfo;
    CommonService.showLoading();
    info.action = "getUserActiveInfoByName";
    ApiService.post('/user', info).then(function(result) {
      console.log(result);
      CommonService.stopLoading();
      if (result.data.success) {
        console.log("---1", result.data.data);
        var _result = result.data.data;
        if (_result.active) {
          CommonService.showError("用户已激活, 请直接登录, 若密码丢失请重置密码！");
          return;
        }
        $scope.mobile = self.userCredentials.mobile = result.data.data.mobile;
        self.stage = "verify";
        self.userCredentials.mobilephone = self.userCredentials.mobile.substring(0, 3) + "****" + self.userCredentials.mobile.substring(self.userCredentials.mobile.length - 4);
      } else if (result.data.error && result.data.error == 'No record!') {
        CommonService.showErrorWithTitle("您的信息不在本系统中", "如果您是驾考学员, 请前往驾校报名！如果您是从业人员, 请核实您的从业报备情况！");
      }
    });
    //this.stage = "existnumber";
    //self.userCredentials.mobile = $scope.mobile;
    //self.userCredentials.mobilephone = self.userCredentials.mobile.substring(0, 3) + "****" + self.userCredentials.mobile.substring(self.userCredentials.mobile.length - 4);
  }
  //isverifycode
  $scope.verifyFunction = function() {
    if (self.mobileStage == 'newnumber') {
      self.userCredentials.mobile = self.mobile.toString();
    }
    console.log( self.userCredentials);
    if (!self.userCredentials.mobile || (self.userCredentials.mobile.length != 8 && self.userCredentials.mobile.length != 11)) {
      CommonService.showError('手机号长度不正确，请重新输入！');
      return;
    }
    //console.log();
    // if (!(/^1[34578]\d{9}$/.test(self.userCredentials.mobile))) {
    //   CommonService.showError("手机号码格式有误，请重新输入！");
    //   return;
    // }
    self.codeVerify();
    if (self.isverifycode == false) {
      self.isverifycode = true;
      self.isCheck = true;
      var totalSecond = 59; //设置计时总时间（分钟）
    //  self.codeVerify();
      //倒计时
      self.timePromise = $interval(function() {
        $scope.CountDown = true;
        if (totalSecond >= 0) {
          var s = totalSecond < 10 ? "0" + totalSecond : totalSecond;
          totalSecond = totalSecond - 1;
          $scope.payCountDown = s + "秒";
          console.log($scope.payCountDown);
        } else {
          self.isverifycode = false;
          $scope.payCountDown = "验证";
          $interval.cancel(self.timePromise); //终止倒计时
        }
      }, 1000);
    }
  }
  var smsSended=false;
  this.codeVerify = function() {
    var info = {
      action: 'verifyMobileForCreate',
      mobile: self.userCredentials.mobile,
      loginName:self.userCredentials.name,
    }
    console.log(info);
    CommonService.showLoading();
    ApiService.post('/messages', info).then(function(result) {
      console.log(result);
      if (result.data.success) {
        smsSended=true;
        //CommonService.showNoBlockInfo('Send Successful!');
        console.log("OK..");
      } else {
        if(result.data.error=='error: Mobile Used!'){
          CommonService.showError('手机号已被其它用户使用，请更换手机号注册！');
          self.isverifycode = false;
          $scope.payCountDown = "验证";
          $interval.cancel(self.timePromise); //终止倒计时
        }else{
          CommonService.showError(result.data.error);
        }
      }
      CommonService.stopLoading();
    });
  }

  this.verify = function() {
    if (self.mobileStage == 'newnumber') {
      self.userCredentials.mobile = self.userCredentials.newphone;
    }
    if (!self.userCredentials.mobile || (self.userCredentials.mobile.length != 8 && self.userCredentials.mobile.length != 11)) {
      CommonService.showError('手机号长度不正确，请重新输入！');
      return;
    }
    if (!(/^1[34578]\d{9}$/.test(self.userCredentials.mobile))) {
      CommonService.showError("手机号码格式有误，请重新输入！");
      return;
    }
    var isnum = /^\d+$/.test(self.userCredentials.mobile);
    if (!isnum) {
      CommonService.showError($translate.instant('验证码有误请重新输入！'));
      return;
    }
    if (self.mobileStage == 'newnumber') {
      self.userCredentials.mobile = document.getElementById('mobile');
    }
    self.stage = 'verify';
  }
  this.verifyCode = function() {
    if(!smsSended){
      return CommonService.showError('请先发送验证码！');
    }
    if (self.mobileStage == 'newnumber') {
      self.userCredentials.mobile = self.mobile;
    }
    if (!self.userCredentials.verifycode || self.userCredentials.verifycode.length < 6) {
      CommonService.showError($translate.instant('验证码有误请重新输入！'));
      return;
    }
    var isnum = /^\d+$/.test(self.userCredentials.verifycode);
    if (!isnum) {
      CommonService.showError($translate.instant('验证码有误请重新输入！'));
      return;
    }
    var info = {
      action: 'checkverification',
      mobile: self.userCredentials.mobile,
      code: self.userCredentials.verifycode
    }
    ApiService.post('/messages', info).then(function(result) {
      console.log(result);
      if (result.data.success) {
        //CommonService.showNoBlockInfo('Send Successful!');
        console.log("OK..");
        $interval.cancel(self.timePromise); //终止倒计时
        self.stage = 'submit';
      } else {
        CommonService.showError($translate.instant('验证码有误请重新输入！'));
      }
    });
  }
  this.register = function(form) {
    $scope.submitted = true;
    var info = self.userCredentials;
    //if (!self.userCredentials.pass || self.userCredentials.pass.length < 6) {
    //    CommonService.showError("密码长度不足！");
    //    return;
    //}
    //if (!self.userCredentials.re_pass || self.userCredentials.re_pass.length < 6) {
    //    CommonService.showError("与密码不一致，请重新输入！");
    //    return;
    //}
    //if (self.userCredentials.re_pass != self.userCredentials.pass) {
    //    CommonService.showError("与密码不一致，请重新输入！");
    //    return;
    //}
    if (info.pass != info.re_pass) {
      //CommonService.showError($translate.instant('Password not matched'));
      CommonService.showError($translate.instant('两次密码不一致！'));
      return;
    }
    console.log(form);
    if (form.$invalid) {
      return;
    }
    CommonService.showLoading();
    console.log(info);
    // info.action = "registerUser";
    // // console.log(serverPath);
    ApiService.post("/smsactive", info).then(function(result) {
      console.log(result)
      CommonService.stopLoading();
      if (result.data.success) {
        var _info = {
          name: info.name,
          pass: info.pass
        };
        loginService.login(_info).then(function(user) {
          if (user) {
            $localstorage.set('passNeedToUpdate', false);
            $localstorage.set('username', info.name.toLowerCase());
            $localstorage.set('password', info.pass);
            $ionicHistory.clearCache().then(function() {
              console.log(user)
              if(user.userType&&user.userType<7&&user.BeiAnZhuangTai&&user.BeiAnZhuangTai==1){
               // $ionicHistory.clearCache().then(function() {
               $state.go('app.home');;
               // });
                return;
              }
              $state.go('app.config.update',{
                backShow:true
              });
            });
          } else {
            $state.go('app.config.login');
            console.log("Something wrong!");
          }
        });
        // CommonService.showInfo($translate.instant('账号已经激活，请用新设的密码登录！'));
        // $state.go('app.config.login');
      } else {
        if (result.data.errorCode && AppConfig.ErrorSignUp[result.data.errorCode]) {
          var _err = AppConfig.ErrorSignUp[result.data.errorCode];
          CommonService.showError(_err.cn);
        } else {
          CommonService.showError(result.data.error);
        }
        return;
      }
    });
  };
})
