'use strict';
angular.module('bamboo.config').controller('SyncCtrl', function($scope, $state,$localstorage,$ionicHistory, loginService, ApiService, CommonService) {
  var _self = this;
  console.log('-- Synccontroller --');

  if (ApiService.school) {
    this.schoolName = ApiService.school.name;
  }
  $scope.mobilephoto = 'img/splash_img.png';

  this.username = $localstorage.get('username');
  this.password = $localstorage.get('password');
  if(!this.username||!this.password){
      $state.go('app.config.login');
  }
  this.logoUrl = 'assets/images/bamboo_logo.png';
  this.companyName = 'Bamboosys System Technology';
  this.companyDescription = '';
  ApiService.getSchoolInfo().then(function() {
    console.log(ApiService.school);
    _self.schoolName = ApiService.school.name;

    if (ApiService.school.mobilephoto) {
      $scope.mobilephoto = ApiService.SHOST + "/site/" + ApiService.school.mobilephoto;
    } else {
      $scope.mobilephoto = 'img/splash_img.png';
    }
    var info = {
      name: _self.username,
      pass: _self.password
    };
    CommonService.showLoading();
    if(!info.name||!info.pass){
      return $state.go('app.config.login');
    }
    console.log(info);
    loginService.login(info).then(function(user) {
      CommonService.stopLoading();
      if (!user) {
        $state.go('app.config.login');
      }else{
        $ionicHistory.goBack();
       // $state.go('app.home');
      }
    });
    //  console.log(_self.schoolServiceAgreement);
  }, function() {
    $state.go('app.config.login');
  });
});
