angular.module('bamboo.material').controller('MaterialInfoCtrl', function(ApiService, CommonService, $sce, $stateParams) {
  var _self = this;
  this.id = $stateParams.id;
  this.item = {};
  this.photoPath = ApiService.SHOST + '/material/';
  this.defaultPhoto = ApiService.SHOST + "/public/images/details.png";
  this.tab = 0;

  function getInfo() {

    CommonService.showLoading();
    ApiService.get("/material/"+_self.id).then(function(result) {
      CommonService.stopLoading();

      if (result.data.success) {
        _self.item = result.data.data || {};
        console.log(_self.item );
        if (_self.item.audio) {
          _self.item.audiourl = $sce.trustAsResourceUrl(_self.photoPath + _self.item._id + '/' + encodeURI(_self.item.audio));
        }
        _self.imageUrl = _self.item.photo ? _self.photoPath + _self.item._id + '/' + _self.item.photo : _self.defaultPhoto;
      }
    });
  }
  getInfo();
});