angular.module('bamboo.material').controller('MaterialListCtrl', function($scope, $stateParams, ApiService, loginService, CommonService) {
  var _self = this;
  //  CommonService.showInfo("news controller");
  console.log("---- news list -----");
  ApiService.getSchoolInfo();
  this.defaultPhoto = ApiService.SHOST + "/public/images/details.png";
  //  this.searchmethod = null;
  this.photoUrl = ApiService.SHOST + '/material/';
  this.page = 0;
  this.moreData = false;
  this.cat = $stateParams.cat;
  this.items = [];
  this.user;
  var mygroup;
  this.nextPage = function() {
    _self.page++;
    getInfo(_self.page);
    console.log("--- next page --");
  }

  function getInfo(page) {
    var pagesize = 6;
    var info = {
      start: pagesize * page,
      limit: pagesize,
      action: "getenablematerials"
    };
    if (_self.cat) {
      if (!info.search) {
        info.search = {};
      }
      info.search.category = _self.cat;
    }
    CommonService.showLoading();
    ApiService.post("/material", info).then(function(result) {
     // console.log(result);
      CommonService.stopLoading();
      if (result.data.success) {
        console.log(result.data.data.items);
        if (!_self.items) {
          _self.items = [];
        }
        _self.items = _self.items.concat(result.data.data.items);
        console.log(mygroup);
        angular.forEach(_self.items, function(item, index) {
          if (item.public) {
            item.url = ".detail";
          } else if(!_self.user){
             item.url = ".info";
          } else if ((!_self.user.grole && !_self.user.is_admin) || (_self.user.grole && _self.user.grole == "user")) {
            if (item.category.indexOf(mygroup) > -1) {
              item.url = ".detail";
            } else {
              item.url = ".info";
            }
          } else {
            item.url = ".detail";
          }
        })
        _self.totalCount = result.data.data.counter;
        _self.moreData = ((_self.totalCount - _self.items.length) > 0);
      }
      $scope.$broadcast('scroll.infiniteScrollComplete');
    });
  }
  console.log("--- school ---");
  loginService.getLoginInfo().then(function(user) {
    console.log(user);
    _self.user = user;
    if (user) {
      loginService.getMyProfile().then(function(result) {
        mygroup = result.mgroup;
        getInfo(0);
      });
    }else{
      mygroup="FFFF";
      getInfo(0);
    }
  })
});