angular.module('bamboo.myspace').controller('MyFeedbackCtrl', function($scope, ApiService,BlogService,CommonService) {
  // body...
  var self = this;
  self.options = [];
  self.newfeedback = {};
  self.addFeedback = function() {}
  ApiService.getFeedbackCategory().then(function(cats) {
    self.options = cats;
  });
  // ctrl function to submit and save this new feedback
  this.savefeedback = function() {
    var invalid = false;
    self.errMsgs = [];
    // check for valid input
    if (!self.newfeedback.tab) {
      invalid = true;
      CommonService.showInfoWithTitle('Info', 'Please select category for new feedback');
    }
    else if (!self.newfeedback.title) {
      invalid = true;
      CommonService.showInfoWithTitle('Info', 'Please enter title for new feedback');
    }
    else if (!self.newfeedback.content) {
      invalid = true;
      CommonService.showInfoWithTitle('Info', 'Please enter content for new feedback');
    }
    if (invalid) {
      return;
    }
    var info = {
      title: self.newfeedback.title, // new feedback title
      t_content: self.newfeedback.content, // new feedback content
      action: "create",
      tab: self.newfeedback.tab, // tab or category, null for all
    };
    BlogService.FeedbackApi(info,function(){
      self.newfeedback = {};
      CommonService.showInfoWithTitle('Info', 'Add a feedback successfully !');
    })
  }
});