'use strict';
angular.module('bamboo.myspace').controller('MyTeacherSessionsStuListCtrl', function(ApiService, loginService, $stateParams, $scope, $filter, $q, $state) {
  var self = this;
  self.tab = 1;
  this.has_position = true;
  this.id = $stateParams.sid;
  var _time = parseInt($stateParams.time);
  console.log($stateParams);
  var time = this.date = new Date((new Date(_time)).toISOString().substring(0, 10));
  console.log(time);
  var _cid = $stateParams.cid;
  this.session = {};
  this.class = {};
  this.record = {};
  this.students = [];
  this.classlist = [];
  this.pagesize2 = 5;
  this.pagesize1 = 5;
  console.log(self.id);
  this.teacherTime;
  var tempSession = {};
  this.showUnattend = false;

  function getInfo() {
    var info = {
      action: 'getsessionrecord',
      sid: self.id,
      time: time,
    }
    ApiService.post("/coursesession", info).then(function(result) {
      //  console.log( '-Starting auth session result: ');
      if (result.data.success) {
        self.session = result.data.data.session;
        self.record = result.data.data.record || {};
        console.log(self.session);
        console.log(self.record);
        self.showUnattend = true;
        // var userid = loginService.user._id;
        // if (self.record.teacherattends && self.record.teacherattends[userid]) {
        //   console.log('attend');
        //   self.teacherTime = self.record.teacherattends[userid];
        // }
        getAttUsers();
        getUnattUsers();
      }
    });
  }
  getInfo();
  this.teacherSignin = function() {
    var info = {
      action: 'teachersignin',
      cid: self.record._id,
    }
    ApiService.post('/coursesession', info).then(function(result) {
      console.log(result);
      if (result.data.success) {
        var userid = loginService.user._id;
        if (!self.record.teacherattends) {
          self.record.teacherattends = {};
        }
        self.record.teacherattends[userid] = new Date();
        CommonService.showNoBlockSuccess('Update Successful!');
      }
    })
  }

  function getAttUsers() {
    var attInfo = {
      id: self.record._id,
      start: 0,
      limit: Number.MAX_SAFE_INTEGER,
      //sort: tableState.sort,
      //search: search,
      action: "getattendstudents"
    };
    ApiService.post('/coursesession', attInfo).then(function(data) {
      // console.log(data);
      if (data.data.success) {
        // CommonService.showNoBlockSuccess('Update Successful!');
        var result = data.data.data;
        self.attendedStudents = result.items;
        console.log(self.attendedStudents);
        $scope.totalAttended = result.counter;
        // self.tableState.pagination.numberOfPages = Math.ceil(result.counter / self.tableState.pagination.number);
      } else {
        CommonService.showError(data.data.error);
      }
    });
  }

  function getUnattUsers() {

    var unattInfo = {
      // lid: _cid,
      id: self.record._id,
      lid: _cid,
      start: 0,
      limit: Number.MAX_SAFE_INTEGER,
      //sort: tableState2.sort,
      //search: search,
      action: "getunattenedenrollusers"
    };
    //  console.log(info);
    ApiService.post('/coursesession', unattInfo).then(function(data) {
      console.log(data);
      if (data.data.success) {
        var result = data.data.data;
        console.log(result);
        self.unAttendedStudents = result.items;
        // $scope.displayedStudents = result.items;
        //  console.log($scope.displayedStudents);
        $scope.totalUnattended = result.counter;
        //self.tableState2.pagination.numberOfPages = Math.ceil(result.counter / self.tableState2.pagination.number);
      }
      if (unattInfo.classId && search) {
        search.classid = unattInfo.classId;
      }
    });
  };


  this.delete = function(index, user) {
    var info = {
      cid: self.record._id,
      username: user.loginname,
      action: 'delattends',
    }
    console.log(info);

    ApiService.post('/coursesession', info).then(function(result) {
      if (result.data.success) {
        getUnattUsers();
        getAttUsers();
      }
    })
  }

  this.select = function(index, user) {
    var info = {
      rid: self.record._id,
      sid: self.id,
      lid: _cid,
      time: time,
      username: user.loginname,
      action: 'addattends',
    }
    console.log(info);
    ApiService.post('/coursesession', info).then(function(result) {
      if (result.data.success) {
        console.log(result.data);
        getUnattUsers();
        getAttUsers();
      }
    })
  };

});