'use strict';
angular.module('bamboo.myspace').controller('MyTeacherSessionsCourseCtrl', function(ApiService, loginService, $stateParams, $scope, $filter, $q) {
  var _self = this;
  this.dayList = [];
  this.cid = $stateParams.cid;

  //get teacher's courses
  function getTeacherCoursesByLoginName(loginname) {
    var deferred = $q.defer();
    var info = {
      action: 'getteachingcourses',
      uid: loginname
    };
    ApiService.post('/lcourses', info).then(function(result) {
      if (result.data.success) {
        deferred.resolve(result.data.data);
      } else {
        var _err = result.data.error || '' + result.data.info || '';
        deferred.reject(_err);
      }
    })
    return deferred.promise;
  }

  getTeacherCoursesByLoginName('teacher01')
    .then(function(res) {
      var courses = res.items;
      console.log(res);
      $scope.teacherCourses = courses;
      $scope.courseCounter = res.counter;

    });


});