angular.module('bamboo.course').controller('TransdetailCtrl', function($scope, CommonService, $stateParams, $ionicHistory, loginService, ApiService, CourseApi, $state, $timeout, $rootScope) {
  var self = this;
  this.id = $stateParams.rid;
  console.log("---- TransdetailCtrl -----", self.id);
  self.identity = 'person';
  self.isBill = false;
  var enterMode = 'normal';

  function getInfo() {
    var info = {
      action: 'getCourseTransaction',
      id: self.id
    }
    ApiService.post("/transaction", info).then(function(_result) {
      if (_result.data.success) {
        result = _result.data.data;
        console.log(result);
        self.company = result.company;
        self.record = result.record;
        self.users = result.users;
        self.courses = result.courses;
        // angular.forEach(self.users, function(user) {
        //   self.userInfo[user._id] = user;
        // })
        // angular.forEach(self.courses, function(course) {
        //   self.courseInfo[course._id] = course;
        // })
        if (self.type == 'course' || self.type == 'courseWithBook') {
          var info = {
            cid: self.record.itemId,
            uid: self.record.userId,
          }
          if (!self.record.multiple) {
            self.record.multiple = [];
          }
          self.record.multiple.push(info);
        }
      }
    });
  }
  getInfo();
});