angular.module('bamboo.news').controller('NewsListCtrl', function($scope,$stateParams, loginService, $ionicModal, ApiService, $timeout, $state, CommonService, $ionicPopover, utilService, $localstorage, newsTabService) {

  var _self = this;
  //  CommonService.showInfo("news controller");
  console.log("---- news list -----");
  var favouritenews = [];
  this.defaultNewsPhoto = ApiService.SHOST + "/public/images/details.png";
  //  this.searchmethod = null;
  this.newsPhotoUrl = ApiService.SHOST + '/public/' + ApiService.RES + '/' + 'schoolnews' + '/';
  this.page = 0;
  this.moreData = false;
  this.loadMore = false;
  this.items = [];
  _self.selectedTab=$stateParams.category;
  ApiService.getSchoolInfo().then(function() {
    if (ApiService.school.newsphoto) {
      _self.defaultNewsPhoto = ApiService.SHOST + "/site/" + ApiService.school.newsphoto;
    }
    getInfo(0);
  });
  var counter = 0;
  $scope.$on('$ionicView.enter', function() {
    $localstorage.set('lastVisitedNewsCategory',  _self.selectedTab)
    //console.log("enter event");
    if (counter > 5) {
      console.log("fire api call");
      _self.page = 0;
      _self.items = [];
      getInfo( _self.page);
      counter = 0;
    }
    //
    //_self.selectedTab="行业资讯";
    //getInfo(0);
    counter++;
  })
  //$scope.$on('$ionicView.afterLeave', function() {
  //    _self.page = 0;
  //    //_self.items = [];
  //    //counter = 0;
  //  //_self.selectedTab="行业资讯";
  //})
  loginService.getLoginInfo().then(function() {
    if (loginService.user) {
      _self.allowfaviourate = true;
      console.log(" allow faviorate ");
    }
  })
  this.nextPage = function(val) {
    if (val) {
      _self.page++;
      getInfo(_self.page);
      console.log("--- next page --");
    }
  };
  this.item = {};
  this.itemPicUrl = ApiService.SHOST + "/public/" + ApiService.RES + "/schoolnews/";
  this.defaultPhoto = ApiService.SHOST + "/public/images/details.png";
  $scope.share = function() {
    var link = ApiService.HOST + '/#/news/' + _self.item._id + "?share=true";
    var imageUrl = _self.item.photo ? _self.itemPicUrl + _self.item._id + '/' + encodeURIComponent(_self.item.photo) : _self.defaultNewsPhoto;
    console.log(link);
    console.log(imageUrl);
    console.log(_self.item.name);
    CommonService.showShareDialog($scope, _self.item.name, imageUrl, link, _self.item.description);
  }
  this.detail;
  this.passNewsId = [];
  $scope.favourite = function() {
    console.log(_self.item);
    if (favouritenews.indexOf(_self.item._id) < 0) {
      var object = {
        type: 'news',
        id: _self.item._id
      };
      var info = {
        action: "addfavourite",
        object: object
      };
      ApiService.post("/user", info).then(function(result) {
        if (result.data.success) {
          loginService.getMyProfile(true).then(function() {
            // console.log("-- need to reload ---");
            $scope.closedetailfromservice();
          });
        }
      });
    }
  };
  this.list=function(key, i){
    newsTabService.newsTab = i
    setLastVisitedNewsCate(key)
    _self.selectedTab=key;
    _self.page=0;
    getInfo(_self.page);
  }

  function setLastVisitedNewsCate(key) {
    $localstorage.set('lastVisitedNewsCategory', key)
  }
  function getLastVisitedNewsCate() {
    return $localstorage.get('lastVisitedNewsCategory') || '';
  }
  function removeLastVisitedNewsCate() {
    $localstorage.removeItem('lastVisitedNewsCategory');
  }

  $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams) {
    if(fromState.name === 'app.news.detail') {
      _self.selectedTab = getLastVisitedNewsCate();
    } else {
    }
  });

  function getInfo(page) {
    var pagesize = 6;
    CommonService.showLoading();
    var info={
      start:page*pagesize,
      limit:pagesize,
      //action:'getEnableNews',
      action:'getallnewses',
      search: {}
    }
    if(_self.selectedTab){
      info.search={
        category: _self.selectedTab
      }
    }
   // var url = "/newses/" + page + "/" + pagesize;
    console.log(info);
    ApiService.post("/news",info).then(function(result) {
      console.log(result);
      CommonService.stopLoading();
      if (result.data.success) {
        //_self.items = [];
        _self.loadMore=false;
        _self.totalCount = result.data.data.counter;
        if(page==0){
          _self.items=result.data.data.items;
        }else{
          _self.items = _self.items.concat(result.data.data.items);
        }

        if((_self.totalCount - 6*(page+1)) > 0){
          _self.moreData=true;
        }else{
          _self.moreData=false;
        }

        if(!_self.moreData){
          _self.page=0;
        }
        console.log(_self.items);
        //console.log(_self.totalCount, _self.items.length, _self.moreData);
        $scope.$broadcast('scroll.infiniteScrollComplete');
        //infiniteScroll.complete();
      }
    });
  }
  $scope.$on('stateChangeSuccess', function() {
    getInfo(_self.page);
  });

  this.showNews = function(id, i, fromList) {
    //CommonService.showLoading();
    _self.currentId = id;
    _self.hide = i;
    ApiService.getSchoolInfo().then(function() {
      if (ApiService.school.newsphoto) {
        _self.defaultPhoto = ApiService.SHOST + "/site/" + encodeURIComponent(ApiService.school.newsphoto);
      }
      ApiService.get("/newses/" + id).then(function(result) {
        if (result.data.success) {
          _self.item = result.data.data;
          favouritenews = [];
          loginService.getMyProfile().then(function(_result) {
            // console.log("--- return ---");
            var favourites = _result.favourites;
            console.log(favourites);
            angular.forEach(favourites, function(_item) {
              //console.log(_item);
              // console.log(id);
              if (_item.type == "news" && _item.id == id) {
                _self.item.favourite = true;
                //  console.log("favourite flag true");
              }
            })
          });
          _self.imageUrl = _self.item.photo ? _self.itemPicUrl + _self.item._id + '/' + encodeURIComponent(_self.item.photo) : _self.defaultPhoto;
          if (_self.item.detail) {
            _self.detail = CommonService.replaceImgLink(_self.item.detail)
              /* if (_self.item.detail.indexOf(' src="//s3-ap-southeast-1.amazonaws.com') > -1) {
                 _self.detail = _self.item.detail.split(' src="//s3-ap-southeast-1.amazonaws.com').join(' src="https://s3-ap-southeast-1.amazonaws.com');
               } else if (_self.item.detail.indexOf(' src="//fileupload.oss-cn-beijing.aliyuncs.com') > -1) {
                 _self.detail = _self.item.detail.split(' src="//fileupload.oss-cn-beijing.aliyuncs.com').join(' src="https://fileupload.oss-cn-beijing.aliyuncs.com');
               } else if (_self.item.detail.indexOf(' src="//media.huijia.edu.cn') > -1) {
                 _self.detail = _self.item.detail.split(' src="//media.huijia.edu.cn').join(' src="http://media.huijia.edu.cn');
               } else if (_self.item.detail.indexOf(' src="//course.xijing.edu.cn') > -1) {
                 _self.detail = _self.item.detail.split(' src="//course.xijing.edu.cn').join(' src="http://course.xijing.edu.cn');
               } else if (_self.item.detail.indexOf(' src="//file.course.jingye.com.sg') > -1) {
                 _self.detail = _self.item.detail.split(' src="//file.course.jingye.com.sg').join(' src="https://file.course.jingye.com.sg');
               } else {
                 _self.detail = _self.item.detail;
               }*/
          }
        }
        console.log(_self.imageUrl);
        console.log(_self.item);
        console.log(_self.hide);
        if (fromList) {
          CommonService.showdetail($scope, 'app/news/newsdetail.html');
        }
      });
    });
  };

  $ionicPopover.fromTemplateUrl('app/news/menupopover.html', {
    scope: $scope,
  }).then(function(popover) {
    $scope.popover = popover;
  });

  $scope.closePopover = function() {
    $scope.popover.hide();
  };

  this.prev = function(id) {
    _self.clicke = true;
    $timeout(function() {
      _self.clicke = false;
    }, 500);
    for (var i = 0; i < _self.passNewsId.length; i++) {
      if (_self.passNewsId[i].value == id) {
        i = i - 1;
        var val = _self.passNewsId[i].value;
        _self.showNews(val, i, false);
        break;
      }
    }
  };
  this.next = function(id) {
    _self.clicked = true;
    $timeout(function() {
      _self.clicked = false;
    }, 500)
    for (var i = 0; i < _self.passNewsId.length; i++) {
      if (_self.passNewsId[i].value == id) {
        i = i + 1;
        var val = _self.passNewsId[i].value;
        _self.showNews(val, i, false);
        break;
      }
    }
  };

  utilService.watchScroll($scope);
});
