angular.module('bamboo.roomsession').controller('UserAccessRecordsCtrl', function($scope, $window, CourseApi, ApiService, CommonService, $rootScope, $state, $translate, loginService, $cordovaGeolocation) {
  var _self = this;
  this.subtab = 0;
  console.log(loginService.user);

  function getAccessRecords() {
    var info = {
      action: 'getUserAccessRecords',
      name: loginService.user.name,
    };
    console.log(info);
    // _self.currentCourse = $scope.setting.items[_self.subtab];
    ApiService.post('/session', info).then(function(result) {
      // console.log(result);
      if (result.data.success) {
        _self.sessions = result.data.data.items;
        console.log(_self.sessions);
      } else {
        CommonService.showError(result.data.error || result.data.info);
      }
    });
  }
  getAccessRecords();
  var currentPage = 0;

  function getLearningRecords() {
    var info = {
      // lid: $scope.setting.items[_self.subtab]._id,
      // uid: loginService.user._id,
      start: currentPage * 6,
      limit: 6,
      action: "getMyCourseLearningRecords"
    };
    if (currentPage == 0) {
      _self.displayedItems = [];
    }
    console.log(info);
    CourseApi.mvApi(info, function(result) {
      //console.log(result);
      _self.displayedItems = _self.displayedItems.concat(result.items);
      _self.total = result.counter;
      if (_self.total > _self.displayedItems.length) {
        console.log("--- need more ");
        _self.onlineMore = true;
      } else {
        _self.onlineMore = false;
      }
      console.log(_self.displayedItems);
      $scope.$broadcast('scroll.infiniteScrollComplete');
      $scope.$broadcast('scroll.refreshComplete');
    });
  }
  getLearningRecords();
  this.nextPage = function() {
    currentPage++;
    console.log("--- next page ----");
    getLearningRecords()
  }
  // $scope.setting = {
  //   page: 0,
  //   numProgress: 0,
  //   page_items: [],
  //   items: []
  // };
  // this.getMyCourses = function(page) {
  //   var info = {
  //     action: "getMyRelaventCourses",
  //     page: 0,
  //     limit: 8 // page size
  //   };
  //   CommonService.showLoading();
  //   CourseApi.lcApi(info, function(result) {
  //     console.log(result);
  //     angular.forEach(result.courses, function(course) {
  //       course.totalScore = (course.sysScore || 0) + (course.offScore || 0);
  //     })
  //     $scope.setting.page_items = result.courses;
  //     $scope.setting.totalCount = result.count;
  //     getMyProgress();
  //     $scope.setting.items = $scope.setting.items.concat(result.courses);
  //     if ($window.innerWidth - $scope.setting.items.length * 80 > 0) {
  //       $scope.marginRight = 0 + 'px';
  //     } else {
  //       $scope.marginRight = ($window.innerWidth - $scope.setting.items.length * 80) + "px";
  //     }
  //     _self.moreData = (($scope.setting.totalCount - $scope.setting.items.length) > 0);
  //     console.log($scope.setting.totalCount, $scope.setting.items.length, _self.moreData);
  //     console.log($scope.setting.page_items);
  //     _self.totalCount = result.count;
  //     getAccessRecords();
  //     $scope.$broadcast('scroll.infiniteScrollComplete');
  //   });
  // }
  // _self.getMyCourses(0);
  // function getMyProgress() {
  //   var info = {
  //     action: "getmyprogress",
  //   }
  //   CourseApi.lcApi(info, function(result) {
  //     console.log(result);
  //     CommonService.stopLoading();
  //     if (result) {
  //       var progress = result;
  //       angular.forEach($scope.setting.page_items, function(course, key) {
  //         console.log(course);
  //         var id = course._id;
  //         if (progress[id] && progress[id].csessionWeight && course.sysScore) {
  //           course.sysprogress = parseInt(progress[id].csessionWeight * 100 / course.sysScore);
  //           console.log(progress[id], course);
  //         }
  //         if (progress[id] && progress[id].sessionWeight && course.offScore) {
  //           course.offprogress = parseInt(progress[id].sessionWeight * 100 / course.offScore);
  //           // console.log(progress[id], course);
  //         }
  //       });
  //       console.log($scope.setting.numProgress)
  //     } else {
  //       // no progress record
  //       $scope.setting.numProgress += $scope.setting.page_items.length;
  //     }
  //   });
  // }
  this.currentCourse;
  this.changeSubTab = function(index, item) {
    this.subtab = index;
    _self.currentCourse = item;
    getAccessRecords()
  }
});