angular.module('bamboo.roomsession').controller('UserAccessRecordsDetailCtrl', function ($stateParams, $scope, ApiService, CommonService, $rootScope, $state, $translate, loginService, $cordovaGeolocation) {
  var self = this;
  this.rid = $stateParams.aid;
  this.isApp = true;       // 判断是否是app签到(线下)还是课程学习（线上）
  function getAccessRecords() {
    var info = {
      action: "getAccessRecordDetail",
      id: self.rid
    };
    console.log(info);
    ApiService.post('/session', info).then(function (result) {
     // console.log(result);
      if (result.data.success) {
        var data = result.data.data
        console.log(data);
        self.accessRecord = data.accessRecord;
        self.app = data.app;
        self.course = data.course;
        self.record = data.record;
        if(self.record.time&&self.record.length){
          var timems=(new Date(self.record.time)).getTime()+self.record.length*60*1000;
          self.record.stop= new Date(timems);
        }

        var imgPath = ApiService.PSURL + "/attendence/" + self.accessRecord.recordId + "/";
        if (self.accessRecord.recordId) {
          if (self.accessRecord.photo) {
            console.log("---------- 1");
            self.accessPhotoUrl = imgPath + self.accessRecord.photo;
            console.log(self.accessPhotoUrl);
          }
          if (self.accessRecord.ephoto) {
            self.exitPhotoUrl = imgPath + self.accessRecord.ephoto;
          }
          if (self.accessRecord.records && self.accessRecord.records.length) {
            angular.forEach(self.accessRecord.records, function (record) {
              record.fullUrl = imgPath + record.photo;
            })
            self.firstPhotoUrl = imgPath + self.accessRecord.records[0].photo;
          }
        }
        self.room = data.room;
        self.session = data.session;
        self.building = data.building;
      }
    });
  }
  getAccessRecords();
});