'use strict';
angular.module('bamboo.myspace').controller('MySessionCoursesCtrl', function($scope, CommonService, ApiService, CourseApi, utilService) {
  var _self = this;
  this.coursePhotoUrl = ApiService.SHOST + '/lcourse/';
  this.subjectPicUrl = ApiService.SHOST + "/public/" + ApiService.RES;
  this.defaultpic = ApiService.SHOST + '/public/images/videos.png';
  this.tab = 'progress';
  ApiService.getSchoolInfo().then(function() {
    if (ApiService.school.coursephoto) {
      _self.defaultpic = ApiService.SHOST + "/site/" + ApiService.school.coursephoto;
    }
  });
  /*
  this.test = function() {
    console.log(ApiService);  
    console.log($scope.setting);
  }
  */
  $scope.setting = {
    page: 0,
    numProgress: 0,
    page_items: [],
    items: []
  };
  this.moreData = false;
  this.nextPage = function() {
    $scope.setting.page++;
    _self.getMyCourses($scope.setting.page);
    console.log("--- next page --");
  };
  this.getMyCourses = function(page) {
    var info = {
      action: "getMyRelaventCourses",
      page: page,
      limit: 8 // page size
    };
    console.log(info);
    CommonService.showLoading();
    CourseApi.lcApi(info, function(result) {
      console.log(result);
      $scope.setting.page_items = result.courses;
      $scope.setting.totalCount = result.count;
      $scope.setting.items = $scope.setting.items.concat(result.courses);
      _self.moreData = (($scope.setting.totalCount - $scope.setting.items.length) > 0);
      console.log($scope.setting.totalCount, $scope.setting.items.length, _self.moreData);
      console.log($scope.setting.page_items);
      _self.totalCount = result.count;
      CommonService.stopLoading();
      $scope.$broadcast('scroll.infiniteScrollComplete');
    });
  }
  _self.getMyCourses(0);
  utilService.watchScroll($scope);
});