angular.module('bamboo.roomsession').controller('SessionRecordDetail', function(loginService, $ionicHistory, $cordovaGeolocation, $cordovaDevice, $scope, ApiService, $sce, CommonService, $state, $stateParams, $filter) {
  var _self = this;
  this.rid = $stateParams.rid;
  this.isenroll = ""
  this.start = "";
  this.end = ""
  this.timeRule = ApiService.school.sessionAccessRules
  //this.imgPath = ApiService.PSURL + "/attendence/" + this.rid + "/";
  if (window.cordova) {
    this.device = true;
  }

  function getInfo() {
    var info = {
      id: _self.rid,
      action: 'getSessionRecordforBooking',
    }
    ApiService.post("/session", info).then(function(result) {
      console.log(result);
      if (result.data.success) {
        console.log(result.data.data);
        var data = result.data.data;
        _self.session = data.session;
        _self.course = data.course;
        _self.room = data.room;
        _self.record = data.record;
        _self.accesses = data.accesses;
        _self.recordLen = data.record.length;

        _self.app = data.app;
        console.log(_self.record)
        var time1 = new Date(_self.record.time);
        var time2 = new Date(_self.record.time);
        time1.setMinutes(time1.getMinutes() - _self.timeRule.joinEarly);
        _self.start0 = time1;
        time2.setMinutes(time2.getMinutes() + _self.timeRule.joinLate);
        _self.start1 = time2;
        var time3 = new Date(_self.record.time);
        var time4 = new Date(_self.record.time);
        time3.setMinutes(time3.getMinutes() + _self.record.length - _self.timeRule.earlyExit);
        _self.end0 =time3;

        time4.setMinutes(time4.getMinutes() + _self.record.length + _self.timeRule.lateExit);
        _self.end1 = time4;
        if (_self.app||_self.accesses) {
          _self.isenroll = true;
        } else {
          _self.isenroll = false;
        }

        if (_self.recordLen && _self.record.time) {
          var start = (new Date(_self.record.time)).getTime();
          _self.stop = new Date(start + ( _self.recordLen || 60) * 60000);
        }
      }
    });
    // var re = CommonService.recordsdetail;
    // _self.session = data.session || {};
    // _self.course = data.course || {};
    // _self.room = data.room || {};
    // _self.data = data;
    // 处理签到和签出时间
  }
  getInfo();
  this.enroll = function() {
    if (_self.app) {
      return CommonService.showError('已经登记');
    }
    if (_self.accesses) {
      return CommonService.showError('已经上过课');
    }
    var seats=_self.room.seats||5;
    var enrolled=_self.record.enrolled||0;
    if(seats<=enrolled){
      return CommonService.showErrorWithTitle("", '已经满员，无法进行预约');
    }
    CommonService.showConfirm('确定要预约此课程?', function(result) {
      var info = {
        rid: _self.rid,
        action: 'userAddRecordApplication',
      //  sid: _self.data.sessionId,
      };
      CommonService.showLoading();
      ApiService.post("/session", info).then(function(result) {
        CommonService.stopLoading();
        if (result.data.success) {
          CommonService.showInfo('预约申请提交成功');
          $ionicHistory.goBack();
        } else {
          if(result.data.error=='Conflict Application!'){
            CommonService.showError('与其它预定时间冲突，无法预定，请检查您的日程表！');
          }
          if(result.data.error=="Fully booked!"){
            CommonService.showError('预约已满！');
          }
          
        }
      })
    })
  }
});