'use strict';
angular.module('bamboo').service('utilService', function($timeout, $translate) {
  var self = this;
  var flag = true;
  self.watchScroll = function(scope) {
    scope.scrolling = function() {
      //console.log('scrolling ...')
      if (!flag) return;
      if (!scope.label) {
        $timeout(function() {
          scope.label = $translate.instant("No more to load");
          flag = false;
        }, 0);

        $timeout(function() {
          scope.label = undefined;
          flag = true;
        }, 1500)
      }
      console.log(flag);


    }
  }

  self.validateTime = function(startTimeStr, endTimeStr) {
    if (!startTimeStr || !endTimeStr) {
      throw new Error('some params is needed!');
    }
    var now = Date.now();
    var startDate = new Date(startTimeStr).getTime();
    var endDate = new Date(endTimeStr).getTime();

    return (now >= startDate) && (now <= endDate)

  }
});