angular.module('bamboo.study').controller('StudyExamPaperCtrl', function($state, $ionicHistory, $sce, $filter, $scope, ApiService, CommonService, $stateParams, $localstorage, MystudyService, ExamService, $interval, $window, loginService, stringHelper, $q) {
  var _self = this;
  this.hideQuestion = false;
  console.log($stateParams.isBank)
  // 是否是题库
  this.isQuestionBank = $stateParams.isBank;
  if ($stateParams.paperName) this.TitleName = $stateParams.paperName;
  //if(!this.isQuestionBank){
  //  _self.submit();
  //}
  this.cid = $stateParams.cid;
  console.log(this.cid)
  var _type = $stateParams.type;
  var paperType = $stateParams.papertype;
  var paperId = $stateParams.paperid;
  this.startNum = Number.parseInt($stateParams.num);
  this.counter = 0;
  // var _eid = $stateParams.id; //for exam
  // var _index = $stateParams.index;
  _self.showQue=false;
  this.submitted = false;
  this.review = true;
  this.currentQ = 0;
  this.courseID;
  this.question = null;
  this.score_percentage = 0;
  this.exam = null;
  this.examHistoryCounter = 0;
  this.use_time = 0;
  this.time_limit = 0;
  this.sTimer = null;
  this.stopTest = true;
  this.wait = false;

  this.paperType = $stateParams.type;
  this.eid = $stateParams.id;
    $scope.questionDel=false;
    $scope.initfreash=false;
  this.audioPath = ApiService.SHOST + "/exam/audio/";
  this.videoPath = ApiService.SHOST + "/exam/video/";
  this.examIconUrl = ApiService.SHOST + '/examphoto/' + ApiService.gid + '/';
  this.typename = {
    'single': 'Select one answer',
    'fill': 'Fill in the blank',
    'mfill': 'Fill in all the blanks',
    'tof': 'True or False',
    'short': 'Essay Question',
    'multiple': 'Select ALL the correct answers',
    'mquestion': 'Multiple Questions'
  }


  this.qtypename = {
    'single': 'Multiple Choice',
    'fill': 'Fill In Blanks',
    'mfill': 'Fill In Blanks',
    'tof': 'True or False',
    'short': 'Essay Question',
    'multiple': 'Multiple Answers',
    'multiselect': 'Multiple Answers',
    'mquestion': 'Question Group'
}

  $scope.title = "Exam";
  console.log($state.current.name);
  if ($state.current.name == "index.tests.test") {
    $scope.title = "Test";
  }
  this.getSelectionText = function() {
    var text = "";
    if (window.getSelection) {
      text = window.getSelection().toString();
    } else if (document.selection && document.selection.type != "Control") {
      text = document.selection.createRange().text;
    }
    console.log(text);
    // CommonService.showInfo(text);
  };
  this.showpopup = function() {
    if (!_self.question.rootContent) {
      return;
    }
    CommonService.showdetail($scope, 'app/exam/contentpopup.html');
  }

  function examApi(info, callback) {
    ApiService.post('/exam', info).then(function(result) {
      if (result.data.success) {
        if (!callback) {
          CommonService.showInfo('Update Successful!');
        } else {
          callback(result.data.data);
        }
      }
    });
  };

  function mvApi(info, callback) {
    ApiService.post('/mvsubjects', info).then(function(result) {
      if (result.data.success) {
        if (!callback) {
          CommonService.showInfo('Update Successful!');
        } else {
          callback(result.data.data);
        }
      }
    });
  };
  var _qsts = {};
  _self.selectQuestion = [];
  var newseq = [];
  var _singleQ = [];
  var _multipleQ = [];
  var _tofQ = [];
  var _fillQ = [];
  var _mfillQ = [];
  var _shortQ = [];
  var _mquestionQ = [];

  function addQinQue(fullquestion, sortFlag) {
    if (sortFlag) {
      switch (fullquestion.type) {
        case "tof":
          _tofQ.push(fullquestion);
          break;
        case "single":
          _singleQ.push(fullquestion);
          break;
        case "fill":
        case "mfill":
          _mfillQ.push(fullquestion);
          break;
        case "multiple":
          _multipleQ.push(fullquestion);
          break;
        case "short":
          _shortQ.push(fullquestion);
          break;
        default:
          console.log("---- !!! Unknow type: " + fullquestion.type);
          break;
      }
    } else {
      newseq.push(fullquestion);
    }
  }

  function addMQinQue(fullquestion, sortFlag) {
    if (sortFlag) {
      _mquestionQ.push(fullquestion);
    } else {
      newseq.push(fullquestion);
    }
  }
  var _mqlength;

  function getFullQue(sortFlag) {
    if (sortFlag) {
      newseq = newseq.concat(_tofQ);
      newseq = newseq.concat(_singleQ);
      newseq = newseq.concat(_mfillQ);
      newseq = newseq.concat(_multipleQ);
      newseq = newseq.concat(_shortQ);
      newseq = newseq.concat(_mquestionQ);
      return newseq;
    } else {
      return newseq;
    }
  }

  function prepareQuestions(data, sortFlag) {
    var _qsts = {};
    console.log(data);
    var exam = angular.copy(data.paper);
    angular.forEach(data.qstList, function(fullquestion, idx) {
      var id = fullquestion._id;
      _qsts[id] = fullquestion;
      if (fullquestion.audio) {
        fullquestion.audiourl = $sce.trustAsResourceUrl(_self.audioPath + encodeURI(fullquestion.audio));
      }
      if (fullquestion.video) {
        fullquestion.videourl = $sce.trustAsResourceUrl(_self.videoPath + encodeURI(fullquestion.video));
        console.log(_self.videoPath + encodeURI(fullquestion.video));
      }
      fullquestion = ExamService.convertBankQ(fullquestion);
      if (fullquestion.type == "single" || fullquestion.type == "multiple") {
        fullquestion._options.sort(function(a, b) {
          return Math.random() > .5 ? -1 : 1;
        });
        fullquestion._options.sort(function(a, b) {
          return Math.random() > .5 ? -1 : 1;
        });
      }
    });
    var scorsInfo = {};
    angular.forEach(exam.questions, function(val, index) {
      if (val.id) {
        scorsInfo[val.id] = val;
      }
    })
    exam.totalScore = 0;
    var idx = 0;
    newseq = [];
    _singleQ = [];
    _multipleQ = [];
    _tofQ = [];
    _fillQ = [];
    _mfillQ = [];
    _shortQ = [];
    _mquestionQ = [];
    angular.forEach(exam.questions, function(question, index) {
      if (question.id && _qsts[question.id]) {
        var fullquestion = _qsts[question.id];
        if (!fullquestion.root && question.type != 'mquestion') {
          fullquestion.score = parseInt(question.score || 0);
          exam.totalScore += fullquestion.score || 0;
          idx++;
          fullquestion.newIdx = fullquestion.q_index = idx;
          addQinQue(fullquestion, sortFlag);
          //_questions.push(fullquestion);
        } else if (question.type == 'mquestion') {
          if (fullquestion.questions && fullquestion.questions.length) {
            angular.forEach(fullquestion.questions, function(id) {
              if (_qsts[id]) {
                var subq = _qsts[id];
                if (!scorsInfo[id]) {
                  scorsInfo[id] = {};
                }
                subq.score = parseInt(scorsInfo[id].score || 0);
                subq.rootContent = fullquestion.content;
                if (fullquestion.audiourl) {
                  subq.rootAudioURL = fullquestion.audiourl;
                }
                if (fullquestion.videourl) {
                  subq.rootVideoURL = fullquestion.videourl;
                }
                exam.totalScore += subq.score;
                idx++;
                subq.newIdx = subq.q_index = idx;
                // _questions.push(subq);
                addMQinQue(subq, sortFlag);
              }
            })
          }
        }
      } else if (question.title) {
        addQinQue(question, sortFlag);
      }
    });
    getFullQue(sortFlag);
    delete exam['questions'];
    exam.questions = newseq;
    return exam;
  }
  var _paper;

  function loadPaper() {
    var info = {
      id: paperId,
      action: "getfullpaper",
    };
    console.log(_self.type);
    if (paperType == "Dynamic" || paperType == "test") {
      info.action = "getfulldpaper";
      info.cid = _self.cid;
    } else {
      console.log('Not supported');
    }
    console.log(info);
    examApi(info, function(data) {
      console.log(data);
      if (!data) {
        return;
      }
      _self.startNum = 0;
      _self.qbanks = data.qstList;
      _self.counter = _self.qbanks.length;
      var q = _self.qbanks[_self.startNum];
      var _data = {
        qstList: [q],
        paper: data.paper,
      }
      createPaper(_data);
    });
  }

  function initQuesVideo(q) {
    if (!q || !q.video) return;
    q.videourl = null;
    $timeout(function() {
      q.videourl = $sce.trustAsResourceUrl(_self.videoPath + encodeURI(q.video))
    }, 200)
  }

  function timerHandler() {
    if (!_self.submitted) {
      _self.use_time++;
      if (_self.time_limit > 0) {
        var timeLeft = _self.time_limit - _self.use_time;
        if (timeLeft <= 0) {
          // time up
          if (!_self.submitted) {
            _self.submit();
          }
        }
        if (Math.floor(timeLeft / 60) < 10) {
          _self.sTimer = "0" + Math.floor(timeLeft / 60) + " : " + (timeLeft % 60);
        } else {
          _self.sTimer = Math.floor(timeLeft / 60) + " : " + (timeLeft % 60);
        }
      }
    } else {
      $interval.cancel(inTimer);;
    }
  };
  var inTimer = $interval(timerHandler, 1000);
  this.loadExercise = function() {};
  this.currentQ = 0;
  $scope.dissQue = function() {
    $scope.queShow = false;
  }
  $scope.clickQue = function() {
    _self.selectQuestion = [];
    for (var n = 0; n < _self.counter;) {
      _self.selectQuestion.push(++n);
    }
    $scope.queShow = true;
  }
  this.gotoQuestion = function(index) {
    console.log(_self.question, index);
    var idx = index - 1;
    console.log(idx)
    if (_self.question.type == 'mfill' || _self.question.type == 'multiple') {
      for (var i = 0; i < _self.question._options.length; i++) {
        if (_self.question._options[i].selection) {
          _self.question.result = _self.question._options[i].selection;
          break;
        }
      }
    } else if (_self.question.type == 'single') {
      for (var i = 0; i < _self.question._options.length; i++) {
        if (_self.question._options[i].correct) {
          _self.question.correctAnswer = i;
          break;
        }
      }
      console.log(_self.question);
    }
    if (idx >= 0 && idx < _self.counter) {
      _self.currentQ = idx;
      _self.startNum = idx;
      _self.question = this.exam.questions[idx];
      //console.log(_self.question);
      //init();
    }
    console.log(MystudyService.myQuestions, _self.question._id);
    if (MystudyService.myQuestions && MystudyService.myQuestions.indexOf(_self.question._id) > -1) {
      _self.question.favourite = true;
    }
    _self.questionNumber = index;
    if (_type == 'practise') {
      _self.flage = true;
      if ($localstorage.getSelectQuestionResult(_self.cid, paperId)) {
        $scope.selectQuestionTrue = $localstorage.getSelectQuestionResult(_self.cid, paperId);
      }
    } else if (_type == 'exam' && _self.isQuestionBank != 2) {
      if ($localstorage.getSelectQuestionResultLib(_self.cid)) {
        $scope.selectQuestionTrue = $localstorage.getSelectQuestionResultLib(_self.cid);
      }
    } else {
      $localstorage.getSelectQuestionResultTagging(this.cid, paperId, _self.startNum, _self.exam.questions[0]._id, _self.flage);
    }

    initQuesVideo(_self.question);
  };
  this.gotoSpecificQuestion = function(idx) {
    // console.log(_self.question);
    console.log(idx)
    if (_self.question.type == 'mfill' || _self.question.type == 'multiple') {
      console.log(_self.question._options.length)
      for (var i = 0; i < _self.question._options.length; i++) {
        if (_self.question._options[i].answer) {
          _self.question.result = _self.question._options[i].answer;
          break;
        }
      }
    } else if (_self.question.type == 'single') {
      for (var i = 0; i < _self.question._options.length; i++) {
        if (_self.question._options[i].correct) {
          _self.question.correctAnswer = i;
          break;
        }
      }
      console.log(_self.question);
    }
    if (idx > 0 && idx <= _self.counter) {
      _self.question = this.exam.questions[idx - 1];
      _self.startNum = idx - 1;
      _self.currentQ = idx - 1;
    }
    initQuesVideo(_self.question);
    $scope.queShow = false;
    if (_type == 'practise') {
      _self.flage = true;
      if ($localstorage.getSelectQuestionResult(_self.cid, paperId)) {
        $scope.selectQuestionTrue = $localstorage.getSelectQuestionResult(_self.cid, paperId);
      }
    } else if (_type == 'exam' && _self.isQuestionBank != 2) {
      if ($localstorage.getSelectQuestionResultLib(_self.cid)) {
        $scope.selectQuestionTrue = $localstorage.getSelectQuestionResultLib(_self.cid);
      }
    } else {
      $localstorage.getSelectQuestionResultTagging(this.cid, paperId, _self.startNum, _self.exam.questions[0]._id, _self.flage);
    }

    init();
  };
  this.selectSingle = function(index, opt) {
    console.log(opt);
    _self.question.result = opt.text;
    //_self.question.selected = opt.index;
  }
  this.submit = function() {
    //CommonService.showConfirm("您确定要提交吗？",function(){
    var exam = _self.exam;

    _self.hideQuestion = !_self.review;
    var _result = ExamService.calResult(exam);

    _result.type = _self.type;
    _result.eid = exam._id;
    _result.reasonid = _self.eid;
    _result.reasontype = _type;
    //scores:get_score,
    _result.time = _self.use_time;
    $scope.timespent = _self.use_time;
    _result.action = "saveexamrecord";
    if (_self.courseID || exam.cid) {
      _result.cid = _self.courseID || exam.cid; // course id higher than paper cid
    }
    if (_type == 'test') {
      _result.action = "savetestrecord";
    } else if (_type == 'error' || _type == 'personal') {
      _result.action = "saveerrorrecord";
    }
    _self.submitted = true;
    if (_result.correct == 1) {
      _self.flage = true;
    } else {
      _self.flage = false;
    }
    if (_type == 'practise') {
      $localstorage.setSelectQuestionResult(this.cid, paperId, _self.startNum, _self.exam.questions[0]._id, _self.flage);
      //cid 课程id  paperId：考试id  _self.currentQ 索引  _self.exam.questions[0]._id  问题id  flage 这道题是否答错
    } else if (_type == 'exam' && _self.isQuestionBank != 2) {
      if(exam.questions[0].answerd) {
        $localstorage.setSelectQuestionResultLib(this.cid, paperId, _self.startNum, _self.exam.questions[0]._id, _self.flage);
        $scope.selectQuestionTrue = $localstorage.getSelectQuestionResultLib(_self.cid);
      }
    } else {
      $localstorage.setSelectQuestionResultTagging(this.cid, paperId, _self.startNum, _self.exam.questions[0]._id, _self.flage);
    }
    //})
  };
  this.qbanks = [];

  function init() {
    if (_type == 'practise') { //练习类
      _self.isQuestionBank = 1;
      _self.title = "practise";
      if (!_self.qbanks || !_self.qbanks.length) {
        loadPaper();
        if ($localstorage.getSelectQuestionResult(_self.cid, paperId)) {
          $scope.selectQuestionTrue = $localstorage.getSelectQuestionResult(_self.cid, paperId);
        }
      } else {
        var _num = Number.parseInt(_self.startNum);
        if (_num >= _self.qbanks.length) {
          return console.log("error", _num, _self.qbanks.length);
        }
        console.log("-- stpe1", _self.startNum, _num);
        var q = _self.qbanks[_num];
        var _data = {
          qstList: [q]
        }
        console.log(q);
        createPaper(_data);
        if ($localstorage.getSelectQuestionResult(_self.cid, paperId)) {
          $scope.selectQuestionTrue = $localstorage.getSelectQuestionResult(_self.cid, paperId);
        }
      }
    } else if (_type == 'exam' && _self.isQuestionBank != 2) { //题库类   isQuestionBank 是否需要提交按钮看答案
      getUserFavouriteQuestions().then(function(faveQuestionIds) {
        MystudyService.myQuestions = faveQuestionIds;
        _self.title = "exam";
        var info = {
          action: "countCourseQuestions",
          id: _self.cid,
        };
        ApiService.post('/exam', info).then(function(result) {
          if (result.data.success) {
            _self.counter = result.data.data || 0;
              if(_self.counter>0){
                  var info = {
                      action: "getCourseQuestionsByQuery",
                      id: _self.cid,
                      limit: 1,
                      start: Number.parseInt(_self.startNum)
                  };
                  console.log(info);
                  examApi(info, function(data) {
                      console.log(data);
                      createPaper(data);
                      if ($localstorage.getSelectQuestionResultLib(_self.cid)) {
                          $scope.selectQuestionTrue = $localstorage.getSelectQuestionResultLib(_self.cid);
                      }
                  });
              }else{
                  _self.showQue=true;
              }
          } else {
            _self.counter = 0;
            _self.showQue=true;
          }
          _self.isQuestionBank = $stateParams.isBank;
          console.log('_self.isQuestionBank', _self.isQuestionBank);
        });
        console.log(_self.counter);

      })
    } else { //标注
      if ($localstorage.getSelectQuestionResultTagging(_self.cid)) {
        $scope.selectQuestionTrue = $localstorage.getSelectQuestionResultTagging(_self.cid);
      }

      getUserFavouriteQuestions().then(function(faveQuestionIds) {
        MystudyService.myQuestions = faveQuestionIds;

        if (!MystudyService.lastCourseId || (MystudyService.lastCourseId != _self.cid) || !MystudyService.myQuestions) {
            _self.counter = MystudyService.myQuestions.length;
            MystudyService.lastCourseId = _self.cid;
            var _num = Number.parseInt(_self.startNum);
            if (_num >= MystudyService.myQuestions.length) {
              return console.log("error", _num, MystudyService.myQuestions.length);
            }
            var id = MystudyService.myQuestions[_num];

            var _info = {
              action: 'getQuestion',
              id: id,
            }
            examApi(_info, function(data) {
              console.log(data);
              //var _data =
                if(!data){
                    $scope.questionDel=true;
                    $scope.id=id;
                }else{
                  var _data = {
                    qstList: [data]
                  }
                  createPaper(_data);
                }
            });
        } else {
          var _num = Number.parseInt(_self.startNum);
          _self.counter = MystudyService.myQuestions.length;
          if (_num >= MystudyService.myQuestions.length) {
            return console.log("error", _num, MystudyService.myQuestions.length);
          }
          var id = MystudyService.myQuestions[_num];
          var _info = {
            action: 'getQuestion',
            id: id,
          }
          console.log(_info);
          examApi(_info, function(data) {
            console.log(data);
              if(!data){
                  $scope.questionDel=true;
                  $scope.id=id;
              }else{
                  var _data = {
                      qstList: [data]
                  }
                  createPaper(_data);
              }
          });
        }

      })
    }
  }

  function getUserFavouriteQuestions() {
    var deferred = $q.defer();
    var promise = deferred.promise;
    ApiService.post('/exam', {
      uid: loginService.user._id,
      lid: _self.cid,
      action: 'getUserFaviorateQuestions',
    }).then(function(result) {
      if (result.data.success) {
        deferred.resolve(result.data.data)
      }
    });
    return promise;
  }

  function createPaper(data) {
    console.log(data);
      _self.showQue=true;
    _self.description = $filter('trans')({
      eng: 'ReTest all the error questions',
      chn: '巩固复习错误的问题'
    });

    if (_self.isQuestionBank == 0 && _type == 'exam') {
      _self.submitted = true;
    } else {
      _self.submitted = false;
    }
      console.log(_self.isQuestionBank,_self.title, _type, _self.submitted);
      console.log(_self.isQuestionBank==1&&_self.title=='exam'&&!_self.submitted)
    //console.log(exam);
    if (!data.qstList.length) {

      _self.exam = {};
      _self.exam.des = $filter('trans')({
        eng: 'No Records',
        chn: '无记录'
      });
        return;
    } else {
      var qsts = data.qstList;
      if (!data.paper) {
        var _questions = [];
        angular.forEach(qsts, function(val, index) {
          var q = {
            type: val.type,
            id: val._id,
            score: val.score,
          }
          _questions.push(q);
        })
        data.paper = {
          questions: _questions,
        };
      }
      _self.exam = prepareQuestions(data);
      console.log(_self.exam)
      _self.exam.des = $filter('trans')({
        eng: 'ReTest all the error questions',
        chn: '巩固复习错误的问题'
      });
      _self.selectQuestion = [];
      for (var n = 0; n < _self.counter;) {
        _self.selectQuestion.push(++n);
      }
      _self.question = _self.exam.questions[0];
      console.log(_self.question)
      _self.gotoQuestion(0);
      _self.totalscores = _self.exam.totalscores;
    }
    _self.use_time = 0;
    _self.currentQ = 0;
    _self.time_limit = 60 * 300; // convert to seconds
  }
  this.changeQuestion = function(index) {
    if (index == 0) { // 上一题
      if(_self.startNum<=0){
        _self.startNum=1;
      }else{
        _self.startNum -= 1;
      }

    } else if (index == 1) { // 下一题
      if(_self.startNum>=_self.selectQuestion.length){
        _self.startNum=_self.selectQuestion.length;
      }else{
        _self.startNum += 1;
      }

    }

    console.log(_self.startNum);
    init()
  }
  this.toNumber = 1;
  this.changeToQuestion = function(number) {
    _self.startNum = number - 1;
    init();
  }
  init();
  this.retest = function() {
    init();
  }
  this.favourite = function() {
    //console.log('favourite', _self.question.favourite);
    if (_self.question&&!_self.question.favourite) {
      var info = {
        action: "addUserFaviorateQuestion",
        lid: _self.cid,
        qid: _self.question._id,
      };
      console.log(info);
      examApi(info, function(data) {
        console.log(data);
      });
      if (!MystudyService.myQuestions) {
        MystudyService.myQuestions = [];
      }
      MystudyService.myQuestions.push(_self.question._id);
      _self.question.favourite = true;
    } else {
       var id="";
        if($scope.questionDel){
            id=$scope.id;
            $scope.initfreash=true;
        }else{
            id=_self.question._id;
        }
      var info = {
        action: "deleteUserFaviorateQuestion",
        lid: _self.cid,
        qid: id
      };
      console.log(info);
      examApi(info, function(data) {
        console.log(data);
          $scope.questionDel=false;

      });
      var pos = MystudyService.myQuestions.indexOf(id);
      if (pos > -1) {
        MystudyService.myQuestions.splice(pos, 1);
      }
      if(_self.question&&_self.question.favourite){
         _self.question.favourite = false;
      }
        if($scope.initfreash){
            init();
        }
    }
      //if(_self.question&&_self.question.favourite){
      //    _self.question.favourite = !_self.question.favourite;
      //}

  }
  $scope.numToLetters = function(num) {
    return String.fromCharCode(65 + num);
  };
  this.share = function() {
    console.log(_self.exam);
    var link = ApiService.HOST + '/app/#/examdetails/' + _self.paperType + '/' + _self.eid;
    console.log(link);
    CommonService.showShareDialog($scope, _self.exam.title, null, link, _self.exam.des);
  };
  this.goBack = function() {
    if (_self.isQuestionBank && _self.submitted) {
      _self.submitted = false;
    } else {
      $ionicHistory.goBack()
    }
  }
});
