angular.module('bamboo.study').controller('MyStudyExamCtrl', function ($scope, $stateParams, ApiService,utilService, CommonService, MystudyService, loginService,AppConfig, CourseService, $filter) {
  var _self = this;
  this.cid = $stateParams.cid;  
  this.examtype = $stateParams.examtype; 
  this.title = $stateParams.examtype == "chapter" ? "章节练习" : ($stateParams.examtype == "practice" ? "专项练习" : "模拟考试")
  console.log(this.cid,this.examtype)
  function getMyExam() {
    var examinfo = {
      action: 'getTypeExamsForCourse',
      cid: _self.cid,
      type: _self.examtype

    }
    console.log(examinfo);
    ApiService.post('/lcourses', examinfo).then(function(result) {
      console.log(result);
      $scope.examitems=result.data.data.items;
      console.log($scope.examitems)
      var completed=0;
      angular.forEach($scope.examitems,function(item){
        if(item.recordId){
          completed++;
        }
      })
      _self.completed=completed;
      _self.outstanding = $scope.examitems.length - completed;
    });
  }
  getMyExam();
  utilService.watchScroll($scope);
});
