angular.module('bamboo.study').controller('ExamNumberCtrl', function($scope, $stateParams, ApiService, CommonService, MystudyService, loginService) {
  var _self = this;
  _self.examnumber = [];
  this.isBank = $stateParams.isBank;
  this.title = $stateParams.isBank == 1 ? "题库模式" : "背题模式"
  this.cid = $stateParams.cid;
  this.getQuestionsForOnePage = function() {
    var info = {
      action: "countCourseQuestions",
      id: _self.cid,
    };
    console.log(info);
    ApiService.post('/exam', info).then(function(result) {
      // console.log(result);
      if (result.data.success) {
        console.log(result.data.data)
        _self.counter = result.data.data || 0;
        for (var i = 0; i < _self.counter; i++) {
          _self.examnumber.push(i)
        }
      } else {
        _self.counter = 0;
      }
      console.log(_self.examnumber)
      MystudyService.examQuestionCounter = _self.counter;
    });
  };
  this.getQuestionsForOnePage();

  function getMyCourseFavioratedQuestions() {
    var info = {
      uid: loginService.user._id,
      lid: _self.cid,
      action: 'getUserFaviorateQuestions',
    }
    console.log(info);
    ApiService.post('/exam', info).then(function(result) {
      console.log(result);
      if (result.data.success) {
        console.log(result.data.data)
        MystudyService.myQuestions=result.data.data;
      }
    });
  }
  getMyCourseFavioratedQuestions();
});