// Ionic Starter App
// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('bamboo.survey', ['ionic']).config(function($stateProvider, $urlRouterProvider) {
  $stateProvider.state('app.survey', {
    url: '/survey',
    views: {
      'Content@app': {
        templateUrl: 'app/survey/survey_list.html',
        controller:"surveyListCtrl as ctrl",
      }
    }
  }).state('app.survey.take', {
    url: '/takes/:id',
    views: {
      'Content@app': {
        templateUrl: 'app/survey/take_survey.html',
        controller: "takesurveyCtrl as ctrl",
      }
    }
  }).state('app.survey.result', {
    url: '/result/:id',
    views: {
      'Content@app': {
        templateUrl: 'app/survey/surveyresult.html',
        controller: "surveyresultCtrl as ctrl",
      }
    }
  })
});