'use strict';
angular.module('bamboo.task').controller('taskApplicationListCtrl', function($scope, $rootScope, $translate, ApiService, CommonService, $stateParams, $state, $filter, $ionicPopover, CourseApi) {
  var self = this;

  $scope.items = [];
  var courseid = $stateParams.lid;
  console.log(courseid);
  var _tableState;
  this.toenroll = {};
  this.selectallval = false;
  this.itemNumber = 10;

  this.del = function(id) {
    var info = {
      aid: id,
      action: "delenrollapplication",
    };
    CourseApi.lcApi(info, function(result) {
      self.getitems();
    });
  }
  this.approve = function(id) {
    var info = {
      aid: id,
      action: "approveenroll",
    };
    CourseApi.lcApi(info, function(result) {
      self.getitems();
    });
  }
  this.approves = function() {
    var ids = [];
    for (var key in self.toenroll) {
      var val = self.toenroll[key];
      if (val) {
        ids.push(key);
      }
    }
    if (ids.length < 1) {
      CommonService.showError('Please select one record!');
      return;
    }
    var info = {
      ids: ids,
      action: "approveenrolls",
      cid: courseid
    };
    console.log(info);
    CourseApi.lcApi(info, function(result) {
      console.log(result);
      self.getitems();
    });
  }
  this.getitems = function() {
    // var search = tableState.search.predicateObject;
    var info = {
      start: 0,
      limit: Number.MAX_SAFE_INTEGER,
      lid: courseid,
      action: "getcourseenrolls"
    };
    console.log(info);
    CourseApi.lcApi(info, function(result) {
      console.log(result);
      self.toenroll = {};
      $scope.displayedItems = result.items;
      console.log($scope.displayedItems);
      //appendClass2Items();
      $scope.total = result.counter;
      // tableState.pagination.numberOfPages = Math.ceil(result.counter / limit);
    });
  };
  this.getitems();
  this.selectall = function() {
    if (self.selectallval) {
      angular.forEach($scope.displayedItems, function(val, idx) {
        if (!val.approved) self.toenroll[val._id] = true;
      });
    } else {
      angular.forEach($scope.displayedItems, function(val, idx) {
        if (!val.approved) self.toenroll[val._id] = false;
      });
    }
  };

  function appendClass2Items() {
    angular.forEach($scope.displayedItems, function(item, idx) {
      classModel.getClassInfoByUserId(item.username).then(function(classes) {
        console.log(classes);
        var classList = classes || [];
        var classNameList = [];
        angular.forEach(classList, function(cls, idx) {
          classNameList.push(cls.name);
        });
        var myclasses = classNameList.join('/');
        item.classes = myclasses;
      });
    });
  }
});