'use strict';
angular.module('bamboo.task').controller('taskExamListCtrl', function($scope, $rootScope, $translate, ApiService, CommonService, $stateParams, $state, ExamService, $filter, $ionicPopover) {
  var self = this;
  self.cid = $stateParams.lid;
  this.getExams = function() {

    var info = {
      action: "getallexamitems",
      limit: Number.MAX_SAFE_INTEGER,
      start: 0,
      cid: self.cid
    };

    console.log(info);
    ExamService.api(info, function(data) {
      console.log(data);
      $scope.items = data.items;
      judgeExamExpired($scope.items);
      self.total = data.counter;
    });
  };
  this.getExams();

  function judgeExamExpired(examList) {
    angular.forEach(examList, function(exam, idx) {
      console.log(exam);
      if (exam.timecontrol && exam.publish && exam.start && exam.stop) {
        var start = new Date(exam.start);
        var stop = new Date(exam.stop);
        var now = Date.now();
        if (now > stop) {
          exam.examExpired = true;
        }
      }
    });
  }
});