// Ionic Starter App
// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('bamboo.task', ['ionic']).config(function($stateProvider, $urlRouterProvider) {
  $stateProvider.state('app.task', {
    url: '/task',
    views: {
      // 'Content@app': {
      //   templateUrl: 'app/task/task.html',
      //   controller: "taskHomeCtrl as ctrl",
      // }
    },
    // data_rightbutton: {
    //   skip: true
    // }
  }).state('app.task.application', {
    url: '/application',
    views: {
      'Content@app': {
        templateUrl: 'app/task/application.html',
        controller: "taskApplicationCtrl as ctrl",
      }
    }
  }).state('app.task.application.list', {
    url: '/:lid/list',
    views: {
      'Content@app': {
        templateUrl: 'app/task/applicationlist.html',
        controller: "taskApplicationListCtrl as ctrl",
      }
    }
  }).state('app.task.assignment', {
    url: '/assignment',
    views: {
      'Content@app': {
        templateUrl: 'app/task/assignment.html',
        controller: "taskAssignmentCtrl as ctrl",
      }
    }
  }).state('app.task.assignment.list', {
    url: '/:lid/list',
    views: {
      'Content@app': {
        templateUrl: 'app/task/assignmentlist.html',
        controller: "taskAssignmentListCtrl as ctrl",
      }
    }
  }).state('app.task.assignment.list.record', {
    url: '/:aid/record',
    views: {
      'Content@app': {
        templateUrl: 'app/task/assignmentrecords.html',
        controller: "taskAssignmentListRecordCtrl as ctrl",
      }
    }
  }).state('app.task.exam', {
    url: '/exam',
    views: {
      'Content@app': {
        templateUrl: 'app/task/exam.html',
        controller: "taskExamCtrl as ctrl",
      }
    }
  }).state('app.task.exam.list', {
    url: '/:lid/list',
    views: {
      'Content@app': {
        templateUrl: 'app/task/examlist.html',
        controller: "taskExamListCtrl as ctrl",
      }
    }
  }).state('app.task.exam.list.records', {
    url: '/:examid/records',
    views: {
      'Content@app': {
        templateUrl: 'app/task/examrecords.html',
        controller: "taskExamListRecordCtrl as ctrl",
      }
    }
  })
});