// Ionic Starter App
// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('bamboo.usecase', ['ionic']).config(function($stateProvider, $urlRouterProvider) {
  $stateProvider.state('app.usecase', {
    url: '/usecase',
    views: {
      'Content@app': {
        templateUrl: 'app/usecase/usecase.html',
        controller: "UsecaseListCtrl as ctrl"
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.usecase.detail', {
    url: '/detail/:id',
    views: {
      'Content@app': {
        templateUrl: 'app/usecase/detail.html',
        controller: "UsecaseDetailCtrl as ctrl"
      }
    }
  })
});
