'use strict';
angular.module('bamboo.user').controller('UserProfileCtrl', function($scope, ApiService, $stateParams, CommonService) {
  var self = this;
  $scope._SHOST = ApiService.SHOST;
  this.nid = $stateParams.id || '';
  this.publicUrl = ApiService.SHOST + "/public/images/";
  this.defaultPersonPhotoUrl = this.publicUrl + "user_icon&48.png";
  this.avatarpath = ApiService.PSURL + "/avatar/";
  $scope._RES = ApiService.RES;
  this.user = {};

  ApiService.get('/profile/' + self.nid /*!loginService.loggedDomain */).then(function(result) {
    //console.log(result);
    if (result.data.success) {
      self.user = result.data.data;
      console.log(self.user);
      getUserTopics();
      getReplyTopics();
    }
  });

  this.sendmessage=function(){
 /*   CommonService.sendmsgdlg({     //*****************  to implement ionic modal dialog for send message
      "userid" : self.user.id,
      "name" : self.user.fullname,
    });*/
  }

  function getUserTopics() {
    ApiService.get('/userapi/recent_topics/' + self.user.id).then(function(result) {
      //console.log(result);
      if (result.data.success) {
        $scope.topics = result.data.data;
      }
    });
  }

  function getReplyTopics() {
    ApiService.get('/userapi/recent_replies/' + self.user.id).then(function(result) {
      //console.log(result);
      if (result.data.success) {
        $scope.replytopics = result.data.data;
      }
    });
  }

  this.sendmsgfromctrl = function(){
    CommonService.showmessagefromservice($scope, self.user.id, self.user.fullname);
  };

});
