angular.module('bamboo.common', ['ionic', "ionic.native"]).service('ApiService', function($http, $ionicPlatform, $q, ServerLists, $localstorage, $timeout, $translate, $rootScope, $location) {
  'use strict';
  var self = this;
  this.key;
  this.gid = $localstorage.get('groupid');
  this.category = null;
  this.version=1;
  this.serverversion;
  this.blogcategory;
  this.school;
  this.tempIndex = -1;

  /*var siteid='debug';
  $localstorage.set('subdomain','lta');
  $localstorage.set('site',siteid );
  self.subdomain='lta';*/

  var siteid='zgdrv';
  $localstorage.set('subdomain','lta');
  $localstorage.set('site',siteid );
  self.subdomain='lta';

  // var siteid='ltatraining';
  // $localstorage.set('subdomain','lta');
  // $localstorage.set('site',siteid );
  // self.subdomain='lta';



  var SITEINFOS = ServerLists[siteid];

  var newhost = SITEINFOS.APIDOMAIN;
  var _lan = $localstorage.get('language');
  _lan = $localstorage.get('language');
  if (_lan) {
    $translate.use(_lan);
    console.log(_lan);
  }
  this.initConstant = function(id) {
    console.log("Init Constants");
    // if (id) {
    //   siteid = id;
    // }
    // if (!siteid||!ServerLists[siteid]) {
    //   siteid = 'bamboostudy';
    // }
   // siteid = 'bamboostudy';
   // $localstorage.set('subdomain','lta');


    SITEINFOS = ServerLists[siteid];
    newhost = SITEINFOS.APIDOMAIN;
    console.log("--- api service 1 ---");
    self.HOSTS = "http" + '://' + newhost//SITEINFOS.PROTOCOL + '://' + newhost;
    if(SITEINFOS.PROTOCOL=='https'){
      self.HOSTS = "https://" + newhost//SITEINFOS.PROTOCOL + '://' + newhost;
    }
    self.country=SITEINFOS.Country;
    if (SITEINFOS.FULLDOMAIN) {
      self.HOST = SITEINFOS.PROTOCOL + '://' + SITEINFOS.FULLDOMAIN;
    } else {
      self.HOST = SITEINFOS.PROTOCOL + '://' + self.subdomain + "." + SITEINFOS.MAINDOMAIN;
    }

    self.FACIALRECURL = SITEINFOS.FACIALRECURL;
    self.RES = SITEINFOS.RES;
    self.SHOST = SITEINFOS.SHOST;
    self.PSURL = SITEINFOS.SHOST + '/public/' + SITEINFOS.RES;
    self.UI_SERVER = self.HOSTS + '/uall';
    self.getSchoolInfo();
  }

  this.Categories;
  this.categoryInfo;
  this.forumcategory;
  this.forumcategoryKeys = [];
  var _vrr = [];

  function getArray(obj, level) {
    if ((typeof obj) === "object") {
      for (var key in obj) {
        var _i = {
          key: key,
          value: level,
          title: key
        };
        _vrr.push(_i);
        var info = obj[key];
        if (typeof info === "object") {
          getArray(info, level + 1)
        }
      }
    }
  }

  function getKeyArray(obj) {
    getArray(obj, 0);
    //console.log(_vrr);
    self.Categories = _vrr;
    var _rrr = {};
    for (var i = 0; i < _vrr.length; i++) {
      var info = _vrr[i];
      var key = info.key;
      _rrr[key] = [];
      _rrr[key].push(key); // first value will be key itself
      //var level=info.level;
      for (var j = i + 1; j < _vrr.length; j++) { // search all the item until the same level key found
        var next = _vrr[j];
        if (info.value < next.value) {
          _rrr[key].push(_vrr[j].key)
        } else {
          break;
        }
      }
    }
    //console.log(_rrr);
    self.categoryInfo = _rrr;
  }

  function getMainJsonKeys(jsondata) {
    var keys = [];
    for (var key in jsondata) {
      keys.push(key);
    }
    return keys;
  }
  var _schoolversion;
  this.compareVersion=function(source,target){
    console.log(source,target)
    var verSources=source.split('.');
    var verTarget=target.split('.');
    //var bigger=true;
    for(var i=0;i<verSources.length;i++){
      var src=parseInt(verSources[i]);
      if(verTarget.length<(i+1)){
        return false;
      }
      var tar=parseInt(verTarget[i]);
      if(src>tar){
        return true;
      }
      if(src<tar){
        return false;
      }

    }
    return false;
  }

  function updateschoolversion() {
    _schoolversion = self.school.update;
    var time = (new Date()).toISOString();
    // console.log(time);
    $localstorage.set('lastschoolapidate', time);
  }
  var _lastapicall = new Date();
  var _timechecktimer;
  var CONTINUETIME = 1000*15; // 5 second
  var SCHOOLVERCHECK = 1000 * 60*30; // 10 minutes

  function idlecheck() {
    var lastschoolupdate = $localstorage.get('lastschoolapidate');
    if (lastschoolupdate) {
      var lastupdatetime = new Date(lastschoolupdate);
      var now = new Date();
      if (now - lastupdatetime > SCHOOLVERCHECK) {
        var info = {
          action: 'getschoolversion',
        }
        self.post('/site', info).then(function(result) {
          console.log(result);
          if (result.data.success) {
            if (_schoolversion == result.data.data) {
             // console.log('-- school info same');
            } else {
             // console.log('-- school info need to be updated --');
              self.getSchoolInfo(null, true);
            }
          }
          var now = new Date();
          $localstorage.set('lastschoolapidate', now);
        })
      }
    }
  }

  function apicheck() {
    if (!self.subdomain) {
      console.log('--- no subdomain , can not do anything ---');
      return;
    }
    var now = new Date();
    if ((now - _lastapicall) < CONTINUETIME) {
      if (_timechecktimer) {
        $timeout.cancel(_timechecktimer);
      }
    }
    _lastapicall = now;
    _timechecktimer = $timeout(idlecheck, CONTINUETIME);
  }

  // this.getFeedbackCategory = function(){
  //   var deferred = $q.defer();
  //   var promise = deferred.promise;
  //   var subdomain = $localstorage.get('subdomain');
  //   var info = {
  //     url: self.HOSTS + "/uapi/getSchoolId/"+subdomain,
  //     method: "GET",
  //     headers: {
  //       'Content-Type': 'application/json'
  //     },
  //     withCredentials: true
  //   };
  //   console.log(info);
  //   $http(info).success(function(data){s
  //     console.log(data);
  //     var oCats = data.feedbackcategory || {};
  //     deferred.resolve(Object.keys(oCats));
  //   }).error(function(error){
  //     deferred.reject(error);
  //   });
  //   return promise;
  // }
  this.getSchoolInfo = function(key, forceflag) {
    console.log("--- get school info");
    var subdomain = key;
    if (!key) {
      subdomain = $localstorage.get('subdomain');
    }
    var deferred = $q.defer();
    if (subdomain == self.key && !forceflag) {
      deferred.resolve(self.school);
      return deferred.promise;
    }
    console.log("--- school info api");
    // console.log("--- retrieve");
    var info = {
     // url: self.HOSTS + "/uapi/getSchoolId/" + subdomain,
      url: self.HOSTS + "/uall/setting",
      method: "GET",
      headers: {
        'Content-Type': 'application/json'
      },
      withCredentials: true
        // async: false,
    };
    //console.log(info);
    $http.defaults.useXDomain = true;
    $http(info).success(function(data) {
      // console.log("-- return value");
      // console.log(data);
      if (data.success) {
       // self.gid = data.school._id;
       // self.key = subdomain;
        self.school = data.setting;
        // _lan = $localstorage.get('language');
        // if (!_lan) {
        //   if (self.school.language && (self.school.language == 'Chinese' || self.school.language == 'cn')) {
        //     $translate.use('cn');
        //   }
        // }
        $translate.use('cn');
        console.log(self.school.language);
        $rootScope.currentSchool = data.setting;
        // if (typeof self.school.wikiFlag == "undefined") {
        //   self.school.wikiFlag = true;
        // }
        // if (typeof self.school.forum == "undefined") {
        //   self.school.forum = true;
        // }
        // if (typeof self.school.courseFlag == "undefined") {
        //   self.school.courseFlag = true;
        // }
        // if (typeof self.school.blogFlag == "undefined") {
        //   self.school.blogFlag = true;
        // }
        // if (typeof self.school.newsFlag == "undefined") {
        //   self.school.newsFlag = true;
        // }
        // if (typeof self.school.BBSFlag == "undefined") {
        //   self.school.BBSFlag = true;
        // }
        // if (typeof self.school.mySpaceFlag == "undefined") {
        //   self.school.mySpaceFlag = true;
        // }
        // if (typeof self.school.eventFlag == "undefined") {
        //   self.school.eventFlag = true;
        // }
        // if (typeof self.school.classFlag == "undefined") {
        //   self.school.classFlag = true;
        // }
       // $timeout(updateschoolversion, 100);
        self.category = data.category;
       // getKeyArray(self.category);
        // self.knowledges = data.knowledges;
        // self.serverversion=data.version;
        // self.forumcategory = data.forumcategory;
        //self.materialgroup = data.materialgroup||{};
        // self.blogcategory = data.school.blogcategory;
        // if (!self.blogcategory || self.blogcategory.length < 1) {
        //   self.blogcategory = defaultblogcategory;
        // }
        deferred.resolve(data.setting);
      } else {
        self.gid = null;
        self.category = null;
        deferred.reject(null);
      }
    }).error(function(msg, code) {
      self.gid = null;
      self.category = null;
      deferred.reject(msg);
    });
    return deferred.promise;
  };
  self.initConstant();
  //self.getSchoolInfo();
  this.getFullUrl = function(url) {
    return self.UI_SERVER +  url;
  };
  this.getApiRoot=function(){
    return self.UI_SERVER + "/";
  }
  this.getUpLoadUrl = function(url) {
    // var fullurl = self.UI_SERVER + "/" + self.gid + url;
    // if (SITEINFOS.UPLOAD) {
     var fullurl = SITEINFOS.PROTOCOL + '://' + SITEINFOS.UPLOAD + url;
    // }
    console.log(fullurl);
    return fullurl;
  };
  var getParameters = function(method, url, data) {
    var params = {
      url: self.getFullUrl(url),
      method: method,
      headers: {
        'Content-Type': 'application/json'
      },
      withCredentials: true
        // async: false,
    };
    if (method === 'POST' || method === 'PUT') {
      params.data = data;
    }
    return params;
  };
  this.request = function(method, url, data) {
    var httpParams = getParameters(method, url, data);
    $http.defaults.useXDomain = true;
    apicheck();
    return $http(httpParams);
  };
  this.get = function(url) {
    return this.request('GET', url);
  };
  this.post = function(url, data) {
    return this.request('POST', url, data);
  };
  this.delete = function(url) {
    return this.request('DELETE', url);
  };
  this.put = function(url, data) {
    return this.request('PUT', url, data);
  };
  this.setGid = function(gid) {
    this.gid = gid;
  };
  this.getLocalJsonFile = function(name) {
    var deferred = $q.defer();
    var promise = deferred.promise;
    $http.get('js/json/'+name).success(function(data) {
      deferred.resolve(data);
    });
    return deferred.promise;
  }
});
