angular.module('bamboo.controllers', ['ionic','ionic.native']).controller('AppCtrl', function($rootScope,$localstorage,ApiService, $ionicPlatform,loginService,AppConfig,$state,$timeout) {
  // With the new view caching in Ionic, Controllers are only called
  // when they are recreated or on app start, instead of every page change.
  // To listen for when this page is active (for example, to refresh data),
  // listen for the $ionicView.enter event:
  var self = this;

  applyrightbutton($state.current);

  this.gotourl=function(){
    $state.go(self.righturl);
  }
  function applyrightbutton(toState) {
    self.righturl = null;
    self.righticon = "";
    self.skip=false;

   // console.log(toState);
    if (toState.data_rightbutton) {
      if(toState.data_rightbutton.skip){
        self.skip=true;
        return;
      }
     //   console.log(toState.data_rightbutton);
      if (toState.data_rightbutton.url) {
        self.righturl = toState.data_rightbutton.url;
      }
      if (toState.data_rightbutton.icon) {
        self.righticon = toState.data_rightbutton.icon;
      }

    }
   // console.log("--- right button --- " + self.righturl);
    //self.righturl=$rootScope.righturl;
  }
  var msgcounters;
  var checkSecond=AppConfig.IDLECHECKTIMER;
  var msgIndex;
  var updateCounter=0;
   /* function loop() {
    if(!loginService.user){
      console.log('Logout user!');
      return ;
    }
  if(cordova&&cordova.plugins&&cordova.plugins.backgroundMode.isActive()){
     
      getMsgCounters(function(counter){
        if(counter>msgcounters){
          console.log('background mode check now!'+counter);
          if(msgIndex&&updateCounter<5){
            console.log("update");
            updateCounter++;
            $cordovaLocalNotification.update({
              id: msgIndex,
              title: 'Unread Messages : ' + counter,
              text: 'You have ' + counter +' unread messages!',
            }).then(function(result) {
              // ...
            });
          }else{
            console.log("new");
            updateCounter=0;
            msgIndex=parseInt(Math.random()*1000);
            $cordovaLocalNotification.schedule({
              id: msgIndex,
              title: 'Unread Messages : ' + counter,
              text: 'You have ' + counter +' unread messages!',
            }).then(function(result) {
              // ...
            });
          }

        }
        msgcounters=counter;
       // checkSecond+=AppConfig.IDLECHECKTIMER;// slower and slower
        if(checkSecond<30*60){
          checkSecond+=checkSecond*1.5; // timer increase 1.5 times
        }
        console.log(checkSecond);
        setTimeout(loop, checkSecond*1000);
      })
      
    } 
    
  }*/
  function getMsgCounters(callback){
    if(!loginService.user){
      return ;
    }
    var info = {
      action: "getunreadmsgcounter",
    }
    ApiService.post("/user", info).then(function(result) {
      if (result.data.success) {
        return callback(result.data.data);
      }
    });
  }
  if (window.cordova) {
    $ionicPlatform.ready(function() {
    /*  cordova.plugins.backgroundMode.on('enable', function() {
        console.log('Background Task enabled!');
      });
      cordova.plugins.backgroundMode.on('activate', function() {
        console.log('Active Backgroud!');
        checkSecond=AppConfig.IDLECHECKTIMER;
        updateCounter=0;
        msgIndex=null;
        getMsgCounters(function(counter){
          msgcounters=counter;
          setTimeout(loop, checkSecond*1000);
        })
      });
      cordova.plugins.backgroundMode.on('failure', function() {
        console.log('Failure');
      });
     // console.log('background check', cordova.plugins.backgroundMode.isActive());
      cordova.plugins.backgroundMode.enable();
      cordova.plugins.backgroundMode.overrideBackButton();  */

      // FCMPlugin.getToken(
      //   function (token) {
      //     $localstorage.set('deviceToken',token);
      //    // alert('Token: ' + token);
      //     console.log('Token: ' + token);
      //   },
      //   function (err) {
      //    // alert('error retrieving token: ' + token);
      //     console.log('error retrieving token: ' + err);
      //   }
      // );
    });
  }
  $rootScope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams) {
    console.log("--- state change " + toState.name);
    applyrightbutton(toState);
    $rootScope.$previousState = fromState;
  })
});