angular.module('bamboo.common').constant('ServerLists', {
  'ltatraining': {
    APIDOMAIN: 'ltaapi.bamboostudy.com',
    HINT: 'Lta trainning',
    MAINDOMAIN: 'ltatraining.bamboostudy.com',
    UPLOAD: 'ltaupload.bamboostudy.com',
    PROTOCOL: 'http',
    RES: 'resg',
    Country: 'China',
    SHOST: 'http://ltadriving.oss-cn-beijing.aliyuncs.com',
    FACIALRECURL: 'http://103.56.76.145:7010/face/tool/compare'
  },
  'zgdrv': {
    APIDOMAIN: 'gdjtpx.com:49443',
    HINT: 'Drv trainning',
    MAINDOMAIN: 'gdjtpx.com',
    UPLOAD: 'gdjtpx.com:7443',
    PROTOCOL: 'https',
    RES: 'resg',
    Country: 'China',
   // SHOST: 'https://gdjtpx.com:7443/media',
    SHOST: 'https://video.gdjtpx.com/media',
    FACIALRECURL: 'http://103.56.76.145:7010/face/tool/compare'
  },
  'debug': {
   // APIDOMAIN: '192.168.0.170:5000',
   //  APIDOMAIN: '203.117.153.173:5000',
    APIDOMAIN: 'localhost:5000',
    HINT: 'Debug Server',
    //  MAINDOMAIN: 'localhost0',
    // FULLDOMAIN: 'localhost',
    //   UPLOAD: '192.168.0.63:5050',
   // FULLDOMAIN: '192.168.0.170:5000',
    UPLOAD: 'ltaupload.bamboostudy.com',
   // UPLOAD: 'gdjtpx.com:7000',
   // SUBDOMAIN: 'lta',
    PROTOCOL: 'http',
    RES: 'resg',
    Country: 'Singapore',

   // SHOST: 'https://video.gdjtpx.com/media',
    // SHOST: 'http://s3-ap-southeast-1.amazonaws.com/edushare',
    SHOST: 'http://ltadriving.oss-cn-beijing.aliyuncs.com',
    FACIALRECURL: 'http://103.56.76.145:7010/face/tool/compare'
  },
}).constant('DomainLists', {
  'debug': {
    server: 'debug',
    SUBDOMAIN: 'bamboo',
    HINT: 'Debug Server',
  },
});
