'use strict';
angular.module('bamboo.attendance').controller('attendanceCtrl', function($scope, ApiService, $stateParams, utilService) {
  var self = this;

  var page = 0;
  var pagesize = 10;
  var search;
  $scope.items = [];
  $scope.loadMore = function() {
    var info = {
      start: page * pagesize,
      limit: pagesize,
      action: 'getclasseswithattends',
    };
    console.log(info);
    var time;
    if (search && search.time) {
      time = search.time;
      info.day = search.time.toString().substring(0, 10);
      delete search.time;
    }
    ApiService.post("/classes", info).then(function(result) {
      //   console.log(result);
      if (result.data.success) {
        console.log(result.data.data);
        if (time) {
          search.time = time;
        }
        $scope.items = $scope.items.concat(result.data.data.items);
        $scope.totalcounter = result.data.data.counter;
        page++;
        $scope.moreData = $scope.items.length < $scope.totalcounter;

        $scope.$broadcast('scroll.infiniteScrollComplete');
      }
    });
  };

  $scope.$on('$stateChangeSuccess', function() {
    $scope.loadMore();
  });

utilService.watchScroll($scope);
});