// Ionic Starter App
// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('bamboo.blog', ['ionic', "ionic.native"]).config(function($stateProvider, $urlRouterProvider) {
  $stateProvider.state('app.blog', {
    url: '/blog',
    views: {
      'Content@app': {
        templateUrl: 'app/blog/blog.html',
        controller: 'blogsCtrl as ctrl'
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.blog.tab', {
    url: '/list/:tab',
    views: {
      'Content@app': {
        templateUrl: 'app/blog/bloglist.html',
        controller: 'BlogListCtrl as ctrl',
      }
    }
  }).state('app.blog.tab.detail', {
    url: '/detail/:id',
    views: {
      'Content@app': {
        templateUrl: 'app/blog/blog_detail.html',
        controller: 'BlogItemCtrl as ctrl',
      }
    }
  })
});