// Ionic Starter App
// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('bamboo.class', ['ionic']).config(function($stateProvider, $urlRouterProvider) {
  $stateProvider.state('app.class', {
    url: '/class',
    views: {
      'Content@app': {
        templateUrl: 'app/class/list.html',
        controller: 'StudentClassesCtrl as ctrl'
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.class.menu', {
    url: '/:classid/menu',
    views: {
      'Content@app': {
        templateUrl: 'app/class/class_menu_list.html',
        // controller: 'StudentClassesMenuCtrl as ctrl'
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.class.menu.gallerylist', {
    url: '/gallerylist',
    views: {
      'Content@app': {
        templateUrl: 'app/class/class_gallery_list.html',
        controller: 'ClassGalleryListCtrl as ctrl'
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.class.menu.gallerylist.gallery', {
    url: '/:id/gallery',
    views: {
      'Content@app': {
        templateUrl: 'app/class/class_gallery.html',
        controller: 'ClassGalleryCtrl as ctrl'
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.class.menu.newslist', {
    url: '/newslist',
    views: {
      'Content@app': {
        templateUrl: 'app/class/class_news_list.html',
        controller: 'ClassNewsListCtrl as ctrl'
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.teacherclasses', {
    url: '/teacherclasses',
    views: {
      'Content@app': {
        templateUrl: 'app/class/list.html',
        controller: "TeacherClassesCtrl as ctrl"
      }
    }
  })
});