'use strict';
angular.module('bamboo.class').controller('ClassNewsListCtrl', function($scope, $stateParams, ApiService, $sce, CommonService, loginService) {
  var _self = this;
  this.mobileFlag = false;
  this.classid = $stateParams.classid;
  console.log($stateParams);
  this.defaultNewsPhoto = 'assets/images/news_no-image1.jpg';
  console.log(loginService.school);
  this.newsImgBaseUrl = ApiService.SHOST + "/companynews/";
  $scope.setting = this.setting = {
    ctrl: _self,
    hasPhoto: true,
    listName: "news",
    emptyTitle: 'No News!',
    // imageFolderPrefix: ApiService.SHOST + '/public/' + ApiService.RES + '/' + 'schoolnews' + '/',
    defaultImage: this.defaultNewsPhoto,
    pageSize: _self.itemNumber
  };

  this.items = [];
  this.pagesize = 6;
  this.page = 1;
  this.pageChanged = function(newPageNumber) {
    _self.page = newPageNumber;
    getInfo(_self.page - 1);
    console.log("--- next page --");
  };

  this.mobileFlag = true;
  this.nextPage = getInfo;

  function getInfo(page) {
    var info = {
      limit: _self.pagesize,
      start: _self.pagesize * (_self.page - 1),
      cid: _self.classid,
      type: 'class',
      action: "getgroupnewses"
    };

    console.log(info);
    ApiService.post("/advinfo", info).then(function(result) {
      console.log(result.data.data);
      if (result.data.success) {
        console.log(result.data.data);
        if (_self.mobileFlag) {
          if (!_self.items) {
            _self.items = [];
          }
          _self.items = _self.items.concat(result.data.data.items);
        } else {
          _self.items = result.data.data.items;
        }
        _self.totalCount = result.data.data.counter;
        $scope.totalCount = result.data.data.counter;
      }
    });
  }
  getInfo(0);

  this.showNews = function(id, i, fromList) {
    var path = "/groupnews/";
    if (id) {
      ApiService.get(path + id).then(function(result) {
        //  console.log( '-Starting auth session result: ');
        if (result.data.success) {
          console.log(result.data.data);
          _self.news = result.data.data || {};
          if (_self.news.photo) {
            //self.imageUrl = self.newsPicUrl + self.news.photo;
            _self.imageUrl = _self.news.photo ? _self.newsImgBaseUrl + _self.news.photo : _self.defaultNewsPhoto;
          }
          _self.item = _self.news;
          console.log(_self.imageUrl);
          CommonService.showdetail($scope, 'app/news/newsdetail2.html');
        }
      });
    }
  };

});