angular.module('bamboo.company').controller('CompanyItemCtrl', function($scope, ApiService, CommonService,$sce, $stateParams) {
  var _self = this;
  this.id = $stateParams.cid;
  this.item = {};
  this.photoPath = ApiService.SHOST + '/company/';
  this.defaultPhoto = ApiService.SHOST + "/public/images/details.png";
  this.tab = 0;

  function getInfo() {
    var info = {
      action: "getcompany",
      id: _self.id,
    }
    console.log(info);
    CommonService.showLoading();
    ApiService.post("/business", info).then(function(result) {
      CommonService.stopLoading();
      if (result.data.success) {
        _self.item = result.data.data || {};
        console.log(_self.item);
        _self.imageUrl = _self.item.photo ? _self.photoPath + _self.item._id + '/' + _self.item.photo : _self.defaultPhoto;
        if (_self.item.audio) {
          _self.item.audiourl = $sce.trustAsResourceUrl(_self.photoPath + _self.item._id + '/' + encodeURI(_self.item.audio));
        }
        if(_self.item.lat){
           _self.item.mapaddress = $sce.trustAsResourceUrl('https://www.google.com/maps/embed/v1/place?q='+_self.item.postcode+'%20singapore&key=AIzaSyCDpjAui7Bp-lfs3akUG4zGId3RAyhGA1M');
        }
      }
    });
  }
  getInfo();
});