angular.module('bamboo.company').controller('CompanyListInCategoryCtrl', function($scope, ApiService,$stateParams, CommonService) {
  var _self = this;
  //  CommonService.showInfo("news controller");
  console.log("---- CompanyListInCategoryCtrl -----");
  this.key= $stateParams.key;
  this.defaultPhoto = ApiService.SHOST + "/public/images/details.png";
  this.productpath = ApiService.SHOST + '/company/';
  this.page = 0;
  this.moreData = false;
  this.items = [];
  this.nextPage = function() {
    _self.page++;
    getInfo(_self.page);
    console.log("--- next page --");
  }

  function getInfo(page) {
    var pagesize = 6;
    var info = {
      start: pagesize * page,
      limit: pagesize,
      action: "getcompanysbycategory",
      key:_self.key,
    };
    CommonService.showLoading();
    ApiService.post("/business", info).then(function(result) {
      CommonService.stopLoading();
      if (result.data.success) {
        if (!_self.items) {
          _self.items = [];
        }
        _self.items = _self.items.concat(result.data.data.items);
        _self.totalCount = result.data.data.counter;
        _self.moreData = ((_self.totalCount - _self.items.length) > 0);
      }
      $scope.$broadcast('scroll.infiniteScrollComplete');
    });

  }
  getInfo(0);
});