angular.module('bamboo.config').controller('ChangePasswordCtrl', function($scope,$stateParams, CommonService, ApiService, $state, school, loginService, $localstorage, $translate) {
  var _self = this;
  $scope.school = school;
  var errorTitle = $translate.instant('Password Notice');
  var passNeedToUpdate = $localstorage.get('passNeedToUpdate');
  $scope.$on("$ionicView.enter", function() {
    passNeedToUpdate = $localstorage.get('passNeedToUpdate');
    console.log(passNeedToUpdate);
  });
  $scope.currentState = $stateParams.state;
  $scope.$on('$ionicView.beforeLeave', function() {
    if(passNeedToUpdate=='true'){
      loginService.logout(true);
    }    
  });
  _self.savePassword = function (form) {
    $scope.submitted = true;
    if (form.$invalid) {
            return;
    }
    console.log(_self.password.oldp)
    if (_self.password.oldp == _self.password.newp) {
      CommonService.showInfoWithTitle(errorTitle,$translate.instant('New password cannot be the same with Old password, please try another one.'));
      return;
    }

    if (_self.password.newp != _self.password.newp2) {
      CommonService.showInfoWithTitle(errorTitle,$translate.instant('New password did not match.'));
      return;
    }

    $scope.submitted = false;
    ApiService.put('/password', _self.password).then(function (result) {
      if (result.data.success) {
        if(passNeedToUpdate=='true'){
          CommonService.showInfoWithTitle(errorTitle,$translate.instant('Password Reset Successful!'));
          $state.go('app.config.login');
        } else {
          CommonService.showInfo($translate.instant('Update Successful!'),function(){
            if($scope.currentState=="change"){
              loginService.logout(true);
              $state.go('app.config.login');
            }else{
              $state.go('app.config');
            }
          });
        }        
      } else {
        CommonService.showError($translate.instant(result.data.error));
      }
    });
  }

});
