angular.module('bamboo.config').controller('ConfigLoginCtrl', function($scope, $rootScope, AppConfig, ServerLists, $translate, $state, CommonService, ApiService,$timeout, loginService,$ionicHistory, $localstorage, $filter) {
  var _self = this;
  //  CommonService.showInfo("news controller");
  console.log("---- login-----");
  this.choice = 'student';
  _self.defaultClaimer = 'THE SERVICE OFFERINGS ARE PROVIDED “AS IS.” WE AND OUR AFFILIATES AND LICENSORS MAKE NO REPRESENTATIONS OR WARRANTIES OF ANY KIND, WHETHER EXPRESS, IMPLIED, STATUTORY OR OTHERWISE REGARDING THE SERVICE OFFERINGS OR THE THIRD PARTY CONTENT, INCLUDING ANY WARRANTY THAT THE SERVICE OFFERINGS OR THIRD PARTY CONTENT WILL BE UNINTERRUPTED, ERROR FREE OR FREE OF HARMFUL COMPONENTS, OR THAT ANY CONTENT, INCLUDING YOUR CONTENT OR THE THIRD PARTY CONTENT, WILL BE SECURE OR NOT OTHERWISE LOST OR DAMAGED. EXCEPT TO THE EXTENT PROHIBITED BY LAW, WE AND OUR AFFILIATES AND LICENSORS DISCLAIM ALL WARRANTIES, INCLUDING ANY IMPLIED WARRANTIES OF MERCHANTABILITY, SATISFACTORY QUALITY, FITNESS FOR A PARTICULAR PURPOSE, NON-INFRINGEMENT, OR QUIET ENJOYMENT, AND ANY WARRANTIES ARISING OUT OF ANY COURSE OF DEALING OR USAGE OF TRADE.';
  this.subdomain = $localstorage.get('subdomain');
  this.subdomain = "lta"

  CommonService.stopLoading();
  $timeout(function(){
    CommonService.stopLoading();
  },1000);
  this._sitekey = $localstorage.get('site');
  console.log(this._sitekey);
  if (this._sitekey) {
    this.site = ServerLists[this._sitekey];
    if (this.site) {
      this.maindomain = this.site.MAINDOMAIN;
    }
  }
  this.role = AppConfig.Role;

  // ApiService.get('/profile/').then(function(result) {
  //   console.log(result);
  //   if (result.data.success) {
  //     _self.userDetails = JSON.parse(JSON.stringify(result.data.data));
  //     console.log(_self.userDetails);
  //   }
  // });
  this.sitelist = [];
  this.serverlist = ServerLists;
  angular.forEach(ServerLists, function(val, key) {
    //console.log(key);
    val.key = key;
    _self.sitelist.push(val);
  })
  console.log(_self.sitelist);
  $scope.isChecked = false;
  console.log(this.subdomain)
  if (ApiService.school) {
    this.schoolName = ApiService.school.name;
  }

  ApiService.getSchoolInfo().then(function() {
    console.log(ApiService.school);
    _self.schoolName = ApiService.school.name;
    //  console.log("--- s2");
    _self.schoolServiceAgreement = ApiService.school.serviceagreement || ApiService.school.serviceagreementCN || _self.defaultClaimer;
    if (ApiService.school.mobilephoto) {
      $scope.mobilephoto = ApiService.SHOST + "/site/" + ApiService.school.mobilephoto;
    } else {
      $scope.mobilephoto = 'img/splash_img.png';
    }
    //  console.log(_self.schoolServiceAgreement);
  }, function() {
    $state.go('app.config.login');
  });

  this.gotoRegister=function(){
    $ionicHistory.clearCache().then(function() {
        $state.go('app.config.register');
    });
  }
  this.username = $localstorage.get('username');
  this.password = $localstorage.get('password');
  this.lan = $localstorage.get('language');
  this.updatelogininfo = function() {
    var errtitle = $filter('translate')('Error')
    // if (!ApiService.school.mobileApp) {
    //   console.log('Do not allow login');
    //   CommonService.showError("Mobile login is not allowed ,please contact administrator!");
    // } else
    ApiService.getSchoolInfo(_self.subdomain.toLowerCase()).then(function(school) {
      CommonService.stopLoading();
      if (_self.username && _self.password) {
        _self.username = _self.username.toLowerCase();
        var info = {
          name: _self.username,
          pass: _self.password
        };
        CommonService.showLoading();
        loginService.login(info).then(function(user) {
          CommonService.stopLoading();
          console.log(user);
          //$scope.user=user;
          // if (!user) {
          //   var error = user.error || "Login Failed";
          //   var errmsg = $filter('translate')(error);
          //   CommonService.showErrorWithTitle(errtitle, errmsg);
          //   // CommonService.showError($translate.instant(AppConfig.LOGINERROR));
          // } else {
          if (user) {
            console.log(AppConfig.Role);
            $localstorage.set('passNeedToUpdate', false);
            if (user.passNeedToUpdate) {
              $localstorage.set('passNeedToUpdate', true);
              $state.go('app.config.changepassword');
              return;
            }
            var errmsg = $filter('translate')('Login Success')
            //CommonService.showInfoWithTitle(errtitle, errmsg);
            $localstorage.set('username', _self.username.toLowerCase());
            $localstorage.set('password', _self.password);
            $ionicHistory.clearCache().then(function() {
              ApiService.get('/profile/').then(function(result) {
                console.log(result);
                if (result.data.success) {
                  $scope.user = result.data.data;
                  /*if($scope.user.BeiAnZhuangTai==1||$scope.user.BeiAnZhuangTai==4){
                    $state.go('app.home', {}, {
                      reload: true,
                      inherit: false
                    });
                    return;
                  }*/

                  var result = checkInfoComplete();
                  if (result) {
                    return CommonService.showInfo(result,function(){
                      $state.go('app.config.update');
                    });
                  } else {
                    if ($state.current.name === "app.config.logininfo") {
                      $state.go('^');
                    } else {
                      $state.go('app.home', {}, {
                        reload: true,
                        inherit: false
                      });
                    }
                  }
                }
              })
            })
            console.dir(user);
            console.dir(_self.choice); /**/
            $rootScope.userType = _self.choice;
            console.dir($rootScope.userType);
            //  CommonService.showInfo("login success");
          }
        }, function(reason) {
          CommonService.stopLoading();
          console.log(reason);
        });
      } else {
        //var errmsg = $filter('translate')('Please provide username and password');
        var errmsg = "请输入证件号码和密码！";
        CommonService.showErrorWithTitle(errtitle, errmsg);
      }
    }, function(err) {
      // CommonService.stopLoading();
      console.log(err);
      CommonService.showError("网络连接失败，请确认网络服务！");
    });
  }


  function checkLicenseError() {
    if (!$scope.user.licensProvience) {
      return '请选择从业资格核发地！';
    }
    if (!$scope.user.licensNo) {
      return '请填写从业资格证号！';
    }
    if (!$scope.user.licensType) {
      return '请填写从业人员类别！';
    }
    if (!$scope.user.CertificateType) {
      return '请填写从业资格类别！';
    }
    if (!$scope.user.licensExpire) {
      return '请选择从业资格有效期！';
    }
    return false;
  }

  function checkInfoComplete() {
    //if (!$scope.user.avatar) {
    //  return '请更新个人照片！';
    //}
    if (!$scope.user.avatar) {
      //CommonService.showInfo("", function (res) {
      //  $state.go('app.config.update');
      //});
      return '您未完成头像上传功能，请前往完成！';
    }
    if (!$scope.user.gender) {
      return '请选择性别！';
    }
    if (!$scope.user.race) {
      return '请选择民族！';
    }
    if (!$scope.user.birthday) {
      return '请选择出生日期！';
    }
    /*if (!$scope.user.cardtype) {
      return '请选择证件类型！';
    }*/
    if (!(/^1[3456789]\d{9}$/.test($scope.user.mobile))) {
      return '基本信息联系电话有误，请重新填写！';
    }
    if (!$scope.user.province) {
      return '请选择辖区省！';
    }
    if (!$scope.user.city) {
      return '请选择辖区市！';
    }
    //if (!$scope.user.district) {
    //  return '请选择辖区县！';
    //}
    if (!$scope.user.address) {
      return '请填写联系地址！';
    }
    if ($scope.user.busitype != '个体经营' && !$scope.user.comId) {
      return '请选择企业名称！';
    }
    if (!$scope.user.userType) {
      return '请选择岗位类型！';
    }
    //if ($scope.user.userType && $scope.user.userType < 4) {
    //  var errorInfo = checkLicenseError();
    //  if (errorInfo) {
    //    // CommonService.showInfo(errorInfo);
    //    return errorInfo;
    //  }
    //}
    //if ($scope.user.licensProvience || $scope.user.licensNo) {
    //  var errorInfo = checkLicenseError();
    //  if (errorInfo) {
    //    //CommonService.showInfo(errorInfo);
    //    return errorInfo;
    //  }
    //}
    //if ($scope.user.safeCert) {
    //  if (!$scope.user.safeCertSource || !$scope.user.safeCertNo || !$scope.user.safeCertExpired) {
    //    return '请完整填写安全工程师信息！';
    //  }
    //}
    if (!$scope.user.enrol) {
      return '请填写服务开始时间！';
    }
    //if (!$scope.user.drivingLicenseSource) {
    //  return '请填写驾驶证发证机关！';
    //}
    //if (!$scope.user.drivingLicenseNo) {
    //  return '请填写驾驶证号！';
    //}
    //if (!$scope.user.drivingType) {
    //  return '请填写驾驶证准驾车型！';
    //}else if($scope.user.drivingType.indexOf(',')>0||$scope.user.drivingType.indexOf('、')>0){
    //  return '驾驶证准驾车型只能选一个！';
    //}
    //if (!$scope.user.drivingLicenseExpire) {
    //  return '请选择驾驶证有效期！';
    //}
    return false;
  }
  this.requestPasswordReset = function(email) {
    this.HOST = ApiService.HOST;
    var info = {
      email: email,
      url: this.HOST + "#/reset-pwd"
    };
    ApiService.post('/search_pass', info).then(function(result) {
      //console.log(result);
      if (result.data.success) {
        CommonService.showInfo(result.data.info, function(res) {
          $state.go('app.config.login');
        });
      } else {
        CommonService.showError(result.data.error || result.data.info);
      }
    });
  };
});
