angular.module('bamboo.course').controller('BishunChapterCtrl', function($scope, $sce, $timeout, $stateParams, ApiService, CourseApi) {
  this.cid = $stateParams.cid;
  this.id = $stateParams.rid;
  this.mvId=$stateParams.mvid;
  console.log("--- BishunChapterCtrl");
  CourseApi.rotateScreen();
  var self = this;
  var resUrl = ApiService.SHOST + '/lcourse/' + this.cid + '/resources/';
  this.index=0;
  this.currentPPT;
  this.init = function(chapter) {
    self.chapter = chapter;
    console.log(self.chapter);
    self.show(0);
  }


  var _lasttime = new Date();
  $scope.$on("$ionicView.enter", function(scopes, states) {
    _lasttime = new Date();
  });
  $scope.$on('$ionicView.beforeLeave', function() {
    CourseApi.recordUsage(self.cid,self.id,$stateParams.mvid,_lasttime);
  });
  function getInfo() {
    var info = {
      action: 'getresource',
      id: self.id,
    };
    CourseApi.mvApi(info, function(result) {
      //CommonService.stopLoading();
      console.log(result);
      self.chapter = result;
      resUrl = ApiService.SHOST + '/lcourse/' + self.chapter.cid + '/resources/';
      self.init(result);
    });
  }
  getInfo();

  
  this.code;
  this.playWord=function(word){
    var file = self.chapter.libs[word];
        if (!file) {
      return;
    }

    var filename = resUrl + file;
    try {
      var myAudio = new Audio(filename);
      myAudio.play();
    } catch (e) {}
  }

  this.nextPage=function(){
    self.index++;
    if(self.index>=self.chapter.ppts.length){
      self.index=0;
    }
    self.show(self.index);
  }
  this.lastPage=function(){
    self.index--;
    if(self.index<0){
      self.index=self.chapter.ppts.length-1;
    }
    self.show(self.index);
  }
  this.show=function(index){
    self.index=index;
    self.currentPPT=self.chapter.ppts[index];
    self.currentPPT.code=self.currentPPT.word.charCodeAt(0).toString(16);
    self.playWord(self.currentPPT.word);
  }


});