angular.module('bamboo.course').controller('Html5Ctrl', function($stateParams, $scope, $sce, $state, ApiService, CommonService, CourseApi) {
  var self = this;
  this.cid = $stateParams.cid;
  this.id = $stateParams.rid;
  this.chapter = {};
  this.mediapath = ApiService.SHOST + '/lcourse/' + self.cid + '/resources/';
  var defaultHtml = "story_html5.html";
  if ($state.current.name.indexOf('ebook') > 0) {
    defaultHtml = 'index.html';
  }
  CourseApi.rotateScreen();
  window.addEventListener('orientationchange', doOnOrientationChange);

  function doOnOrientationChange() {
    console.log("--- rotation detected --");
    switch (window.orientation) {
      case -90:
      case 90:
        console.log('landscape');
        self.barFlag = true;
        $ionicNavBarDelegate.showBar(true);
        break;
      default:
        console.log('portrait');
        self.barFlag = true;
        $ionicNavBarDelegate.showBar(true);
        break;
    }
  }
  var _lasttime = new Date();
  $scope.$on("$ionicView.enter", function(scopes, states) {
    _lasttime = new Date();
  });
  $scope.$on('$ionicView.beforeLeave', function() {
    CourseApi.recordUsage(self.cid,self.id,$stateParams.mvid,_lasttime);
  });
  /*
    function getFolder(id,mediaPath,content,default) {
      if (window.cordova) {
        _platform = $cordovaDevice.platform;
        if (_platform && _platform.indexOf('iOS') > -1) {
          _systemroot = cordova.file.dataDirectory;
        } else if (_platform && _platform.indexOf('Android') > -1) {
          _systemroot = cordova.file.externalRootDirectory;
          // window.screen.orientation.lock('portrait');
        }
        var localExist = $localstorage.getResource(self.id);
        console.log(localExist);
        if (localExist) {
          var localfolder = _systemroot + 'bamboo/' + self.id;
          console.log(localfolder);
          var folders = [localfolder];
          searchFolders(folders, defaultHtml, function(err, file) {
            console.log(err);
            console.log(file);
            self.mediaurl=file;
          });
        }
      }else{
        var fullurl = self.mediapath + self.chapter.content + "/" + defaultHtml;
        console.log(fullurl);
        self.mediaurl = $sce.trustAsResourceUrl(encodeURI(fullurl));
        // self.mediaurl = encodeURI(fullurl);
      }
    }

  */
  function getInfo() {
    // CommonService.showLoading();
    var info = {
      action: 'getresource',
      id: self.id,
    };
    CourseApi.mvApi(info, function(result) {
      //CommonService.stopLoading();
      console.log(result);
      self.chapter = result;
      if (self.chapter.cid != self.cid) {
        self.mediapath = ApiService.SHOST + '/lcourse/' + self.chapter.cid + '/resources/';
      }
      if (self.chapter.indexHtml) {
        defaultHtml = self.chapter.indexHtml;
      }
      CourseApi.getMediaPath(self.id, self.mediapath, self.chapter.content, defaultHtml, function(file) {
        if (file.indexOf('file') == 0) {
          self.mediaurl = file;
        } else {
          self.mediaurl = $sce.trustAsResourceUrl(encodeURI(file));
        }
      })
    });
  }
  getInfo();
});