angular.module('bamboo.course').controller('TakePhotoCtrl', function ($scope, $stateParams,$rootScope, loginService, $ionicModal, ApiService, $timeout, $state, CommonService, CourseApi, $ionicPopover, $cordovaDevice, utilService, $ionicPopup, $ionicLoading) {
    var _self = this;
    console.log("TakePhotoCtrl");
    $scope.$on('$ionicView.beforeEnter', function () {
        _self.imageFile = "";
    })
    console.log(loginService.user)
    var userId = loginService.user._id;
    $scope.$on("$ionicView.enter", function (scopes, states) {
        CommonService.stopListen();
        if (window.cordova) {
            var _platform = $cordovaDevice.platform;
            // if (_platform && _platform.indexOf('iOS') > -1) {} else if (_platform && _platform.indexOf('Android') > -1) {
            //   window.screen.orientation.lock('portrait');
            // }
            window.screen.orientation.lock('portrait');

        }
        console.log($rootScope.$previousState);
        if($rootScope.$previousState&&$rootScope.$previousState.name.indexOf('app.course.home.chapterslist')>-1){
           $state.go("^");
        }
        var state = CommonService.stateInfo;
        if (state.state == 'start') {
            _self.title = "拍照签到"
        } else {
            _self.title = "拍照签退"
        }
        // CommonService.getCurrentLocation(true, function (err, position) {
        //     _self.cord = position;
        //     console.log(position);
        // });
    });
    this.imgPath = ApiService.SHOST + "/learningrecordphoto/" + userId + "/";
    this.addAttachment = function (fileflag) {
        var url = "learningrecordphoto/" + userId + "/";
        console.log(url);
        if (window.cordova) {
            CommonService.attachmentUpload(url, fileflag, function (res) {
                // by supercat 2020-04-14
                $ionicLoading.show({
                    template: "请稍等..."
                });
                console.log(res);
                var img1 = ApiService.SHOST + "/learningrecordphoto/" + loginService.user._id + "/" + res.result;
                var img2 = ApiService.PSURL + "/avatar/" + loginService.user._id  +'/'+ loginService.user.avatar;

                CommonService.verifyFacialProfile(img1, img2)
                .then(function(data) {
                  ApiService.getSchoolInfo()
                  .then(function(result) {
                    console.log("sessionAccessRules",result.sessionAccessRules,data)
                    var sr = result.sessionAccessRules;
                    var faceRate = sr.faceRate ? parseInt(sr.faceRate*100) : 60;

                    if(data.result === 0 && ((data.score * 100) > faceRate)) {
                        _self.imageFile = res.result;
                        $ionicPopup.alert({
                            title: '验证通过',
                            template: '<div style="text-align: left;">温馨提示：学习期间如接听电话或切换至其他APP，系统将暂停计算学时；如10分钟内未返回学习，系统将自动记录当前进度并退出学习。</div>',
                            okText: '知道了',
                        }).then(function(res) {
                            if (res) {
                                var state = CommonService.stateInfo;
                                if (state.state == 'start') {
                                    _self.lookVideo();
                                } else {
                                    exitStudy();
                                }
                            }
                        });
                    } else {
                      _self.imageFile = "";
                      CommonService.showError("您的照片识别未通过，请重新拍摄", function() {
                        $scope.Retake();
                      });
                    }
                  })
                }).catch(function(err) {
                  console.log(err)
                }).finally(() => { // by supercat 2020-04-14
                    $ionicLoading.hide();
                });
            });
        } else {
            _self.imageFile = "wx81135caec2134fd1_o6zAJs0u_af4YXzj3CpOWwfvm5f8_kUv83ua4qCT9e0bb43bc57e0b09433d783e9e5bee76a.jpg" //res.result;
            $ionicPopup.alert({
                title: '验证通过',
                template: '<div style="text-align: left;">温馨提示：学习期间如接听电话或切换至其他APP，系统将暂停计算学时；如10分钟内未返回学习，系统将自动记录当前进度并退出学习。</div>',
                okText: '知道了',
            }).then(function (res) {
                if (res) {
                    var state = CommonService.stateInfo;
                    if (state.state == 'start') {
                        _self.lookVideo();
                    } else {
                        exitStudy();
                    }
                }
            });
        }
    }

    $scope.Retake = function() {
        $scope.modal.hide();
        _self.addAttachment();
    };

    this.cancel = function () {
        _self.imageFile = "";
    }

    function exitStudy() {
        var state = CommonService.stateInfo;
        if (!state) {
            ;
            CommonService.showError('Invalid State');
        }
        var info = {
            lid: state.lid,
            mid: state.mvid,
            rid: state.rid,
            photo: _self.imageFile,
            action: 'addCourseLearningRecord',
            type: "exit",
            deviceId: $cordovaDevice.uuid,
        }
        if (state.complete) {
            info.complete = true;
        }
        console.log(_self.cord);
        if (_self.cord) {
            info.lat = _self.cord.coords.latitude;
            info.lng = _self.cord.coords.longitude;
        }
        if (state.start) {
            var len = parseInt(((new Date()) - state.start) / 1000);
            info.len = len;
            if (CommonService.getSysSleepLen()) {
                info.len = info.len - CommonService.getSysSleepLen();
                console.log("len reduced ", CommonService.getSysSleepLen());
            }
            info.start = state.start;
        }
        console.log(info);
        CourseApi.mvApi(info, function (result) {
            console.log(result);
            $state.go("^");
        });
    }

    // CommonService.getCurrentLocation(true, function(err, cord) {
    //   console.log("--- lcoation got", cord);
    //   _self.cord = cord;
    // })
    this.lookVideo = function () {
        var item = CommonService.lookVideo;
        var state = CommonService.stateInfo;
        if (!state) {
            ;
            CommonService.showError('Invalid State');
        }
        CommonService.stateInfo.state = 'learning';
        var info = {
            lid: state.lid,
            mid: state.mvid,
            rid: state.rid,
            photo: _self.imageFile,
            action: 'addCourseLearningRecord',
            type: "join",
            deviceId: $cordovaDevice.uuid,
        }
        console.log(_self.cord);
        if (_self.cord) {
            info.lat = _self.cord.coords.latitude;
            info.lng = _self.cord.coords.longitude;
        }
        console.log(info);
        CourseApi.mvApi(info, function (result) {
            CommonService.stateInfo.start = new Date();
            console.log(result);
        });
        //  return ;
        // var currentMvid = CommonService.currentMvid;
        var _platform = $cordovaDevice.platform;
        if (!window.cordova || (_platform && _platform.indexOf('iOS') > -1)) {
            $state.go("" + "app.course.home.chapterslist." + item.type, {
                rid: item.rid,
                mvid: state.mvid,
            });
            return;
        }
        var options = {
            location: 'no',
            clearcache: 'no',
            toolbar: 'yes'
        };
        var opStr = "";
        angular.forEach(options, function (val, key) {
            if (opStr.length) {
                opStr += '&';
            }
            opStr += key + "=" + val;
        })
        var target = "_system";
        // if (item.download) {
        // if (item.type == "mp4" || item.type == "mp4ppt" || item.type == "mp4quiz" || item.type == "pdf") {
        //  _self.directplay(item);
        $state.go("app.course.home.chapterslist." + item.type, {
            rid: item.rid,
            mvid: state.mvid,
        });
        return;

        // }
        if (_platform && _platform.indexOf('iOS') > -1) {
            _systemroot = cordova.file.dataDirectory;
        } else if (_platform && _platform.indexOf('Android') > -1) {
            _systemroot = cordova.file.externalRootDirectory;
            // window.screen.orientation.lock('portrait');
        }
        var targetPath = _systemroot + 'bamboo/' + encodeURI(item.file);
        console.log(targetPath);
        console.log(cordova.InAppBrowser);
        var ref = cordova.InAppBrowser.open(targetPath, target, opStr, function (event) {
            console.log("--- open success --");
        }, function (error) {
            console.log("--- open err --");
            console.dir(error);
        });
        ref.close();
    }
});
