(function() {
  'use strict';

  angular
    .module('bamboo')
    .directive('mytooltip', directive);

  directive.$inject = ['$window'];

  function directive($window) {
    // Usage:
    //     <directive></directive>
    // Creates:
    //
    var directive = {
      link: link,
      restrict: 'AEC',
      scope: {
        title: '@',
      },
    };
    return directive;

    function link(scope, element, attrs) {
      console.log(scope);
      console.log(scope.title);
      //   if (scope.title) {
      console.log(scope.title);
      var $element = $(element);
      $element.attr("title", scope.title);
      //   attrs.title = scope.title;
      $element.tooltipster({
        animation: 'fade',
        trigger: "click",
        position: "left",
        positionTracker: true,
        maxWidth: 500,
        contentAsHTML: true
      });

    }
    // }
  }

})();