angular.module('bamboo.course').controller('ExamCategoryCtrl', function($scope , ApiService,  $state) {
  var self = this;
  this.knowledges;
  this.examList = null;
  console.log("---ExamCategoryCtrl");
  ApiService.getSchoolInfo().then(function() {
    if (ApiService.knowledges) {
      self.knowledges = ApiService.knowledges;
      var catList = [];
      getArray(self.knowledges, catList, 0, '');
      $scope.catitems = catList;
      generateCategoryList();
      
    }
  });

  this.OpenUp = function(item) {
    item.shown = !item.shown;
    console.log(item);
  }
  function getArray(obj, array, level, parent) {
    if ((typeof obj) === "object") {
      for (var key in obj) {
        var fullkey;
        if (parent == '') {
          fullkey = key;
        } else {
          fullkey = parent + "," + key;
        }
        var _i = {
          key: fullkey,
          value: level,
          title: key,
          items: [],
        };
        array.push(_i);
        var info = obj[key];
        if (typeof info === "object") {
          getArray(info, _i.items, level + 1, fullkey);
        }
      }
    }
  }

  function generateCategoryList() {
    var catList = [];
    getArray(self.knowledges, catList, 0, '');
    console.log(catList);
    $scope.catitems = catList;
    var info={
      action:"getexamcounterbycategory",
    }
    ApiService.post('/exam', info).then(function(result) {
     // console.log(result);
      if (result.data.success) {
      //  console.log(result.data.data);
        var _temp=result.data.data;
        angular.forEach(catList,function(item,index){
         // console.log(item);
          var key=item.key;
         // console.log(key);
          if(_temp[key]){
            item.counter=_temp[key];
          }
        });
      //  console.log(catList);
      }
    });

  }
  this.list=function(key){
    console.log(key);
    $state.go("app.exam",{cat:key});
  }
});