angular.module('bamboo.exam').controller('ExamListController', function($scope,CommonService,$timeout,$stateParams, ApiService) {
  var _self = this;
  this.defaultpic = 'img/exams1.png';
  this.page = 0;
  this.cat = $stateParams.cat;
  console.log(this.cat);
  this.moreData = false;
  $scope.examitems = [];
  $scope.imageUrl = ApiService.SHOST + '/examphoto/' + ApiService.gid + '/';

  function examApi(info, callback) {
    CommonService.showLoading();
    ApiService.post('/exam', info).then(function(result) {
      //console.log(result);
      CommonService.stopLoading();
      if (result.data.success) {
        if (!callback) {
          CommonService.showInfo('Update Successful!');
        } else {
          callback(result.data.data);
        }
      }else{

      }
    });
  }

  function getExams(page) {
    var info = {
      action: "getpublicexamitems",
      start: page * 6,
      limit: 6,
    };
    if (_self.cat) {
      if (!info.search) {
        info.search = {};
      }
      info.search.knowledge = _self.cat;
    }
    console.log(info);
    examApi(info, function(data) {
      console.log(data);
      _self.totalCount = data.counter;
      $scope.examitems = $scope.examitems.concat(data.items);
      _self.moreData = ((_self.totalCount - $scope.examitems.length) > 0);
      console.log(_self.moreData);

        $scope.$broadcast('scroll.infiniteScrollComplete');
       // CommonService.stopLoading();

    })
  }
  getExams(0);
  this.nextPage=function(){
    console.log("-- next page");
    _self.page++;
    getExams(_self.page)
  }
});
