angular.module('bamboo.formal').controller('FormalRecordDetail', function($stateParams, $scope, ApiService,  $rootScope,$translate, examService, loginService) {
  var self = this;
  this.rid = $stateParams.rid;
  console.log(loginService.user);
  this.typename = {
    'single': '单项选择题',
    'fill': '填空题',
    'mfill': '填空题',
    'tof': '判断题',
    'short': '主观题',
    'multiple': '多项选择题',
    'multiselect': '主观选择题',
  }

  function getAccessRecords() {
    var info = {
      action: "getSimpleFormalRecordById",
      id: self.rid
    };
    console.log(info);
    examService.api(info, function(result) {
      console.log(result);
      self.record = result.record;
      self.exam = result.exam;
      self.paper = result.paper;

      self.record.endTime = moment(self.record.update).add(self.record.time, 'seconds').format();
      self.record.startTime = self.record.update
      self.record.duration = secondsToTime(self.record.time);


      var imgPath = ApiService.SHOST + "/formalphoto/" + loginService.user._id+"/";
      self.recordPhoto=imgPath+self.record.photo;
    });
  }
  getAccessRecords();

  
    function secondsToTime(secs) {
      var sec_num = parseInt(secs, 10); // don't forget the second param
      var hours = Math.floor(sec_num / (60 * 60));
      var minutes = Math.floor((sec_num - (hours * 3600)) / 60);
      var seconds = sec_num - (hours * 3600) - (minutes * 60);
      if (hours < 10) {
        hours = "0" + hours;
      }
      if (minutes < 10) {
        minutes = "0" + minutes;
      }
      if (seconds < 10) {
        seconds = "0" + seconds;
      }
      var time = hours + ':' + minutes + ':' + seconds;
      return time;
    };

});


