angular.module('bamboo.formal').controller('MyPractisesCtrl', function($scope, ApiService,CommonService,$state, $localstorage) {
  var self = this;
  var examinfo = {
    action: 'getMyFormalPractises',
  }
  console.log(examinfo);
  ApiService.post('/exam', examinfo).then(function(result) {
    console.log("-------!!--------");
    console.log(result.data.data);
    var examCounters = $localstorage.getCurrentDayExamCounters();
    console.log(examCounters);
    $scope.examitems = result.data.data || [];
    angular.forEach($scope.examitems, function(item) {
      var allow = true;
      if (examCounters[item._id] && examCounters[item._id] > 2) {
        allow = false;
      }
      item.allow = allow;
    })
  });
  this.goTest = function(item) {
    if (item.allow) {
      $state.go('app.formal.test', {
        type: "fast",
        id: item._id
      });
    } else {
      CommonService.showError("每天练习次数已经到了3次，请明天再试！");
    }
  }
});