angular.module('bamboo.formal', ['ionic', "ionic.native", "ionic.utils"]).config(function($stateProvider, $urlRouterProvider) {
  //    .state('app.formal', {
  //  url: '/formal',
  //  views: {
  //    'Content@app': {
  //      templateUrl: 'app/formal/mobilelist.html',
  //      controller:"FormalListController as ctrl",
  //    }
  //  }
  //})
  $stateProvider.state('app.formal', {
    url: '/formal',
    views: {
      'Content@app': {
        templateUrl: 'app/formal/myexam.html',
        controller: "MyExamsCtrl as ctrl",
      }
    }
  }).state('app.formal.practise', {
    url: "/practise/list",
    views: {
      'Content@app': {
        templateUrl: 'app/formal/mypractise.html',
        controller: "MyPractisesCtrl as ctrl",
      }
    }
  }).state('app.formal.simulations', {
    url: "/simulations/list",
    views: {
      'Content@app': {
        templateUrl: 'app/formal/simulations.html',
        controller: "SimulationsCtrl as ctrl",
      }
    }
  }).state('app.formal.startpage', {
    url: "/start/:type/:id",
    views: {
      'Content@app': {
        templateUrl: 'app/formal/start.html',
        controller: "FormalStartController as ctrl",
      }
    }
    //.state('app.formal.landing', {
    //  url:"/landing/:type/:id",
    //  views: {
    //    'Content@app': {
    //      templateUrl: 'app/exam/viewresultlanding.html',
    //      controller:"ExamListController as ctrl",
    //    }
    //  }
    //})
    //.state('app.formal.result', {
    //  url:"/result/:type/:id",
    //  views: {
    //    'Content@app': {
    //      templateUrl: 'app/exam/examresult.html',
    //      controller:"ExamListController as ctrl",
    //    }
    //  }
    //})
  }).state('app.formal.test', {
    url: "/test/:type/:id",
    views: {
      'Content@app': {
        templateUrl: 'app/formal/examtest.html',
        controller: "FormalTestController as ctrl",
      }
    }
  }).state('app.formalrecords', {
    url: "/records",
    views: {
      'Content@app': {
        templateUrl: 'app/formal/examrecords.html',
        controller: "MyFormalRecordsCtrl as ctrl",
      }
    }
  }).state('app.formalrecords.detail', {
    url: "/detail/:rid",
    views: {
      'Content@app': {
        templateUrl: 'app/formal/examrecorddetail.html',
        controller: "FormalRecordDetail as ctrl",
      }
    }
    // }).state('app.fastpass', {
    //   url: "/fastpass",
    //   views: {
    //     'Content@app': {
    //       templateUrl: 'app/formal/fastpass.html',
    //       controller: "FastPassCtrl as ctrl",
    //     }
    //   }
  });
});