'use strict';
angular.module('bamboo.formal').controller('FormalStartController', function($state, $localstorage,$ionicHistory,$rootScope, $sce, CommonService, ExamService, $scope, ApiService, $stateParams, loginService, $interval, $timeout, $filter, $window, $document, $translate) {
  var _self = this;
  this.hideQuestion = false;
  this.id;

  this.userID = loginService.user && loginService.user.name;
  // console.log(loginService);
  var _type = this._type = $stateParams.type;
  var userId=loginService.user._id;
  // console.info($document[0].referrer);
  // console.info(_type);
  var _task = $stateParams.task;
  this.commentIndex = 0;
  var _eid = $stateParams.id; //for exam
  //console.log($stateParams);
  // console.log(_type, _task, _eid);
  this.courseID;
  this.fullsize = false;
  _self.CurrQIdx = 0;
  //$scope.singleDragTarget = {};
  $scope.singleDropTarget = {};
  //$scope.$storage = $localStorage;
  //console.info($localStorage);
  this.submitted = false;
  this.review = true;
  this.currentQ = 0;
  this.question = null;
  this.score_percentage = 0;
  this.exam = null;
  this.examHistoryCounter = 0;
  this.use_time = 0;
  this.time_limit = 0;
  this.sTimer = null;
  this.stopTest = true;
  this.knowledgeresult = {};
  this.wait = false;
  this.totalscores = 0;
  this.eid = $stateParams.id;
  this.examIconUrl = ApiService.SHOST + '/examphoto/';
  this.audioPath = ApiService.SHOST + "/exam/audio/";
  this.videoPath = ApiService.SHOST + "/exam/video/";
  this.typename = ExamService.typename;
  this.REASON = "Sorry,you can not take the test again because you can only take a limited number of times!";
  $scope.title = "Exam";
  console.log($state.current.name);
  $scope.HostURL = "http://localhost:3100/#";
  if ($state.current.name == "index.tests.test") {
    $scope.title = "Test";
  }
  this.toggleSize = function() {
    _self.fullsize = !_self.fullsize;
  }
  this.toggleSize2 = function() {
    _self.fullsize2 = !_self.fullsize2;
  }
  this.toggleSize3 = function() {
    _self.fullsize3 = !_self.fullsize3;
  }

  function loadExamHistory() {
    var info = {
      id: _eid,
      action: "getuserexamcountbyreason",
    };
    examApi(info, function(data) {
      console.log(data);
      console.log("-- history --" + data + ":" + _self.accessOnce);
      console.log($scope.retries);
      _self.examHistoryCounter = data.total;
      _self.examPassCounter = data.pass || 0;
      if (_self.accessOnce == "1" && _self.examHistoryCounter > 0 && _type != "test") {
        console.log("Have record, can not start test!");
        _self.stopInfo = $filter('trans')({
          eng: "You have done the Test!",
          chn: '已完成考试'
        });
        $timeout(function() {
          _self.stopTest = false;
        }, 200);
      }
      if ($scope.retries && _self.examHistoryCounter >= $scope.retries && $scope.retries != 0) {
        $state.go('app.formal.startpage', {
          id: $stateParams.id,
          type: _type
        });
      }
      //isAllowedRetest();
    });
  };

  function filterDotOfKnowledges(knowledgeresult) {
    console.log(knowledgeresult);
    for (var property in knowledgeresult) {
      if (property.indexOf('.') >= 0) {
        var oldname = property;
        var newname = property.replace('.', '');
        rename(knowledgeresult, oldname, newname);
      }
    }
    console.log(knowledgeresult);
  }

  function examApi(info, callback) {
    ApiService.post('/exam', info).then(function (result) {
      if (result.data.success) {
        if (!callback) {
          CommonService.showInfo('Update Successful!');
        } else {
          callback(result.data.data);
        }
      }
    });
  };

  function rename(obj, oldName, newName) {
    if (!obj.hasOwnProperty(oldName)) {
      return false;
    }
    obj[newName] = obj[oldName];
    delete obj[oldName];
    return true;
  }
  this.viewResult = function() {
    _self.showResult = true;
  }

  function loadPaper() {
    var info = {
      id: _self.id,
      action: "getpaper",
    };
    if (_self.type == 'Knowledge') {
      info.action = "getKPaper";
    }
    console.log(info);
    examApi(info, function(data) {
      if (!data) {
        return;
      }
      console.log(data);
      _self.paper = data;
      _self.paperID = data._id;
    });
  }

  function init() {
    console.log(_type + ":" + _eid);
    console.log("-----------------init-----------------");

    function prepareTest(data) {
      console.log(data);
      _self.exam = data;
      _self.id = data.eid;
      _self.type = data.type;
      loadPaper();
      loadExamHistory();
    }
    switch (_type) {
      case 'exam':
        var info = {
          action: "getFormalWithStatus",
          id: _eid,
        };
        console.log(info);
        examApi(info, function(data) {
          console.log(data)
          if (data) {
            console.info("---data------");
            console.info(data);
            $scope.retries = data.retries;
            if(data.status){
              if(data.status.pass){
                var paperInfo={
                  status:data.status,
                  pass:data.status.pass
                }
                $localstorage.set('paperExamPass',paperInfo);
              }
            }

            prepareTest(data);
          } else {
            console.log("error: data is null");
          }
        });
        break;
      case 'test':
        var info = {
          action: "gettestitem",
          id: _eid,
        };
        console.log(info);
        examApi(info, function(data) {
          prepareTest(data);
        });
        break;
    }
  }
  ////if (loginService.isLogged) {
    init();
  ////} else {
  //  console.log(_eid);
  //  //_self.showLogin = true;
  //  // ApiService.get('/exam/' + _eid).then(function(result) {
  //  //   console.log(result);
  //  //   if (result.data.success) {
  //  //     var exam = result.data.data.exam;
  //  //     _self.title = exam.name;
  //  //     _self.description = exam.description;
  //  //     _self.imgUrl = exam.photo;
  //  //     _self.showLogin = true;
  //  //   } else {
  //  //     CommonService.showError(result.data.error || result.data.info);
  //  //   }
  //  // });
  //}
  this.login = function() {
    var options = {
      templateUrl: 'app/home/login.dlg.html',
      controller: 'LoginDlgCtrl',
      controllerAs: 'ctrl',
      size: "md-lg vertical-align-center",
      backdrop: 'static'
    }
    if (loginService.school.theme) {
      switch (loginService.school.theme) {
        case 'v1':
          options.templateUrl = "app/home/login.dlg1.html";
          break;
      }
    }
    //$uibModal.open(options).result.then(function(login) {
    //  console.log(login);
    //  if (!login) {} else if (login.forgotPassword) {
    //    $state.go('index.request-reset-pwd');
    //  } else {
    //    $scope.login = login;
    //    $scope.loginMe();
    //  }
    //});
  }
  $scope.loginMe = function() {
    $scope.login.domain = loginService.subDomain;
    $scope.login.ownername = loginService.school.name;
    $scope.login.url = ApiService.HOST + "#/active_account";
    loginService.login($scope.login).then(function(user) {
      console.info(user);
      if (!user) {
        $scope.LOGINERROR = true;
        return;
      }
      $state.reload();
    }, function(reason) {
      console.log(reason.data.error);
      //CommonService.showError(reason.data.error);
    });
  };
  $scope.numToLetters = function(num) {
    return String.fromCharCode(65 + num);
  };

  function getCheckSum(_cs) {
    if (!_cs) {
      return 'a1b1c2';
    }
    var len = _cs.length;
    var start = 0;
    if (len > 8) {
      start = len - 8;
    }
    var chk = 0;
    for (var i = start; i < len; i++) {
      chk += (_cs.charCodeAt(i) * (i + 1));
    }
    return (chk & 0xffffffff).toString(16);
    // return md5.createHash(_cs);
  }
  var options = {
    title: $translate.instant("Warning"),
    message: $translate.instant("The exam page lost focus ! Click Cancel to go back exam otherwise the system is going to submit the exam after 3s automatically ."),
    button: $translate.instant("Ok"),
    button_dismiss: $translate.instant("Cancel")
    //icon:options.icon;
  };
  /* var options = {
     title: "Warning",
     message: "The exam page lost focus ! Click Cancel to go back exam otherwise the system is going to submit the exam after 3s automatically .",
     button: "Ok",
     button_dismiss: "Cancel"
     //icon:options.icon;
   };*/
  var ExitWarningOptions = {
    content: $translate.instant("Do you really want to exit the exam ? The data maybe lost ."),
    title: 'Confirm',
    icon: "text-warning fa fa-question-circle fa-3x",
    btn_confirm: $translate.instant("Ok")
  };

  function initRetakeFlag() {
    $scope.retakeFlag = true;
    switch (loginService.subDomain) {
      case "caregiverasia":
        $scope.retakeFlag = false;
        break;
      default:
        $scope.retakeFlag = true;
        break;
    }
  }
  // initRetakeFlag();
  var photoSetting = {
    image: true,
    promise: true,
    title: "用户验证照片",
    maxheight: 200,
    maxwidth: 200,
    resPath: "formalphoto/" + loginService.user._id + "/",
    usewebcam: true,
    noFile: true,
  }
  this.start = function(fileflag) {
    console.log(_self.examHistoryCounter);
    console.log($scope.retries);
    console.log(_self.passOnce);
    console.log(_self.examPassCounter);
    if (_self.passOnce && _self.examPassCounter > 0) {
      CommonService.showInfo("You have passed this exam already and are not allowed to take the exam again !");
      return;
    }
    if (_self.examHistoryCounter >= $scope.retries && $scope.retries != 0) {
      //CommonService.showInfo(_self.REASON);
      _self.description = $filter('trans')({
        eng: 'Sorry,you can not take the test again because you can only take a limited number of times!',
        chn: '很抱歉，您不能进行答题，因答题次数已到达限制!'
      });
      CommonService.showInfo(_self.description);
      return;
    }

    var url = "formalphoto/"+userId+"/";
    console.log(url);
    _self.imageFile=""
    if ($window.cordova) {
      CommonService.attachmentUpload(url,fileflag,function(res) {
        console.log(res);
        _self.imageFile = res.result;
        //if(_self.imageFile){
          $localstorage.set('imageFileExam',_self.imageFile);
          $state.go('app.formal.test', {
            id: _self.eid,
            type: _type,
            path:'list'
          });
        //}
      })
    }
    else {
      _self.imageFile = "formalphoto/5d12f461fe752c1f72694311/image_16944.jpg" //res.result;
      $localstorage.set('imageFileExams',_self.imageFile);
      $state.go('app.formal.test', {
        id: _self.eid,
        type: _type,
        path:'list'
      });
    }




    this.cancel = function() {
      _self.imageFile = "";
    }

    //CommonService.uploadFile(photoSetting).then(function(result) {
    //  console.log(result);
    //  //$localStorage.lastUserPhoto = result.fileName;
    //  //$localStorage.lastUserPhotoTime = new Date();
    //$state.go('app.formal.test', {
    //  id: _self.eid,
    //  type: _type,
    //  path:'list'
    //});
    //});
  };
  //$scope.$on('$ionicView.afterLeave', function() {
  //  //console.log(1111)
  //  _self.imageFile = "";
  //})
  //$ionicView.
});
