angular.module('bamboo').controller('DiscoverCtrl', function($state, $timeout, $scope, CommonService, loginService, $localstorage, ApiService, AppConfig) {
  var self = this;

  if(loginService)
  {
    self.subDomain = loginService.subDomain;
  }

  console.log(AppConfig.Role);
  if (AppConfig.Role === 'student') {
    self.hideCourseForum = true;
  }
  ApiService.getSchoolInfo().then(function() {
    loginService.getLoginInfo().then(function(user) {
      if (!user) {
        return;
      }
      var info = {
        action: "getmobilecounters"
      };
      ApiService.post("/site", info).then(function(result) {
        // console.log(result);
        if (result.data.success) {
          var _result = result.data.data;
          console.log(_result);
          self.newcourses = _result.newcourses;
          self.unreadmsgs = _result.unreadmsgs;
          self.mycourses = _result.mycourses;
          self.events = _result.events;
          self.newannoucements = _result.newannoucements;
        } else {
          CommonService.showError(result.data.error);
        }
      });
    });
  });
});