angular.module('bamboo').controller('HomeCtrl', function($state, $cordovaBadge, $window, $timeout, $scope, AppConfig, loginService, CommonService, $localstorage, ApiService, $cordovaDevice, $cordovaGeolocation, $ionicPlatform, $rootScope, newsTabService) {
  var self = this;
  this.news = []
  this.discovercounter = 0;
  this.mobileadvs = [];
  this.subdomain = $localstorage.get('subdomain');
  this.username = $localstorage.get('username');
  this.password = $localstorage.get('password');
  this.firsttime = $localstorage.get('firsttime');
  $scope.heightScroll = $window.innerHeight - 44 + 'px';
  $scope.heightBanner = $window.innerWidth / 5 * 2 + 'px';
  console.log($scope.heightBanner);
  this.defaultadvs = ["img/slide1.jpg"];
  this.coursePhotoUrl = ApiService.SHOST + '/lcourse/';
  this.defaultpic = ApiService.SHOST + '/public/images/videos.png';
  console.log("-- home controller ---");
  console.log(loginService);
  this.page = 'standard';
  console.log(this.username, this.password);
  this.tologin = function() {
    $state.go('app.config.login');
  }
  var lastCheck;
  $scope.$on('$ionicView.enter', function() {
    self.tab = newsTabService.newsTab || 0
    console.log("enter event");
    ApiService.getSchoolInfo(self.subdomain).then(function(school) {
      self.getHomeNews();
      if (ApiService.school.newsphoto) {
        self.defaultNewsPhoto = ApiService.SHOST + "/site/" + ApiService.school.newsphoto;
      }
      $scope.currentSchool = ApiService.school;
      console.log(ApiService.school)
      self.iconurl = ApiService.SHOST + "/site/";
      if (ApiService.school.mobileadvs && ApiService.school.mobileadvs.length > 0) {
        self.mobileadvs = ApiService.school.mobileadvs;
      }
      if (window.cordova) {
        var _platform = $cordovaDevice.platform;
        var android = false;
        if (_platform && _platform.indexOf('Android') > -1) {
          android = true;
          window.screen.orientation.lock('portrait');
        }
        console.log('cordov ready!');
        cordova.getAppVersion.getVersionNumber().then(function(version) {
          console.log("--- version ", version,school.eduAppVers);
          $localstorage.set('appversion', version);
          if (school.eduAppVers) {
            if (android) {
              if (school.eduAppVers.androidMustVer) {
                var result = ApiService.compareVersion(school.eduAppVers.androidMustVer, version);
                console.log(result);
                if (result) {
                  $timeout(function() {
                    CommonService.showInfo('请下载最新版本，才能继续使用相关功能！', function() {
                      $state.go('app.config.download');
                    });
                  }, 1000)
                }
              }
            } else {
              // ios or simulator
              if (school.eduAppVers.iosMustVer) {
                var result = ApiService.compareVersion(school.eduAppVers.iosMustVer, version);
                if (result) {
                  $timeout(function() {
                    CommonService.showInfo('请下载最新版本，才能继续使用相关功能！', function() {
                      $state.go('app.config.download');
                    });
                  }, 1000)
                }
              }
            }
          }
        });
      }else{
       // $localstorage.set('appversion', '1.1.15');
      }
    });
    // if (window.cordova) {
    //   CommonService.startRequestGPS();
    // }
    loginService.getLoginInfo().then(function(user) {
      console.log(user)
      if (!user) {
        console.log('Not login user');
        //$state.go('app.config.login');
        self.needlogin = true;
        return;
      }
      self.needlogin = false;
      var time = new Date();
      if (!lastCheck || (time - lastCheck) > (1000 * 60 * 5)) {
        console.log('longer than 5 minutes, check the counter again!');
        lastCheck = time;
        // getmobilecounter();
      }
    });
  })
  this.gotoState = function(state) {
    if (self.needlogin) {
      CommonService.showInfo('在开始使用本应用前，请先登录，谢谢', function() {
        $state.go('app.config.login');
      })
    } else {
      $state.go(state);
    }
  }
  
  this.changeTab = function(tab) {
    self.tab = newsTabService.newsTab = tab;
  }
  // 获取列表
  this.newspath = ApiService.SHOST + '/public/' + ApiService.RES + '/schoolnews/';
  this.consultation = [];
  this.guides = [];
  this.regulars = []
  this.tab = 0;
  this.getHomeNews = function() {
    var info = {
      action: 'getTopCatNews',
    }
    ApiService.post('/setting', info).then(function(result) {
      console.log(result);
      var data = result.data.data;
      var news = [];
      angular.forEach(data, function(value, key) {
        var obj = {}
        obj.title = key;
        obj.list = value || [];
        news.push(obj)
      });
      self.news = news;
      $scope.$broadcast('scroll.refreshComplete');
      // console.log(news);
      // handleFavorate();
    });
  }
  this.searchByName = function() {
    $state.go('app.search');
  }
}).service('newsTabService', function() {
  this.newsTab;
});
