angular.module('bamboo.job').controller('JobCategoryCtrl', function($scope, ApiService,  $state) {
  var self = this;
  this.category;
  ApiService.getSchoolInfo().then(function(school) {
    console.log(school);
    if (school.jobCategoryDoc) {
       ApiService.get('/schooldoc/' + school.jobCategoryDoc).then(function(result) {
        console.log(result);
        if (result.data.success) {
          var content = result.data.data.content || {};
          self.category = content;
          var catList = [];
          getArray(self.category, catList, 0, '');
          $scope.catitems = catList;
          getlateststatus();
        }
      });
    }
  });

  this.OpenUp = function(item) {
    item.shown = !item.shown;
    console.log(item);
  }
  
  function getArray(obj, array, level, parent) {
    if ((typeof obj) === "object") {
      for (var key in obj) {
        var fullkey;
        if (parent == '') {
          fullkey = key;
        } else {
          fullkey = parent + "," + key;
        }
        var _i = {
          key: fullkey,
          value: level,
          title: key,
          items: [],
        };
        array.push(_i);
        var info = obj[key];
        if (typeof info === "object") {
          getArray(info, _i.items, level + 1, fullkey);
        }
      }
    }
  }

  function getlateststatus() {
    var info={
      action:"getCategoryNumber",
    }
    console.log(info);
    ApiService.post("/job", info).then(function(result) {
      console.log(result);
      if (result.data.success) {
        console.log(result.data);
        var _totalCoursesCountUnderCat = 0;
        for (var i = 0; i < $scope.catitems.length; i++) {
          var catitem = $scope.catitems[i];
          var key = catitem.key;
          if (result.data.data[key]) {
            catitem.counter = result.data.data[key];
          }
        }
      }
    });
  }

  this.list=function(key){
    console.log(key);
    $state.go("app.job",{cat:key});
  }
});