'use strict';
angular.module('bamboo').controller('LoginCtrl', function($scope, $rootScope, $state, deviceDetector, $stateParams, $translate, loginService, ApiService, CommonService, AppConfig, $modal, $filter) {
  var _self = this;
  console.log('-- login controller --');


  this.loginService = loginService;
  $scope.login = {
    domain: loginService.subDomain
  };

  this.logoUrl = 'assets/images/bamboo_logo.png';
  this.companyName = 'Bamboosys System Technology';
  this.companyDescription = '';


  $scope.loginMe = function() {
    // setup promise, and 'working' flag
    $scope.login.domain = loginService.subDomain;
    $scope.login.ownername = loginService.school.name;
    console.log(_self.subdomain)
    ApiService.getSchoolInfo(_self.subdomain.toLowerCase()).then(function(school) {
      CommonService.stopLoading();
      console.log($scope.login);
      $scope.login.url = ApiService.HOST + "#/active_account";
      loginService.login($scope.login).then(function(user) {
        if (!user) {
          CommonService.showError($translate.instant(AppConfig.LOGINERROR));
        }
      }, function(reason) {
        if (reason.data.errorcode && reason.data.errorcode == 1001) {
          CommonService.showError('账户未激活，请重新注册!');
        }
        CommonService.showError(reason);
      });
    }, function(err) {
      // CommonService.stopLoading();
      console.log(err);
      CommonService.showError("获取学校gid失败");
    });
  };
  $scope.logoutMe = function() {
    loginService.logout();
  };
});
