// Ionic Starter App
// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('bamboo.material', ['ionic']).config(function($stateProvider, $urlRouterProvider) {
  $stateProvider.state('app.material', {
    url: '/material/:cat',
    views: {
      'Content@app': {
        templateUrl: 'app/material/list.html',
        controller: "MaterialListCtrl as ctrl",
      }
    },
  }).state('app.material.category', {
    url: '/category',
    views: {
      'Content@app': {
        templateUrl: 'app/material/category.html',
        controller: 'MaterialCategoryCtrl as ctrl'
      }
    },
  }).state('app.material.info', {
    url: '/info/:id',
    views: {
      'Content@app': {
        templateUrl: 'app/material/info.html',
        controller: 'MaterialInfoCtrl as ctrl'
      }
    },
  }).state('app.material.detail', {
    url: '/detail/:id',
    views: {
      'Content@app': {
        templateUrl: 'app/material/detail.html',
        controller:'MaterialDetailCtrl as ctrl',
      }
    },
  })
});