angular.module('bamboo.myspace').controller('MySpaceCtrl', function($scope, ApiService, $localstorage, CommonService, MystudyService, $cordovaDevice, loginService, CourseService, $filter, $state) {
  var _self = this;
  var lastCheck;
  this.subdomain = $localstorage.get('subdomain');
  this.imgPath = ApiService.PSURL + "/avatar/";
  console.log(loginService);
  _self.subDomain = loginService.subDomain;
  if (loginService.school&&loginService.school.jobFlag) {
    this.myjob = true;
  }
  $scope.$on('$ionicView.enter', function() {
    console.log("enter event");
    if (window.cordova) {
      var _platform = $cordovaDevice.platform;
      if (_platform && _platform.indexOf('Android') > -1) {
        window.screen.orientation.lock('portrait');
      }
    }
    loginService.getLoginInfo().then(function(user) {
      if (!user) {
        console.log('Not login user');
        $state.go('app.config.login');
        _self.needlogin = true;
        return;
      }
      _self.needlogin = false;
      var time=new Date();
      if(!lastCheck||(time-lastCheck)>(1000*60*5)){
        console.log('My Space check, timeout!');
        lastCheck=time;
        getMySpaceInfo();
      }
    });
    ApiService.get('/profile/').then(function(result) {
      console.log(result);
      if (result.data.success) {
        _self.userDetails = JSON.parse(JSON.stringify(result.data.data));
        console.log(_self.userDetails);
      }
    });

  })

  function getMySpaceInfo() {
    var info = {
      action: "getmyspacecounter"
    };
    console.log(info);
    ApiService.post('/user', info).then(function(result) {
       console.log(result);
      if (result.data.success) {
        console.log(result.data.data);
        _self.courseCount = result.data.data.courses;
        _self.unreadmsgs = result.data.data.unreadmsgs;
        _self.noteCount = result.data.data.notes;
        _self.eventCount = result.data.data.events;
        _self.assignmentCount = result.data.data.assignments;
        _self.examCount = result.data.data.exams;
        _self.testCount = result.data.data.tests;
        _self.bbsCount = result.data.data.bbss;
        _self.blogCount = result.data.data.blogs;
        _self.classCount = result.data.data.classes;
        _self.topicsCount= result.data.data.topics;
      } else {
        CommonService.showError(result.data.error);
      }
    });
  }

});