/**
 * Created by root on 11/6/2019.
 */
angular.module('bamboo.formal').controller('TransactionsCtrl', function($scope, loginService,  CommonService, ApiService) {
  var self = this;
  this.itemNumber = 10;
  this.school = loginService.school;
  this.icon = 'assets/images/school_logo.jpg';
  this.companyname = 'Bamboo Learning';
  var loadMoreIncrements = 10;
  var start = 0;
  var limit = 8;
  this.moreDataCanBeLoaded = false;
  this.displayedItems = [];
  self.bookType={
    courses:'在线课程',
    courseWithBook:'带书课程',
  }

  this.getitems = function() {
    loadRecords({
      start: 0,
      limit: 8,
    })
  }

  self.getitems();

  function loadRecords(info) {
    info.action = 'getmytransactions';
    info.search = '';

    ApiService.post("/transaction", info).then(function(result) {

      var itemCount = 0

      if (result.data.success) {
        itemCount = self.displayedItems.length
        if(itemCount > 0) {
          //Append to existing data
          self.displayedItems.concat(result.data.data.items)
        } else {
          self.displayedItems = result.data.data.items;
        }
        $scope.$broadcast('scroll.infiniteScrollComplete');
        console.log(self.displayedItems);
        // angular.forEach(self.displayedItems, function(student, key) {
        //     //  console.log(student);
        //     student.avatar_url = CommonService.getAvatarSrc(student.user);
        // });
        self.total = result.data.data.counter;
      // tableState.pagination.numberOfPages = Math.ceil(result.data.data.counter / 8);
        self.moreDataCanBeLoaded = self.total > itemCount ? true :  false;
      }
    });
  }

  self.loadMore = function() {
    start = limit;
    limit = limit + loadMoreIncrements;

    loadRecords({
      start: start,
      limit: limit,
    })
  };
});
