// Ionic Starter App
// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('bamboo.news', ['ionic']).config(function($stateProvider, $urlRouterProvider) {
  $stateProvider.state('app.news', {
    url: '/news/:category',
    views: {
      'Content@app': {
        templateUrl: 'app/news/news.html',
        controller: "NewsListCtrl as ctrl"
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.news.detail', {
    url: '/detail/:id',
    views: {
      'Content@app': {
        templateUrl: 'app/news/detail.html',
        controller: "NewsDetailCtrl as ctrl"
      }
    }
  })
});
