angular.module('bamboo.product').controller('ProductCategoryCtrl', function($scope, ApiService, CommonService) {
  var _self = this;
  this.categorylist = [];
  console.log("---- ProductCategoryCtrl -----");

  function getInfo() {
    var info = {
      action: "getproductcategoryinfo"
    };
    CommonService.showLoading();
    ApiService.post("/business", info).then(function(result) {
      //console.log(result);
      CommonService.stopLoading();
      if (result.data.success) {
        console.log(result.data.data);
        var _result = result.data.data;
        for (var key in _result) {
          var info = {
            key: key,
            counter: _result[key],
          }
          _self.categorylist.push(info);
        }
      }
      $scope.$broadcast('scroll.infiniteScrollComplete');
    });
  }
  getInfo();
});