angular.module('bamboo.myspace').controller('BuildingSessionRecords', function($scope, ApiService, loginService, $state, $stateParams, CommonService, $filter, utilService, $translate) {
  var _self = this;
  this.page = parseInt($stateParams.page) || 0;
  this.bid = $stateParams.bid
  this.pageSize = 4;
  _self.contentModelPicUrl = ApiService.SHOST + "/public/" + ApiService.RES + "/schoolevent/";
  this.moreData = false;
  this.items = [];
  this.itemlist = [];
  this.nextPage = function() {
    _self.page++;
    getInfo(_self.page);
    console.log("--- next page --");
  };
  $scope.$on('$ionicView.enter', function() {
    console.log(1111)
    getInfo(_self.page);
  })
  this.enroll = function(item) {
    CommonService.recordsdetail = item;
    $state.go(".detail", {rid: item._id})
  }

  function getInfo(page) {
    var info = {
      start: page * 8,
      limit: 8,
      action: "getAccessBuildingSessionRecords",
      bid: _self.bid
    }
    console.log(info);
    CommonService.showLoading();
    ApiService.post("/session", info).then(function(result) {
      CommonService.stopLoading();
      if (result.data.success) {
        if (!_self.items) {
          _self.items = [];
        }
        console.log(result.data);
        if (result.data.data&&result.data.data.items) {
          _self.items = _self.items.concat(result.data.data.items);
          var now = new Date();
          angular.forEach(_self.items, function(item, index, the) {
            if (item.registrationFlag) {
              if (item.registrationEnd) {
                var end = new Date(item.registrationEnd);
                if (end > now) {
                  item.enroll = true;
                }
              } else {
                item.enroll = true;
              }
            }
            var startDate = $filter('date')(item.start, "yyyy/MM/d");
          });
          _self.totalCount = result.data.data.counter;
          _self.moreData = ((_self.totalCount - _self.items.length) > 0);
          console.log(_self.totalCount, _self.items.length, _self.moreData);
        }
      }
      $scope.$broadcast('scroll.infiniteScrollComplete');
    });
  }
  utilService.watchScroll($scope);
});