angular.module('bamboo.myspace').controller('BuildingsController', function($scope, ApiService, loginService, $state, $cordovaGeolocation, CommonService, $filter, utilService, $translate) {
  var _self = this;
 // this.page = parseInt($stateParams.page) || 0;
 // this.lid = $stateParams.lid
  this.pageSize = 4;
  var pathurl = ApiService.SHOST + "/schoolbuilding/null/";
  this.moreData = false;
  this.isshow = false;
  this.items = [];
  this.itemlist = [];
  this.page=0;
  this.nextPage = function() {
    _self.page++;
    getInfo(_self.page);
    console.log("--- next page --");
  };
 // getInfo(0);
  console.log(22222)

  function getLocationInfo() {
    CommonService.showLoading();
    var posOptions = {
      timeout: 1000,
      enableHighAccuracy: false,
      maximumAge: 30000
    };
    $cordovaGeolocation.getCurrentPosition(posOptions).then(function(position) {
      console.log(position);
      _self.position = position.coords;
      CommonService.stopLoading();
      getInfo(0);
    }, function(err) {
      CommonService.stopLoading();
      console.log(err);
      if (err && err.code == 3) {

       // getLocationInfo();
      } else {
        CommonService.showError("Location error! " + err);
      }
      // 测试
      console.log(111111)
      _self.position = {
        longitude: 36.2144940000,
        latitude: 120.5933550000
      }
      getInfo(0);
    });
  }
  getLocationInfo();
  this.refresh = function() {
    _self.items = [];
    _self.page=0;
    getInfo(0);
  }
  function getInfo(page) {
    var info = {
      start: page * 6,
      limit: 6,
      action: "getValidBuildings",
     // lid: _self.lid
    }
    if(searchNames&&searchNames.length){
      info.search={
        name:searchNames,
      }
    }
    console.log(info);
    CommonService.showLoading();
    ApiService.post("/building", info).then(function(result) {
      _self.isshow=true;
      CommonService.stopLoading();
      if (result.data.success) {
        if (!_self.items) {
          _self.items = [];
        }
        console.log(result.data.data.items);
        if (result.data.data.items.length>0) {
          var now = new Date();
          angular.forEach(result.data.data.items, function(item, index) {
            console.log(item);
            if(item.photo){
              item.photourl=pathurl+item.photo;
            }
            if(item.lat){
              item.dis=CommonService.getDistance(item.lat,item.lng,_self.position.latitude,_self.position.longitude)
            }
          });

          _self.totalCount = result.data.data.counter;
          if(_self.totalCount>6){
            _self.items = _self.items.concat(result.data.data.items);
          }else{
            _self.items =result.data.data.items;
          }
          //_self.moreData = ((_self.totalCount - _self.items.length) >= 0);
          //if(page*6>_self.totalCount){
          //  _self.moreData=false;
          //}
          console.log(_self.totalCount, _self.items.length, _self.moreData,_self.page);
        }
      }
      $scope.$broadcast('scroll.infiniteScrollComplete');
      $scope.$broadcast('scroll.refreshComplete');
    });
  }
  utilService.watchScroll($scope);
  var searchNames;

  this.searchByName=function(name){
    searchNames=name;
    _self.items=[];
    getInfo(0);
  }
});