angular.module('bamboo.roomsession').controller('MyLatestSessionAppsCtrl', function ($scope, $filter, ApiService, CommonService, $rootScope, $state, loginService, $translate, $cordovaGeolocation, $timeout) {
  /////////
  //  签中拍照暂时不要
  ////////
  var self = this;
  this.signType = 0; //签到0 签中1 签退2
  this.distanceRule = loginService.school.sessionAccessRules;
  this.timeRule = loginService.school.sessionAccessRules||{};
  $scope.isShow = false;
  $scope.$on("$ionicView.enter", function (scopes, states) {
    self.signtime = $filter("date")(new Date(), "hh:mm");
  });
  ApiService.country = 'China';

  function addBuildingAddress() {
    if (ApiService.country == 'China') {
      console.log("---- China");
      if (!self.map) {
        return $timeout(addBuildingAddress, 100);
      }
      var names = [];
      var pointArr = [];
      if (self.signType == 0) {
        angular.forEach(self.sessions, function (session) {
          if (session.record == undefined) {
            return;
          } else {
            var ggPoint = new BMap.Point(session.record.building.lng, session.record.building.lat);
            pointArr.push(ggPoint);
            self.building = session.record.building;
            names.push(session.session.name);
          }
        });
      } else {
        console.log(self.sessions);
        angular.forEach(self.sessions, function (session) {
          var ggPoint = new BMap.Point(session.building.lng, session.building.lat);
          pointArr.push(ggPoint);
          self.building = session.building;
          names.push(session.session.name)
        });
      }
      if (!self.building) {
        return;
      }
      var marker = {
        longitude: self.building.lng,
        latitude: self.building.lat,
        icon: 'images/mappiont.png',
        width: 45,
        height: 45,
        title: self.building.name,
      }
      self.mapOptions.markers.push(marker);
      console.log(self.building);
      // self.dis = CommonService.getDistance(self.building.lat, self.building.lng, self.position.latitude, self.position.longitude);
      // console.log(self.dis)
      console.log(self.position, self.position.longitude, self.position.latitude);
      var pointArr = [];
      var ggPoint = new BMap.Point(self.position.longitude, self.position.latitude);
      pointArr.push(ggPoint);
      var convertor = new BMap.Convertor();
      convertor.translate(pointArr, 1, 5, function (data) {
        console.log(data);
        if (data.status === 0) {
          console.log(data);
          var myIcon = new BMap.Icon("assets/education/images/human.png", new BMap.Size(45, 45));
          var point = new BMap.Point(data.points[0].lng, data.points[0].lat);
          self.convertedPosition = {
            longitude: data.points[0].lng,
            latitude: data.points[0].lat,
          }
          var marker2 = new BMap.Marker(point, {
            icon: myIcon
          }); // 创建标注
          self.map.addOverlay(marker2);
          var buildingpoint = new BMap.Point(self.building.lng, self.building.lat);
          $timeout(function () {
            self.dis = self.map.getDistance(buildingpoint, point) / 1000;
            console.log('---- distance ---', self.dis);
            var item = self.sessions[0]; //  sessions列表中只有一条符合记录的数据，所以这么取是可以的。
            console.log(self.signType)
            // 判断距离   --签到
            if (self.signType == 0) {
              if (!(self.position.latitude && self.position.longitude && self.building.lat && self.building.lng)) {
                //CommonService.showInfo("地理位置不合理");
                $scope.message = "地理位置不合理";
                $scope.isShow = false;
                return;
              }
              // self.dis = CommonService.getDistance(item.record.building.lat, item.record.building.lng, self.position.latitude, self.position.longitude);
              if (self.dis * 1000 > self.distanceRule.distance) {
                //CommonService.showInfo("您未到允许签到的距离范围");
                $scope.message = "您未到允许签到的距离范围";
                $scope.isShow = false;
                return;
              }
              var time1 = new Date(item.time);
              var time2 = new Date(item.time);
              time1.setMinutes(time1.getMinutes() - self.timeRule.joinEarly||0);
              time2.setMinutes(time2.getMinutes() + self.timeRule.joinLate||0);
              var time3 = new Date().getTime()
              if (time3 > time2.getTime()) {
                //CommonService.showInfo("签到时间已过，请预约新的课程");
                $scope.message = "签到时间已过，请预约新的课程";
                $scope.isShow = false;
                return;
              }
              if (time3 < time1.getTime()) {
                //CommonService.showInfo("签到时间未到，请等候");
                $scope.message = "签到时间未到，请等候";
                $scope.isShow = false;
                return;
              }
              $scope.message = "请签到!";
              $scope.isShow = true;
            } else if (self.signType == 2) {
              if (!(self.position.latitude && self.position.longitude && self.building.lat && self.building.lng)) {
                //CommonService.showInfo("地理位置不合理");
                $scope.message = "地理位置不合理";
                $scope.isShow = false;
                return;
              }
              // var dis = CommonService.getDistance(item.building.lat, item.building.lng, self.position.latitude, self.position.longitude);
              if (self.dis * 1000 > self.distanceRule.distance) {
                //CommonService.showInfo("您未到允许签退的距离范围");
                $scope.message = "您未到允许签退的距离范围";
                $scope.isShow = false;
                return;
              }
              var time3T = new Date(item.record.time); //  这里应该是time+ length(课时长度)
              var time4T = new Date(item.record.time);
              time3 = time3T.getTime() + ((item.record.length || 60) - (self.timeRule.earlyExit || 0)) * 60 * 1000;
              var time4 = time4T.getTime() + ((item.record.length || 60) + (self.timeRule.earlyExit || 0)) * 60 * 1000;
              var time5 = new Date().getTime()
              if (time5 < time3) {
                //CommonService.showInfo("签退时间未到，请等候");
                $scope.message = "签退时间未到，请等候";
                $scope.isShow = false;
                return;
              }
              if (time5 > time4) {
                //CommonService.showInfo("签退时间已过");
                $scope.message = "签退时间已过";
                $scope.isShow = false;
                return;
              }
              $scope.message = "请签退!";
              $scope.isShow = true;
            }
          }, 100);


        }
      });
    } else {
      angular.forEach(self.sessions, function (session, index) {
        var marker = {
          longitude: session.record.building.lng,
          latitude: session.record.building.lat,
          icon: 'images/mappiont.png',
          width: 45,
          height: 45,
          title: session.session.name,
        }
        self.building = session.record.building;
        // self.building.lng = session.record.building.lng;
        // self.building.lat = session.record.building.lat;
        self.mapOptions.markers.push(marker);
      });
      console.log(self.mapOptions.markers);
    }
  }

  getLocationInfo();
  function getAccessRecords() {
    var info = {
      action: 'getMyLatestApplications'
    };
    console.log(info);
    ApiService.post('/session', info).then(function (result) {
      console.log(result);
      if (result.data.success && result.data.data.length > 0) { // 判断签入的数据是否准确
        self.sessions = getSignInSessions(result.data.data);
        console.log(self.sessions)
        if (!self.sessions || self.sessions.length == 0) {
          //getOutAccessRecords();
           $scope.message = "没有可以签到签退的记录!";
        } else {
          self.signType = 0;
          self.title = "签到";
          $scope.message = "";
          addBuildingAddress();
        }
      } else {
         $scope.message = "没有可以签到签退的记录!";
        // 获取签出的记录
        //getOutAccessRecords();
      }
    });
  }

  function getSignInSessions(data) {
    var session = "";
    data.sort(function (a, b) { // 按时间排序
      return new Date(a.time) - new Date(b.time)
    })
    var time2 = "";
    for (var i = 0; i < data.length; i++) {
      var item = data[i];
      console.log(item)
      time2 = new Date(item.time);
     // time2.setMinutes(time2.getMinutes() + self.timeRule.joinLate);
      var addSeconds=(self.timeRule.joinLate||0)*60000;
      var seconds=time2.getTime()+addSeconds;
      console.log(time2,new Date(),self.timeRule.joinLate);
      console.log(new Date().getTime())
      if (seconds > new Date().getTime()) { // 找到最近的且当前没有错过签入时间的那条记录。
        session = item;
        break;
      }
    }
    console.log(session)
    if (session) {
      return [session];
    } else {
      return []
    }
  }

  function getOutAccessRecords() {
    var info = {
      action: 'getUserAllOpenAccessRecords'
    };
    console.log(info);
    ApiService.post('/session', info).then(function (result) {
      console.log(result);
      if (result.data.success) {
        console.log(result.data.data)
        if (result.data.data.length > 0) { //  签中的记录就取第一条
          self.sessions = getSignOutSessions(result.data.data);
          if(self.sessions.length){
            self.signType = 2; // 签退
            self.title = "签退"
            $scope.message = "请签退!";
            console.log(self.sessions);
            addBuildingAddress();
          }else{
            console.log("--get to login ---");
            getAccessRecords();
          }
        }else{
          getAccessRecords();
        }
        console.log(self.sessions);
       
        
      } else {
        CommonService.showError(result.data.error || result.data.info);
      }
    });
  }

  function getSignOutSessions(data) {
    var session = "";
    data.sort(function (a, b) { // 按时间排序
      return new Date(a.join) - new Date(b.join)
    })
    var time2 = ""
    for (var i = 0; i < data.length; i++) {
      var item = data[i]
      time2 = new Date(item.record.time); //  这里time应该是jointime + len (课程长度)
      console.log(time2,item.record.length);
      var addSeconds=(item.record.length + self.timeRule.lateExit)*60000;
      var temp=time2.getTime()+addSeconds;
     // time2.setMinutes(time2.getMinutes() + item.record.length + self.timeRule.lateExit);
      if (temp > new Date().getTime()) { // 找到最近的且当前没有错过签入时间的那条记录。
        session = item;
        break;
      }
    }
    if (session) {
      return [session];
    } else {
      return []
    }
  }

  // console.log(loginService.user)
  this.exit = function (item) {
    console.log(item);
    if (item) {
      self.item = item;
    }
  }
  //mapLoaded()
  this.mapLoaded = function (map) {
    console.log("-- loaded");
    self.map = map;
    if (ApiService.country == 'China') {
    } else {
      var myIcon = new BMap.Icon("assets/education/images/human.png", new BMap.Size(60, 60));
      var point = new BMap.Point(self.position.longitude, self.position.latitude);
      var marker2 = new BMap.Marker(point, {
        icon: myIcon
      }); // 创建标注
      map.addOverlay(marker2);
    }
  }
  this.position = {};

  function getLocationInfo() {
    CommonService.showLoading();
    var posOptions = {
      timeout: 5000,
      enableHighAccuracy: false,
    //  maximumAge: 30000
    };
    $cordovaGeolocation.getCurrentPosition(posOptions).then(function (position) {
      console.log(position);

      self.position = position.coords;
      CommonService.stopLoading();
      self.mapOptions = {
        center: {
          longitude: position.coords.longitude,
          latitude: position.coords.latitude,
        },
        zoom: 15,
        city: 'GuangZhou',
        markers: [],
      };
      getOutAccessRecords()
      //getAccessRecords();
    }, function (err) {
      CommonService.stopLoading();
      if (window.cordova) {
        console.log("load gps error", err);
        //CommonService.stopLoading();
        console.log(err);
        if (err && err.code == 3) {
          getLocationInfo();
        } else {
          CommonService.showError("Location error! " + err);
        }
      } else {
        self.position = {
          //longitude: '120.404658',
          //latitude: '36.072606'
          longitude: '120.673278',
          latitude: '36.345786'
        }
        // self.position = position.coords;
        // CommonService.stopLoading();
        self.mapOptions = {
          center: {
            // longitude: position.coords.longitude,
            // latitude: position.coords.latitude,
            //longitude: '120.404658',
            //latitude: '36.072606'
            longitude: '120.673278',
            latitude: '36.345786'
          },
          zoom: 15,
          city: 'GuangZhou',
          markers: [],
        };
        getOutAccessRecords()
        //getAccessRecords();
      }
    });
  }

  //getLocationInfo();
  this.register = function (item) {
    var item = self.sessions[0]; //  sessions列表中只有一条符合记录的数据，所以这么取是可以的。
    //console.log(self.signType)
    //// 判断距离   --签到
    //if (self.signType == 0) {
    //    if (!(self.position.latitude && self.position.longitude && self.building.lat && self.building.lng)) {
    //        CommonService.showInfo("地理位置不合理");
    //        $scope.isShow = false;
    //        return;
    //    }
    //    // self.dis = CommonService.getDistance(item.record.building.lat, item.record.building.lng, self.position.latitude, self.position.longitude);
    //    if (self.dis * 1000 > self.distanceRule.distance) {
    //        CommonService.showInfo("您未到允许签到的距离范围");
    //        $scope.isShow = false;
    //        return;
    //    }
    //    var time1 = new Date(item.time);
    //    var time2 = new Date(item.time);
    //    time1.setMinutes(time1.getMinutes() - self.timeRule.joinEarly);
    //    time2.setMinutes(time2.getMinutes() + self.timeRule.joinLate);
    //    var time3 = new Date().getTime()
    //    if (time3 > time2.getTime()) {
    //        CommonService.showInfo("签到时间已过，请预约新的课程");
    //        return;
    //    }
    //    if (time3 < time1.getTime()) {
    //        CommonService.showInfo("签到时间未到，请等候");
    //        return;
    //    }
    //} else if (self.signType == 2) {
    //    if (!(self.position.latitude && self.position.longitude && self.building.lat && self.building.lng)) {
    //        CommonService.showInfo("地理位置不合理");
    //        return;
    //    }
    //    // var dis = CommonService.getDistance(item.building.lat, item.building.lng, self.position.latitude, self.position.longitude);
    //    if (self.dis * 1000 > self.distanceRule.distance) {
    //        CommonService.showInfo("您未到允许签退的距离范围");
    //        return;
    //    }
    //    var time3T = new Date(item.record.time); //  这里应该是time+ length(课时长度)
    //    var time4T = new Date(item.record.time);
    //    time3 = time3T.getTime() + ((item.record.length || 60) - (self.timeRule.earlyExit || 0)) * 60 * 1000;
    //    time4 = time4T.getTime() + ((item.record.length || 60) + (self.timeRule.earlyExit || 0)) * 60 * 1000;
    //    var time5 = new Date().getTime()
    //    if (time5 < time3) {
    //        CommonService.showInfo("签退时间未到，请等候");
    //        return;
    //    }
    //    if (time5 > time4) {
    //        CommonService.showInfo("签退时间已过");
    //        return;
    //    }
    //}

    // 先进行拍照
    var url = "/attendence/" + item.recordId + '/';
    CommonService.shotandUpload(url, '', function (url, filename) {
      if (filename) {
        CommonService.signphoto = filename;
        console.log(self.signType);
        if (self.signType == 0) { // 签到
          $state.go("app.qrcode.register", {
            sid: item.sessionId,
            rid: item.recordId,
            aid: item._id
          });
        } else { // 签退
          $state.go("app.exitqrcode.details", {
            sid: item.session._id,
            rid: item.recordId,
            aid: item._id,
            signType: self.signType
          });
        }
      }
    });
  }
});
