angular.module('bamboo.roomsession').controller('MyBookedSessionAppsCtrl', function($scope, ApiService, CommonService, $rootScope, $state, loginService, $translate, $cordovaGeolocation, $timeout) {
  var self = this;
  this.subtab = 0;
  this.applications = [];
  this.unusual = [];
  this.getMyApplications = function() {
    var info = {
      action: 'getMyApplications',
      limits: 8,
      start: 0
    };
    console.log(info);
    ApiService.post('/session', info).then(function(result) {
      //  console.log(result);
      if (result.data.success) {
        self.sessions = result.data.data.items;
        // addBuildingAddress();
        angular.forEach(self.sessions,function(item){
          if(item.record&&item.record.time){
            var start=(new Date(item.record.time)).getTime();
            var stop=new Date(start+(item.record.length||60)*60000);
            item.time=item.record.time;
            item.stop=stop;
          }
        })
        console.log(self.sessions);
      } else {
        CommonService.showError(result.data.error || result.data.info);
      }
    });
  }
  this.getMyApplications();
  
  this.getUnusual = function() {
    var info = {
      action: 'getMyBadApplications',
      limits: 8,
      start: 0
    };
    console.log(info);
    ApiService.post('/session', info).then(function(result) {
      //  console.log(result);
      if (result.data.success) {
        self.sessions = result.data.data;
        // addBuildingAddress();
        console.log(self.sessions);
      } else {
        CommonService.showError(result.data.error || result.data.info);
      }
    });
  }
});