angular.module('bamboo').service('examService', function(ApiService, $q) {
  var self = this;
  self.examApi = function(config) {
    return ApiService.post('/exam', config);
  }
  self.api = function(info, callback) {
    ApiService.post('/exam', info).then(function(result) {
      console.log(result);
      if (result.data.success) {
        if (!callback) {
          CommonService.showInfo('Update Successful!');
        } else {
          callback(result.data.data);
        }
      }
    });
  }
});