angular.module('bamboo.sharedrive').controller('DriveCateCtrl', function($scope, ApiService, $state, loginService) {
  var self = this;
  this.category;
  ApiService.getSchoolInfo().then(function() {
    if(ApiService.school&&ApiService.school.drivecategorydoc){
      ApiService.get('/schooldoc/' + ApiService.school.drivecategorydoc).then(function(result) {
        console.log(result);
        if (result.data.success) {
          self.category = result.data.data.content || {};
          var catList = [];
          getArray(self.category, catList, 0, '');
          $scope.catitems = catList;
        }
      });
    }
  });

  this.OpenUp = function(item) {
    item.shown = !item.shown;
    console.log(item);
  }

  function getArray(obj, array, level, parent) {
    if ((typeof obj) === "object") {
      for (var key in obj) {
        var fullkey;
        if (parent == '') {
          fullkey = key;
        } else {
          fullkey = parent + "," + key;
        }
        var _i = {
          key: fullkey,
          value: level,
          title: key,
          items: [],
        };
        array.push(_i);
        var info = obj[key];
        if (typeof info === "object") {
          getArray(info, _i.items, level + 1, fullkey);
        }
      }
    }
  }

  this.list=function(key){
    console.log(key);
    $state.go("app.sharedrive",{cat:key});
  }
});