'use strict';
angular.module('bamboo.survey').controller('surveyresultCtrl', function($scope, ApiService, $stateParams) {
  var self = this;
  self.id = $stateParams.id;
  self.resultFlag = true;
  var info = {
    action: 'getsurveyresult',
    id: self.id
  };
  ApiService.post('/survey', info).then(function(result) {
    console.log(result);
    if (result.data.success) {
      var _result = result.data.data;
      self.summary = _result;
      console.log(self.summary);
    }
  });

  function getRandomColorStr() {
    var color = Math.floor(Math.random() * 256).toString(10);
    color += ',';
    color += Math.floor(Math.random() * 256).toString(10);
    color += ',';
    color += Math.floor(Math.random() * 256).toString(10);
    return color;
  }
})
