angular.module('bamboo.teacher', ['ionic']).config(function($stateProvider, $urlRouterProvider) {
  $stateProvider.state('app.teacher', {
    url: '/teacher',
    views: {
      'Content@app': {
        // templateUrl: 'app/teacher/teacher.html',
        // controller: "taskHomeCtrl as ctrl",
      }
    },
    abstract: true
  }).state('app.teacher.course', {
    url: '/course',
    views: {
      'Content@app': {
        templateUrl: 'app/teacher/course/teacher_course_list.html',
        controller: "teacherCourseListCtrl as ctrl",
      }
    },
  }).state('app.teacher.record', {
    url: '/record',
    views: {
      'Content@app': {
        templateUrl: 'app/teacher/record/teacher_course_list.html',
        controller: "teacherCourseListCtrl as ctrl",
      }
    },
  }).state('app.teacher.record.list', {
    url: '/:lid/list',
    views: {
      'Content@app': {
        templateUrl: 'app/teacher/record/teacher_record_list.html',
        controller: "teacherRecordListCtrl as ctrl",
      }
    },
  }).state('app.teacher.assignment', {
    url: '/assignment',
    views: {
      'Content@app': {
        templateUrl: 'app/teacher/record/teacher_course_list.html',
        controller: "teacherCourseListCtrl as ctrl",
      }
    },
  }).state('app.teacher.assignment.list', {
    url: '/:lid/list',
    views: {
      'Content@app': {
        templateUrl: 'app/teacher/assignment/teacher_assignment_list.html',
        controller: "teacherCourseAssignmentListCtrl as ctrl",
        //templateUrl: 'app/myspace/myassignment.html',
        //controller: 'MyAssignmentCtrl as ctrl'
      }
    },
  }).state('app.teacher.assignment.list.record', {
    url: '/:aid/list',
    views: {
      'Content@app': {
        templateUrl: 'app/teacher/assignment/teacher_assignment_record.html',
        controller: "teacherAssignmentRecordListCtrl as ctrl",
        //templateUrl: 'app/myspace/myassignment.html',
        //controller: 'MyAssignmentCtrl as ctrl'
      }
    },
  }).state('app.teacher.class', {
    url: '/class',
    views: {
      'Content@app': {
        templateUrl: 'app/teacher/record/teacher_course_list.html',
        controller: "teacherCourseListCtrl as ctrl",
      }
    },
  }).state('app.teacher.class.list', {
    url: '/:lid/list',
    views: {
      'Content@app': {
        templateUrl: 'app/teacher/class/teacher_class_list.html',
        controller: "teacherClassListCtrl as ctrl",
      }
    },
  }).state('app.teacher.class.list.newslist', {
    url: '/:classid/newslist',
    views: {
      'Content@app': {
        templateUrl: 'app/class/class_news_list.html',
        controller: 'ClassNewsListCtrl as ctrl'
      }
    },
  }).state('app.teacher.class.list.gallerylist', {
    url: '/:classid/gallerylist',
    views: {
      'Content@app': {
        templateUrl: 'app/class/class_gallery_list.html',
        controller: 'ClassGalleryListCtrl as ctrl'
      }
    },
  }).state('app.teacher.class.list.gallerylist.gallery', {
    url: '/:id/gallery',
    views: {
      'Content@app': {
        templateUrl: 'app/class/class_gallery.html',
        controller: 'ClassGalleryCtrl as ctrl'
      }
    },
  }).state('app.teacher.class.list.students', {
    url: '/:classid/students',
    views: {
      'Content@app': {
        templateUrl: 'app/teacher/class/teacher_class_stu_list.html',
        controller: "teacherClassStuListCtrl as ctrl",
      }
    },
  }).state('app.teacher.exam', {
    url: '/exam',
    views: {
      'Content@app': {
        templateUrl: 'app/teacher/record/teacher_course_list.html',
        controller: "teacherCourseListCtrl as ctrl",
      }
    },
  }).state('app.teacher.exam.list', {
    url: '/:lid/list',
    views: {
      'Content@app': {
        templateUrl: 'app/task/examlist.html',
        controller: "taskExamListCtrl as ctrl",
      }
    },
  }).state('app.teacher.exam.list.records', {
    url: '/:examid/record',
    views: {
      'Content@app': {
        templateUrl: 'app/task/examrecords.html',
        controller: "teacherExamRecordListCtrl as ctrl",
      }
    },
  }).state('app.teacher.attendance', {
    url: '/attendance',
    views: {
      'Content@app': {
        templateUrl: 'app/teacher/attendance/teacher_course_attendance.html',
        controller: "teacherCourseAttendanceCtrl as ctrl",
      }
    },
  }).state('app.teacher.attendance.list', {
    url: '/list',
    views: {
      'Content@app': {
        // templateUrl: 'app/teacher/attendance/teacher_course_attendance.html',
        // controller: "teacherCourseAttendanceCtrl as ctrl",
        templateUrl: 'app/attendance/list.html',
        controller: "attendanceListCtrl as ctrl",
      }
    },
  })
});