angular.module('bamboo.usecase').controller('UsecaseListCtrl', function ($scope, loginService, $ionicModal, ApiService, $timeout, $state, CommonService, $ionicPopover, utilService) {
    var self = this;
    this.limit = 10;
    this.moreData = false;
    this.newses = [];
    this.mobileadvs = [];
    this.tab = 0;
    this.page=0;
    $scope.islagoin = false;
    $scope.isShow = false;
    this.defaultadvs = ["img/slide1.jpg", "img/slide2.jpg", "img/slide3.jpg"];
    var defaultUseCasePhoto = 'img/usecase.jpg';
    console.log(loginService.user);
    if (loginService.user) {
        $scope.islagoin = true;
    }
    var imgBaseUrl = ApiService.SHOST + '/advinfo/';
    this.getSiteCases = function (flag) {
        if (!flag) {
            self.limit = 10;
        }
        var info = {
            start: self.page*self.limit,
            limit: self.limit,
            type: 'school',
            action: "getEnableObjects"
        };
        CommonService.showLoading();
        ApiService.post('/advinfo', info).then(function (data) {
            console.log(data)
            CommonService.stopLoading();
            $scope.isShow = true;
            if (data.data.success) {
                var result = data.data.data;
                console.log(data);
                //self.newses = result.items;
                if(self.page==0){
                    self.newses=result.items;
                }else{
                    self.newses = self.newses.concat(result.items);
                }
                angular.forEach(self.newses, function (item) {
                    if (item.photo) {
                        item.picurl = imgBaseUrl + item.photo;
                    } else {
                        item.picurl = defaultUseCasePhoto;
                    }
                })
                $scope.count = result.counter;
                if (($scope.count - (self.page+1)*self.limit ) > 0) {
                    self.moreData = true;
                } else {
                    self.moreData = false;
                }
                //
                if(!self.moreData){
                  self.page=0;
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
                //AddUiSrefForList($scope.UseCaseList);
            }
        });
    };
    self.getSiteCases();
    this.getCompanyCases = function () {
        var info = {
            start: self.page*self.limit,
            limit: self.limit,
            action: "getCompanyEnableObjects"
        };
        CommonService.showLoading();
        ApiService.post('/advinfo', info).then(function (data) {
            console.log(data)
            CommonService.stopLoading();
            $scope.count = 0;
            self.newses = [];
            $scope.isShow = true;
            if (data.data.success && data.data.data) {
                var result = data.data.data;
                console.log(result);
                //self.newses = result.items;
                if(self.page==0){
                    self.newses=result.items;
                }else{
                    self.newses = self.newses.concat(result.items);
                }
                angular.forEach(self.newses, function (item) {
                    if (item.photo) {
                        item.picurl = imgBaseUrl + item.photo;
                    } else {
                        item.picurl = defaultUseCasePhoto;
                    }
                })
                $scope.count = result.counter;
                if (($scope.count - (self.page+1)*self.limit ) > 0) {
                    self.moreData = true;
                } else {
                    self.moreData = false;
                }
                //AddUiSrefForList($scope.UseCaseList);
                $scope.$broadcast('scroll.infiniteScrollComplete');
            }
        });
    };
    this.nextPage = function (val) {
        if (val) {
            //if ($scope.count - (self.limit + 10) > 0) {
            //    self.limit += 10;
            //} else {
            //    self.limit += $scope.count - self.limit;
            //}
            self.page++;
            if (self.tab == 0) {
                self.getSiteCases(true);
            } else {
                self.getCompanyCases(true);
            }
        }
    };
});
